VERSION HISTORY:
----------------
v0.34.10 (2012-01-23)
+ Bug: Shields and Spikes count for defensive BV
+ Bug: large shield with all crits destroyed still hindering movement
+ All Clan Mechs have Clan names again
+ use double buffering for swing UI (I don't even remember why I disabled it
    in the first place)
+ Bug 2928258: LRM 15 not loading from TDB .xml files
+ Bug 2930686: Plasma rifle vs. fire-resistant armor
+ Bug 2933643: Charge should damage first, displace later
+ Bug with coolant pods BV
+ Bug 3030702: report error with vibroclaws against infantry
+ Added spanish translation

v0.34.9 (2009-11-09, 19:32 UTC+1)
+ Bug 2585799: Pilot damage assigned to vehicle crew
+ Bug: NPE when DFAing a VTOL off the board
+ Bug: AC AP ammo still doing crits against partial cover
+ Fix potential report filtering issue
+ Bug 2871000: Chameleon LPS gives wrong mod at medium range when used with
   Null-Sig.
+ Bug 2874785: ATMs doing only 1 damage against infantry
+ Bug 2879004: NPE in deploymentdisplay
+ Bug 2881020: NPE when using searchlights
+ Bug: Artillery special graphic shown on location of firing unit, not on target hex
+ Bug 2881408: Bot trying DFA attacks with infantry units
+ Bug: Extended LRMs not properly added

v0.34.8 (2009-08-17, 15:23 UTC+2)
+ Bug: Mechdisplay not remembering which ammo was selected
+ Bug 2827537: edge and center deployment should be allowed even with exclusive
    DB deployment
+ Bug: Telemissiles had wrong movementtype
+ Bug: Telemissiles image in swing wrong
+ Bug 2832645: Forest absorbing swarmed infantry attack
+ Lots of new BA and ASF images (Thanks adgar76)
+ externalId saved to and loaded from MUL files
+ Bug 2836883: To-hit modifier for units on top of the same multi-hex building
+ Bug 2830760: Large VSP Laser and Aero damage
+ Bug 2792205: LRM Thunder minefiled delivery should get -4 mod for immobile
+ Bug: HVAC explosion should be treated like an ammo explosion

v0.34.7 (2009-07-24, 23:16 GMT+2)
+ Bug: Clan Laser AMS has wrong crits/tonnage
+ Some new or improved unit images (Thanks devil877 and BH21)
+ Bug: Some crits have no mounteds
+ Bug: next unit button not working correctly after a reset
+ Bug: BA AP Gauss Rifle not doing correct damage against Infantry
+ Bug: CASE in ASF prevents explosive equipment BV penalty
+ Bug: For Aeros Ultras should count as 2*heat and RACs at 6*heat for BV
+ Bug: Explosive Weapons not counted for DBV reduction for aeros
+ Lots of Aerospace Fighter files fixed
+ Bug: explosive weapons sometimes counting twice for DBV reduction
+ Bug 2826355: no high gravity PSR warning on jumps
+ Bug 2792093: ECCM not disrupting Stealth Armor

v0.34.6 (2009-07-09, 19:14 UTC+2)
+ Bug 2813397: Spikes
+ Bug 2813404: Implemented TacOps artillery scatter errata
+ Bug 2813314: Pulse Laser extreme range
+ Bug 2813374: Ice not working under classic/simplified tileset
+ Bug: Retractable blade sometimes overweight
+ Lots of Aerospace and Conventional Fighter Updates
+ Bug: Aero bays not loadable

v0.34.5 (2009-06-27, 20:37 UTC+2)
+ Patch 2806831: fix typo in MovePath
+ Bug 2808412: Firebee image misnamed
+ Bug: BA microbomb should have range 0
+ Ymir and Von Rohr images added (Thanks st0ny)
+ Bug: BA with vibroclaws not correctly identified as eligible for the physical
    attacks phase
+ Bug: Rubble should always cost +1 MP to enter
+ Bug: Fa Shih mines not working correctly
+ Bug: Aeros with MRM 40 not loading
+ Bug 2810084: Bot freezing
+ Bug 2809999: Light and Moderate Gale/Wind
+ Bug 2811958: Reckless (non-careful) movement producing too many PSRs

v0.34.4 (2009-06-18, 16 UTC+2)
+ Bug 2800635: BattleMech Talons not working correctly
+ lots of mechfile fixes
+ Fix Aero BV bug
+ Fix bug with unit list export
+ Bug: 3d interface not working
+ Bug: Protomech cost not including heatsinks
+ Bug: Protomech cost not including weapons and misc equipment
+ Bug 2805632: Infantry digging in in terrain where they shouldn't be able to
+ Bug 1967859: random army creator not working correctly with tanks
+ Bug 2805244: BA Vibro claws
+ Preferrably do not displace into friendly units when displacement should
    be chosen by controller of displaced unit

v0.34.3 (2009-06-03, 15:48 UTC+2)
+ Bug: aero BV explosive munition subtracting not working correctly
+ Updated mechfiles
+ Added image for Zeus X (thanks DarkISI)
+ Updated vehicle files
+ Updated conventional fighter files
+ Bug 2790142: Talons have wrong weight
+ Bug: Talons BV should be the extra damage they do in a kick attack
+ Prevent ConcurrentModificationExceptions in the server networking
+ Updated vehicles.zip
+ Images for TRO3075 units
+ Added Uziel Jacob and Uziel Jacob II
+ Bug: Chameleon Light Polarization Shield not working

v0.34.2 (2009-05-09, 18:02 UTC+2)
+ Bug: Ostwar 3M has wrong techlevel
+ Bug 2555773, Patch 2782679: Narc pods working for non-narc ammo
+ Patch 2782596: Infantry weapon cost missing
+ Bug 2780871: Kobold BA missing and wrong variants
+ Bug: HAG costs wrong
+ Bug: Void sig not correctly counted for BV purposes
+ Bug: Mech taser counting for -15 per crit for defensive BV, instead of -1
+ Bug: mouse clicks register at wrong location in swing BoardView
+ Bug: homing artillery hit side resolving from TAG location
+ Bug: prevent NPE in FiringDisplay
+ Bug 2786447: B-Pod bug
+ Bug 2785522: minor typo and small bug
+ Bug: LRM-delivered minefields should always have strength equal to the rack-
    size of the launcher
+ Bug: Torpedoes should not be available to MMLs
+ Bug 2787549: pilot damage avoidance rolls wrong
+ Bug 278587: Aft Weapons Bay Bug
+ Bug 2784920, Patch 2786448: firing leg-mounted weapons when hull down
+ Bug: camo choice not working correctly in swing for no camo
+ Bug: board selection dialog in swing not reacting to double click on board

v0.34.1 (2009-04-28, 15:16 UTC+2)
+ Patch 2782015, Bug 2777743: Enhanced ER PPC BV
+ Bug: mouse clicks register at wrong location in BoardView
+ Adjusted build.xml to get source from correct location

v0.34.0 STABLE (2009-04-27, 21:46 UTC+2)
+ Bug: make camo choice dialog correct size
+ Mechfiles update
+ Bug: VTOLs above smoke acting as if in smoke
+ Bug: Hovers falling into water when breaking ice
+ Bug: one-shot ammo counting as explosive for Aero BV
+ Bug 2774986: Hovercraft Not Sinking on Water
+ Bug 2777807: AMS and Swarm Missiles
+ Added BA Flag to more BA only equipment
+ Added Flags to delininate weapons and equipment for unit types

v0.33.45 (0.34.0 Release Candidate 2) (2008-04-16, 14:34 UTC+2)
+ Bug: AMS and BAP should count for offensive Aero BV
+ Bug: BA improved sensors counting as light active probes for BV purposes
+ Bug: BA BV calculation not disregarding "burden" by non-fired missiles for
    speedfactor calculation
+ Bug: Clan Medium Bär BA should not have heavy battle claws (magnetic)
+ Bug: Clan SRM 5 BV wrong
+ Bug: Djinn and Djinn (Stealth) BA should not have heavy battle claws (magnetic)
+ Bug: Rogue Bear BA should not be able to make leg or swarm attacks
+ Bug: Fa Shih should have 2 mines for each trooper, at 4 BV each
+ Bug: BA micro bombs should have BV 11
+ Bug: Report with missing subject
+ Bug: edge not always working correctly for quad mechs
+ Bug: direct fire artillery should only scatter for a distance of 1d6
+ Bug: Building destruction does not affect units in parts of the building that
    are destroyed due to more than half the building hexes being destroyed
+ Bug: ProtoMechs should not be able to fire MGA into non-front arcs
+ Bug: ProtoMechs should not be able to jump into any elevation of a building
    hex, only onto the top of it
+ Bug: Fah Shih mine-laying not working correctly, mines now correctly get
    placed during movement. TODO: adjust it so that mines can only be placed at
    the start or end of movement (only jumping/VTOL movement for BA)
+ Bug: magnetic clamps allowing 2 BA units to ride on omni tanks
+ Bug: BA Taser interference not working correctly
+ Bug: Aft mounted weapons not correctly identified as being rear mounted for
    Aero BV calculations
+ Bug: Implemented errata for QuadMech advanced hit location table
+ Bug 2755192: NPE when resolving FASCAM artillery delivery
+ Patch 2754033: Switch statements fall through
+ Patch 2754024: Error messages for invalid board size
+ added the ability to load the source tag for all BLK file loaders
+ Bug: buildings should not be damaged when exiting
+ Bug: buildings should immediately collapse when CF gets lowered to 0 due to
    units moving into buildings
+ Bug: Endo steel crits on listed as Tech All
+ Bug 2765038: alertdialogs can possibly be larger than the screen

v0.33.44 (0.34.0 Release Candidate 1) (2009-04-07, 03:43 UTC+2)
+ RFE: Add tonnage to -export command
+ Added F_BA_WEAPON flag to Clan BA weapons
+ revert change to require java6, for windows 98 users
+ Bug: Magma crust not destroyable
+ Bug 2728335: communication gear
+ Bug 1884498: damage during  BA swarm attack not quite correct
+ Bug 2713471: erronoues text
+ Bug: Firebee has missing MML ammo
+ Non-monospace font in swing unit loading failure dialog
+ Bug 2183009: VTOL Skid problem forces use of /skip
+ Bug: BV rounding for small cockpits wrong
+ Bug: Aero small cockpit BV calculation not quite right
+ Bug: Not all BAPs counting for BA BV
+ Bug: Protomech ammo not calculating correct BV
+ Bug: Aero BV not working correctly for heat efficient fighters
+ Bug: Armor appears twice in MechView for Aeros
+ Bug 1988508: Large Support Tank Vee Armor Display Distorted

v0.33.43 (2008-03-31, 20:31 GMT+2)
+ Updated Lancelot 25-01X
+ Bug: WiGE not loading if movement type was WiGE instead of WIGE
+ RFE: added public methods for BattleArmor Stealth Armor
+ Bug: checking for ice breaking when moving across elevation 0 bridge
+ Bug 1944660: Attacks on surface naval vessels don't follow TW rules
+ Bug: fix error with LOS between 2 units not always being identical
    Also, when LOS is going exactly between 2 hexes, and both provide same
    cover, the side gets chosen that gives the "better" hitting arc for the
    targeted unit
+ Bug 1908901: unit in climb mode can enter bridge from the side
+ Bug 1840605: mech falling into waterhex that has bridge wrong
+ Bug: server crash when charging a unit off the map
+ RFE: Added Movment Mod variabels for SimpleCamo and and Mimetic Armor for MegaMekLab
+ Bug: Clan and IS Superchargers had the same internal name
+ RFE: Added a way to force the bot to go individual init.  (a random unit is forced
	to move each time the bot starts.)  The option is set in bot.properties.
+ Bug 2526357: Swing button display was not updating properly
+ Bug 1880517: Entity.getArmor needed defensive programming
+ Bug 1774438: Bot inappropriately charges
+ Bug 2719742: Protos not moving
+ Updated Mechfiles

v0.33.42 (2009-03-10, 19:52 UTC+1)
+ Updated RSPPU mechfiles because of pending errata
    Thanks darkisi!
+ Bug 2653414: ClassCastException in Compute#getSwarmMekBaseToHit
+ Bug 2617908: MegaMek runs out of Memory after Nuke Attack
    Increased default memory to 256MB
+ Bug 2617215: Buggy savegame dialogue
+ Bug 1734691: LOS walking "both sides of the fence"
+ Bug 2652670: Bridges and frozen water
+ Bug 2603366: Kicking with hull breached leg
+ Bug 1990407: Assorted BA errors
+ Bug 2319736: BA initiative done after swarmed target ejects
+ Bug: Armored Component DBV calculated incorrectly
+ Bug: Industrial ICE engine unstalling not working correctly
+ Implementing Industrial check for critical damage after falling or being hít
    by a physical attack
+ Engine explosions shouldn't cause fires
+ Bug: Stalled engine in an industrial not causing all shutdown problems
+ Bug: Armored Components not calculated correctly for PPC Caps
+ Bug 1681510: Mech in depth 1 water takes damage to legs from swarmmissiles
+ Bug 1827095: performance issue in loading large maps
+ Bug: More Armored Components BV Calculations.
+ Bug 2620865: Bridge collapses, one unit falls other does not
+ Bug 2672469: Direct-fire artillery is +4 to-hit, not +5 (TacOps, pg. 185)
+ Bug: When moving out of a building collapses that buildinghex, the unit causing
    the collapse should not be hit by debris, because it just left that hex
+ Bug: Armored Components BV Calculations changing again.
+ Bug 2673107: double blind and offboard artillery result in crash
+ Bug 2685499: some 3025 units are erroneously marked as TW units

v0.33.41 (2009-02-25, UTC+1)
+ Bug: prevent NPE when c3/c3i team mate is not yet deployed
+ Minor fix in BV calculations
+ Bug 2499328: german AMS report string needs to be updated
+ Bug 1986904: Bot Freezes When Fighting Large Tank Support Vehicle
+ Bug 1878789: Game over before it even Begins
+ RFE: Armored Components
+ Bug 1642025: VTOL Sideslip and Crash Bug
+ Blowing sand visual range limit
+ Updated Mechfiles from RS PPU
+ Warhawk C should have right arm lower arm actuator
+ Bug 2591332: Force Modifier BV Broken
+ Grappler/Electromagnet Manei Domini Option
+ PL-MASC Manei Domini Option
+ Cybernetic Eye/Ear (including MM) Manei Domini Option
+ Comm Implant (including boosted) Manei Domini Option
+ Dermal Armor Manei Domini Option
+ Bug: Blowing sand visual ranges too short
+ Added F_BA_EQUIPMENT flag to MiscType.java
+ Bug 2564316: client not starting with Java6U12
+ Separated visual and sensor checks in Compute.java
+ Bug: Visibility (for double-blind) is not updated at the beginning of the turn
+ RFE: Added Fluff Source for MTF files
+ Bug 2596796:  MTF parser sensitive to crit arrangement (DHS issue?)
+ Bug: lookupnames for PPC capacitors missing
+ Bug: armored components screw up loading of multi-crit items>
+ Bug 2594423: Compact Gyro Weighs Too Much
+ Bug: NPE in Mech#getMtf if source is null
+ Reworked public gyro/engine creation API
+ Added missing internal name for PPC capacitors
+ initalized Source as empty string
+ Bug: escape does not always clear movement plot in MovementDisplay
+ Bug: Direct-fire artillery is +4 to-hit, not +5 (TacOps, pg. 185)
+ Bug: ProtoMechs not causing 1 CF damage to buildings when entering.
+ Bug 2414528: BA jumping into a building should need PSR to avoid damage
+ Updated Armored Crits code
+ Updated Artillery BV values to BV 2.0
+ BV halving for rear mounted weapons not working correctly
+ Bug: B-Pods have wrong BV and count for explosiveness
+ Read all engine codes correctly from BLK files

v0.33.40 (2009-02-08, 2:27 UTC+1)
+ Reorganized game options so that unofficial options are integrated into the appropriate tabs
+ revert Bug 2538487: Firing with a prone quad, was not actually a bug
+ RFE: Added new internal names for Improved Heavy Medium and Improved Heavy Small Lasers
+ Bug: /localload not working correctly
+ Correctly set armor tech level
+ Fix armor weight calculation to work correctly with armor tech level
+ Added construction data for spot welder, tracks, salvage arm
+ Gyro weight rounding wrong
+ Added searchlights as a construction option+
+ Bug: Enviromental Sealing rounding when getting weight
+ Added ProtoMech AC 2,4,8
+ Added Mek Taser, Not fully Tested.
+ Bug: NPE when calculating BV for HarJel when mounted has Location None
+ RFE: Added the ability to save and load base chassis heat sinks for omnis
+ Bug: Industrial Mechs without advanced targeting system should get 0.9 mod
    to offensive BV
+ Typo: Chassie changed to Chassis
+ Added getFirstEmptyCrit method
+ Bug: Not saving mixed Chassis types
+ Added MASS
+ Bug 2561154: Leg Destroyed - Avoiding Damage
+ Bug 2549302: Warrior C VTOL has no SRM-4 ammo
+ Bug 2495763: tanks falling due to sideslips should not take pilot damage
+ RFE: Added Rock Cutter
+ Bug: Mace showing as Experimental instead of Advanced.

v0.33.39 (2009-01-28, UTC+1)
+ Don't crash the server when trying to add newlines to empty Vector of Reports
+ Destruction of carried infantry when carrier dies according to TW rules
+ Industrial TSM
+ Industrial Mech Environmental Sealing
+ Fix some mechfiles ammo
+ Vehicles can evade
+ ICE Industrial Mech engine stalling
+ Industrial structure weight
+ Fission and Fuel Cell engine weight
+ Starting with Primitive Mechs
+ some javadoc updates
+ Bug 2516778: Bot freeze with BA
+ Bug 2517288: Infernos hit with NARC-Bonus
+ Bug 2155831: GameOptionsDialog doesn't resize nicely
+ Changed font in report display, GameOptionsDialog text area and in chatbox to
    non-monospace
+ Fix ConcurrentModificationException on Server closing
+ Bug: Mech Magshot Gauss had wrong tech level
+ Removed Mech Clan Magshot Gauss, it does not exist
+ Primitive BattleMech construction
+ Added Dervish DV-1S from Jihad Secrets: Blake Documents
+ Added Fluid Guns. Only construction data, no rules
+ fixed verifier tonnage rounding
+ fixed Zeus 9WD Stacy tech level
+ Fixed primitive and industrial cockpit strings
+ Fix some industrial engine stuff
+ Fix environmental sealing flags for MMLab
+ Fix primitive Mech engine ratings
+ industrial mech cockpit equipment restrictions should also apply to primitive
    industrial cockpits
+ Fix a few 3075 mechfiles
+ Rename "allow level 3 ammunition" game option to "allow advanced ammunition"
+ Bug 2517886: TacOps PSR weightclass mod not stacking correctly
+ Default players to a team, instead of "No Team"
+ Laser AMS should have BV of 45, not 105 
+ RFE: Check for defaulthexset if selected hexset does not exist
+ RFE: Create defaulthexset if it does not exist and is needed
+ Bug: Not able to Load more then 1 mul at a time using MegaMekLab
+ Bug: Clan RAC/2 and RAC/5 had wrong crits/tonnage
+ RFE: Command line to print out equipment stats
+ RFE: setTonnage Method created for MMLab
+ Bug 2538487: Firing with a prone quad
+ Bug 2531526: Hull breached ammunition in vacuum

v0.33.38 (2009-01-15, 19:51 UTC+1)
+ New public method to compact engines and compact gyros
+ changed Mech.addXLGyro to make gyro contigious in the CT
+ Added Ballistic flag to B-Pods
+ Mech.CalculateBattleValue now creates a StringBuilder with the
    Steps printed out for easier debugging
+ Added ER Flamers
+ Fix Shedu MG
+ Improve BV calculation printout
+ Fixed External name on TAG and A-Pod
+ Bug: direct fire artillery should be at +4, not +5
+ Bug 2457669: (AERO) Ammo fighter squadron weapons getting NPE
+ Bug 2459131: (AERO) ECM too high when LoS splits hexes
+ Bug: Offboard distancesetting not working
+ Bug: Void sig BV problem
+ Added Show BV calculation button to swing MechSelectorDialog
+ Bug: non-body-mounted weapons instead of body-mounted weapons couldn't hit
    during swarm attack
+ Bug: To-hit description in swing mechdisplay has no linebreaks
+ Bug: Rear facing weapons not printing '(R)' in getMTF() method.
+ Removed IS from External name of LMGA HMGA and MGA
+ Updated mechfiles, thanks St0ny
+ Some work for Idustrial Mechs
+ Bug: MASC should be critable
+ Added Industrial Mech armor
+ Bug: Fix building hex collapse crash
+ Bug: with people placing , in the fuel strings like 18,000
+ Made Look for equipment names case insensitive.
+ Ejection seats for industrial mechs
+ Industrial Mechs with ICE engine don't generate heat for walking/running
+ Industrial Mech Sensors are knocked out after 1 hit
+ -1 to-hit for anti-mech attacks against industrials
+ Flag illegal tech combinations on industrial mechs as illegal
+ Update armor and IS costs
+ Added Industrial Mech Cockpit (that has no advanced firing control)
+ BV errata on TSM and MASC speed factors
+ Bug: Speed Factor rounding too soon when calculating BV
+ RFE: GameListeners are no longer saved to the save game files
+ Bug: Apollo has not loading LRM 15 ammo
+ Bug: sorting of weapons wrong in BV calculation when BV difference is < 1
+ Bug: BAR armor not working quite right
+ Bug: non-mechs can't shoot
+ IndustrialMechs get +2 on the determining critical hits roll and 4 crits on a
    result of 14 
+ MOUNTWIDTHMIN and MOUNTWIDTHMAX not correctly loading from XML files
+ RFE: Defensive Equipment BV printed out in list for BV Calculations
+ Removed Clan and IS enumeration from MiscType names.
+ Bug 2505813: Nemesis iNarc causing NPE
+ Bug 2506959: Class cast exception in TestMech.correctCriticals()

v0.33.37 (2008-12-19, 19:45 UTC)
+ Updated canon unit list
+ Bug: Thunderbolts in minimum range should do half damage, round down
+ Bug: physical attacks vs. flying VTOLs not possible at correct elevations
+ Bug 2129039: Skid distance and PSR calculated wrong
+ Bug: Fix MVSPL range correctly
+ Bug: MASC set as Splitable
+ Bug: Auto Cannon Internal names missing
+ Bug: Small Cockpit crits placed wrong
+ Changed External Name for Rocket Launcher from RL to Rocket Launcher
+ StratOps Tactical Fuel Efficiency
+ StratOps Advanced Heat
+ StratOps Variable Damage Thresholds
+ StratOps Advanced Atmospheric Control Rolls
+ StratOps AAA Capital Laser Mode
+ StratOps Bracketing Fire Mode
+ StratOps Over-Penetrating Weapons Fire Mode
+ Standard to capital damage modified to follow example on pg. 33
+ StratOps Fighter Squadrons
+ StratOps Large Craft and Sensor Shadows
+ StratOps ECM
+ StratOps Harjel
+ simplified fighter launching (fighters above safe rate are distributed evenly among doors)
+ Jumpship and Space Station Movement
+ Jumpship/Warship/Space Station Hit Locations
+ Bug: Mule Kicks should be impossible with front leg destroyed or hip-critted
+ Bug 2429049: Quad Mech with 2 destroyed legs
+ Bug 2128991: UnitOverview in swing UI bugged
+ Bug 2165007: infinite loop in swing mekdisplay
+ Bug 2201700: swing map editor does not work
+ Bug 2095864: Indirectly Fired LRM's hitting Partial Cover
+ Bug 1725442: damage to mechanized infantry
+ Bug: collapsing buildings causing too much damage to BA and mechanized infantry
+ bomb loading
+ StratOps Space Bombing
+ TacOps AAA Missile Bomb Munitions
+ TacOps AS Missile Bomb Munitions
+ TacOps LAA Missile Bomb Munitions
+ fixed space bombing bomb expenditure
+ Bug: Aeros can't fire at targets in the same hex
+ Fixed Black Lion warship ammo
+ Bug: Improved Heavy Small Laser to set to Experimental
+ Bug: Quad mtfs not being parsed correctly if saved with MM SaveMek method.
+ Bug: Bomb Arrow IV replacing IS Arrow IV
+ No Arrow IV bomb weapons
+ Bug: protomechs not correctly loading ammo into weapons
+ Patch 2246602: More Weapons for CustomBattleArmor Dialog
+ Bug: Coolant pods being checked for incorrectly in BV Calculations
+ Changed BV Calcuations String to HTML Format

v0.33.36 (2008-12-10, 19:00 UTC)
+ Bug in Mech BV calculation fixed
+ Bug: Infantry flamers cause too much heat
+ include equipment.txt in release built via ant
+ added /load command to load a game from the savegames directory
+ added safety check for filename in load command
+ added a /localload command to load a game from the client's savegames directory
+ game option to disable local saves when double blind is in use
+ added /listSave command to list all *.sav files in the savegames directory
+ updated command line help
+ added serialization to Aero sub-classes
+ Added missing Achileus (Flamer)
+ Bugs: wrong to-hit for club attacks with claws
+ Bug 2332664: engine hits counted twice for engine explosion when location destroyed
    and engince crits in that location critted in same phase
+ Bug: vehicle advanced front firing arc using turret arc
+ combined duplicate methods Mounted.howManyShots and Mounted.getCurrentShots
+ Bug: Do displacement due to charges/DFAs before dealing damage
+ Simplify MekMortarHandler
+ Finished BA BV.
+ Bug: IS BA with body-mounted missile launchers can't jump until the missile
    launchers are jettisoned.
+ NOTE: To specify that a weapon is body mounted on a BA, add a ":Body" at the 
    end of the equipment line in the BLK file. This is important for the jumping
    with missiles on the body, and for swarm attacks
+ Bug: Body-mounted weapons usable in swarm attack
+ Show burdened status of BA in mechview and mechdisplay
+ AP infantry weapons shouldn't count for BA BV
+ Bug: Small Cockpit BV
+ Updated Ammo Short Names for MML and LB-X
+ Implemented BA Taser Rifles
+ Moved all Capacitors to one MiscType
+ Updated BV for PPC Capacitors
+ Bug: PPC Caps not loading correctly
+ Bug: target movement mod of 1 for jumping 0 hexes in BV calculations
+ isMilitary method
+ Bug 2206429: (AERO) Fighters can do maneuvers in space
+ Bug 2385422: (AERO) Small Craft freeze game
+ Small Aerospace Cockpits
+ Bug 2205615: (AERO) Heat by bay losing attacks
+ Bug 2205567: (AERO) loaded fighters survive carrier destruction
+ Bug 2205569: (AERO) icon for loaded fighters on fleeing carriers show
+ Added Errata change to BV for Torso Mounted Cockpits. http://www.classicbattletech.com/forums/index.php/topic,44161.0.html
+ Added TacOps BV Armor modifiers
+ Bug: Armor Def BV value not being calculated correctly for Torso Mounted cockpit Units.
+ Removed unused Imports
+ Added F_BA_WEAPON flag for informational purposes.
+ Bug: Shields not loading correctly for MegaMekLab
+ methods for including some end of turn modes and instant switch modes on the same equipment
+ Fixed reporting for mode switching
+ Fix 3058U IS Mechfiles that mount lvl 1 ACs
+ Bug: crash when buildings collapse
+ Bug 2398701: Wrong VSPL ranges
+ Bug 2369839: TownSize wrong in generated maps
+ Bug 2310983: Laser AMS using wrong heat
+ Bug 2270412: Flak Ammo don't get -2 Bonus against VTOL
+ Bug 2238975: Trip Attack available when units at different elevations

v0.33.35 (2008-11-16)
+ Santa Anna ship-to-ship missiles
+ Fixed: White Shark/Santa Anna appropriate weapon handler
+ Bug 2204575: Can't go from prone to hull down
+ Bug: Capital Missile Bays reported as AR10 Bays
+ Fixed: Tele-Missile NPE Error
+ Rules change: BA micro bombs use only anti-mech skill for to-hit
+ Fixed LRM scatter
+ Fixed some swing display issues for Aeros
+ Data 2154265 and Data 2161694 - fixes Bug 2033354, Bug 2024271, Bug 2126353
+ Bug 2206470: Light and heavy snow not showing
+ Tooltip now shows all terrains present in a hex, except for fluff
+ No snowfall on magma hexes
+ Fixed rubble levels
+ give wall rubble (level 5) "light rubble" hex image
+ changed rough_1.png to the hex image for ultra rough
+ Bug 2205548: More Hull Down Issues
+ added Fulcrum image (thanks evilimperial)
+ added hex images for light and heavy jungle (taken from the coast line theme - thanks Battledroid)
+ added hex image for ultra heavy woods
+ added hex image for ultra heavy jungle
+ added colors to minimap and map preview for ultra heavy woods/jungle, planted fields, and heavy industrial zone
+ reorganized the ordering of terrain types for the tooltips, including more comments
+ corrected terrain factor sizes for TacOps (pg. 64)
+ added hex image for planted fields
+ Added shortName field to AmmoType
+ added getShortName() to AmmoType
+ stealth armor not using correct armor name
+ Bug: Laser Heat sinks not being saved with getMtf()
+ Bug: Omnimech not being saved with getMtf()
+ Sub-Capital Weapons
+ Bug 2204611: (AERO) Capital Missile Mods Wrong
+ RFE: Still show player DB messages for their unit after the pilot lost LOS of the attacker.
+ Added extra building roof images
+ Bug: LACs having Rapid fire mode when game option is not set
+ Bug: BA have higher run MP than they should
+ Bug: 3D boardview not working
+ Assign more memory to javac when building MM via ant, to prevent OutOfMemory
    errors
+ Modular armor BV
+ TacOps Retractable Blades
+ added image and height display for Heavy Industrial Zone
+ AES BV
+ UMU BV
+ CASE II BV
+ Cooland pods BV
+ Changed Loc0st string to make users report server crashes correctly
+ Bug: Clan Wrecking Ball listed as IS TW Non Box
+ Fix wrong use of getOriginalJumpMP()
+ Added Cost and BV to the -validation command
+ Added BA Vibroclaws and their physical attack (accessible via right-click menu
    in physical attack phase
+ Updated ASF, Conventional Fighter, and Small Craft BV to TM Errata 1.0
+ BA BV, not yet done
+ Added Canon Column to -export printout
+ Removed Unused Imports
+ Bug: Reflective and Reactive armor not calculating the correct amount of crits
+ Bug 2146268: artillery does not fire when torsotwisting
+ Magscan and Active Probe sensors are not blocked by hills (see http://www.classicbattletech.com/forums/index.php/topic,43036.0.html)
+ Updated Dropship BV to TM Errata 1.0
+ Added Mounted object to CriticalSlot
+ Added get/set methods for Mounted in CriticalSlot
+ Bug 2258241: Simultaneous fire with Protos caused server crash
+ Bug 2272739: A-pod doing no damage
+ Bug: extra BV from C3 should be based off base BV; ignoring pilot/gunnery of
    units in force
+ Bug: Leg attack possible against mech doing a DFA
+ Bug: Supercharger should be available to clan units

v0.33.34 (2008-10-28, 02:30 UTC)
+ Added Hephaestus image
+ Fixed lots of munition techlevel
+ Bug: Mech with left arm and a leg destroyed couldn't get back up
+ Options to play attack phases in parallel to speed up large games
    Attack arrows aren't shown to your opponent to avoid disadvantage in
    declaring first
+ Initiative related options including the above given their own tab, since
   there are a lot of them
+ Updated some 3050U mechfiles' rules levels
+ Context Menu for Swing
+ Bug 2128994: Artifacts on Swing when scrolling
+ Bug 2151853: Off Board Artillery and reinforcements get NPEs when checking for buildings
+ Bug 1662069: Bot using MASC too much, especially if it's under threat.
+ Bug 1662074: Bot takes PSRs too often
+ Bug 1967269: Negative damage on accidental charges
+ Bug: non-mech units falling when in collapsing building
+ Commander Initiative
+ IR scanners only detect units with heat on their heat track
+ Bug: game-option dependent modes not appearing on units after loading a savegame
+ old code for BAP detection within a certain range deleted
+ Bug: BAP not detecting through buildings
+ Bug: overheating adjustments to night modifiers
+ Bug: VTOL units have seismic sensors
+ Sensors only detect a single range bracket
+ Added game option to make sensor ranges inclusive (i.e. medium range includes medium and short)
+ Bug: MRM 20 OS showing rack size 40
+ Void-Signature System (including sensor modifiers)
+ Bug: initiative bonuses not clearing in InitiativeRoll
+ RFE: Do not update Planetary Conditions/Game Options/Map settings after the game has started
+ Bug: Null-Sig/Void-Sig fixes
+ Bug: only link stealth/Null-sig to ECM on Meks
+ Bug 2176127: Swarm missiles being weird.
+ TacOps Pilot Fatigue Option
+ Chameleon Light Polarization Field
+ Adjust visual range for visual camo (including null sig)
+ Check chameleon/void-sig/null-sig/stealth armor and other equipment restrictions
    for illegal units
+ Bug: MASC and supercharger on one mech not working correctly
+ Minefield damage delivered in 5-pt clusters
+ Bug 2083962: move mod for walking backwards
+ In right-click popup target menu, show target entity even if it's the only one
+ Bug: Fixed a few oddities in the swing add unit dialog
+ Bug: fix ATM ammo switching not working correctly
+ Bug: Attacks listed twice in attack-arrow tooltips before finishing firing
    declaration of a unit
+ Bug 2043390: Large Units and Multiple Target Mods
+ Bug: Swing tooltip not multiline like the AWT one
+ Bug: jumping onto ice
+ RFE: Added overload to Mech.addEngineSinks() to allow for the loading of Laser 
	and Compact Heat Sinks
+ Bug: infantry/Battle Armor should not check for breaking ice
+ Bug 1971380: first step does not break ice from below
+ Bug: non-careful movement shouldn't affect movement below ice
+ Inferno fire corrections
+ Bug: inferno fire not melting ice and snow
+ Added GBC class, a helper class to set up GridBagConstraints
+ Reworked CustomMechDialog to use GBC
+ Bug 2000045: Celestial OmniMechs not Omnis
+ Blowing sand planetary condition
+ BUG 2167295: MegaMek Lock-Up w/ new init rules 33.44-dev
+ RFE (mekwars.org forum suggestion): typing /defeat before /victory now informs other 
  players that you wish to surrender. Bot accepts surrenders but will still play the rest
  of the turn normally.  
+ updated equipment.txt with new tech levels
+ Bug: AMS did not have a Ballistic flag
+ Bug: Infantry should have identical walk and run MP
+ Bug: 0 MP infantry units should be able to shoot or move
+ Bug 2171505: C3i not granting bonus
+ Enhancements to swing GUI to make it look more system-specific (especially for Macs)

v0.33.33 (2008-10-07, 20:33 GMT+1)
+ Bug: Clan IJJ's being treated like IJJ's
+ Bug: Cluster artillery doing reduced damage against units in woods.
+ Bug: Mine Field Delievery Menu option not showing up for MML launchers
+ Bug: SmokeCloud not Seralizable.
+ Created Mounted.isInoperable(). Checks for Missing Destroyed and Breached flags
+ Enforce "no attack on friendly units" rule only when friendly fire is disabled
+ Bug: leg attacks not working
+ Bad Placements of isShutdown();
+ Bug: BV heat efficiency not taking XXL engine movement heat into account
+ Bug: Fuel tanks not correctly initialized
+ Bug: Some BV Skill modifiers were wrong (see Welshman's table at http://www.classicbattletech.com/forums/index.php?action=dlattach;topic=38208.0;attach=34721
+ Bug 2076194: Hulldowned mech lost leg and still Hull Down
+ Changed Tech level handling:
    We now have introductory box set, TW, advanced, experimental and unofficial
    techlevels. (advanced and experimental being Tactical Operations stuff and
    other current rules, unofficial being all old rules (THB) and MFUK and house
    rule equipment.
    In MTF files, techlevel 3 now corresponds to advanced, 4 corresponds to
    experimental, and 5 to unofficial.
+ Implemented Communications Gear, including ECCM, Ghost Target and Initiative
    bonus functions
+ Bug: Fixed physical weapon attacks to hit mods
+ Bug: getting up from hull down not working correctly
+ Bug: experimental/unofficial ammo not being allowed when appropriate game
    option is set
+ Bug: go prone and go hulldown and climb mode movement sprites not displayed
    immediately
+ Bug: Swing UI target menu not working correctly
+ Bug: problem with collapsing multi-hex buildings
+ Bug 2124361: accidental charges not working
+ Bug: swarm missiles not hitting friendly units
+ Bug: multiple leg destroyed PSRs for a quad that loses first a front leg and
    then the torso it was attached to
+ Bug: DFAs and charges not working
+ Bug: Pulse lasers not adjusted for glazed armor
+ Bug: Homing artillery ammo not giving extra BV when TAG present
+ Bug: Disabled AMS still shoots
+ Bug: some BA ammo had wrong tech level
+ Bug: BA ammo choice not showing correctly in Mech Display
+ Bug: Artillery scatter not using updated rules from TO
    Removed unofficial error_margin_scatter, as current artillery scatter rules
    depend on margin of success.
    Used these scatter rules also for LRM scatterable stuff, although TO does
    not specify scatter rules for this.
+ Bug: ProtoMechs should not be able to skid
+ Bug 2085049: movement types not localised
	Note german text is machine translated, please correct if you are a native speaker
+ Bug 2098953: Thorn 1S and Hornet 154 have 9 HS
+ Updated german translation of movement types
+ Updated BLK loaders with new techlevels:
    IS Level 1: box set stuff
    IS Level 2: TW stuff
    IS Level 3: TO advanced stuff
    IS Level 4: TO experimental stuff
    IS Level 5: unofficial or outdated equipment (e.g. MFUK or THB stuff
    same for Clan Units
    for mixed tech units, use these types:
    Mixed (IS Chassis): mixed tech with TO advanced equipment
    Mixed (IS Chassis) Experimental: mixed tech with TO experimental equipment
    Mixed (IS Chassis) Unofficial: mixed tech with unofficial equipment
    Mixed (Clan Chassis) etc for clan base chassis
+ Bug 2095170: ATM Standard Ammo
+ Bug: MASC weight calculation wrong
+ Bug: Server crash when building crashes because of unit standing on it
+ Bug: Only one leg attack per turn possible
+ Bug: Swarm/Swarm-I target choosing now updated to TO rules
+ Bug: Artillery scatter not correct
+ Bug 2080245: C3i DB bug
+ Bug: /reset not clearing pending attacks
+ RFE: Set Max wind Strength for Planetary Conditions.
+ Bug: fix initiative reporting error
+ Added Stinger wreck image
+ Added new field gunner pics
    Thanks Nyrond!
+ Data 2113388: Whirlwind LPL
+ Data 2113425: Revised WS gifs and mechset based on errors
+ Data 2127520: Some missing unit GIFs
+ Added Pariah unit files
+ Bug: Infantry with 0 walk MP but some run MP can't move (this can happen with
    TacOps weather conditions
+ Added image for Manteuffel tank

v0.33.32 (2009-09-15, 21:21 GMT+1)
+ Remove unused image files
+ Bug 2111184: 0.30.31 Bot Won't Move/Deploy
+ Bug: Issue with null buildings in losEffects

v0.33.31 (2009-09-14, 19:30 GMT+1)
+ Bug: Improved Heavy Large Laser had the wrong crit/Tonnage
+ Bug: Rapidfire AC possible when option is not set
+ Bug 2098132: Stackpole rolls for vehicle engine crits
+ Bug 2098980: Standing up with missing leg not working
+ Bug 2096126: swarming infantry shouldn't get a movement turn
+ Bug 2095661: Artillery Damage
+ Bug 2087303: RACs at Extreme Range
+ New Context menu for AWT.
+ Bug: Punch and Push logic reversed in Context menu
+ Logic change to how Direct Blow damage is calculated.
+ Bug: smoke not removed when server is reset
+ Bug: Terrain Modifier added Twice for Pilot damage roll when unit falls
+ Bug 2103038: ECM should still work if the pilot is unconscious
+ Bug 2103147: Artillery Direct Fire Minimum range
+ Bug 2020986: BA Leg Attack Bug
+ Bug: Could not Target Buildings with Context Menu
+ Bug 2104615: Airborne Direct Fire artillery
+ Bug: leg-mounted B-Pods not being able to fired as a normal weapon against
    Infantry in the same hex.
+ Bug 2104831: AMS and Streak SRMs
+ Bug 2001981: Missed shots on units inside Buildings (per TW Rules)
+ Bug: PPC damage getting halved twice when attacking reflective armor
+ Data 2030944: TRO3075 Vehicles
+ Data 2029934: 3039 ASF Revised
+ Data 2012074: 3075 Pentagons
+ Data 2072689: Aegis TH Error
+ Data 2066654: Conqueror error
+ Data 2027479: Missing Units
+ Bug 1997361, Data 2012085: Excalibur PWS
+ Data 2024274: More WS Icons
+ Data 1988368: new SHD-5D Sprite
+ Bug: a friendly unit can never be the target of a direct attack.
+ Bug: missing to-hit modifiers when in-building-combat happens
+ Bug 1966594: Unit Damage inside Buildings (TW rules)
+ Bug: Artillery flight time was not being adjusted for gravity
+ Data 2106809: Danais + Trojan dropships
+ Data 2108434: localclient_wreckset

 v0.33.30 (2008-09-01, 09:40 GMT-8)
+ Bug: Talons not added to equipment list.
+ Bug: Wrong messages.properties file
+ Bug: AES not loading if Unit has SuperCharger
+ BV for Torso Cockpits
+ Bug 2043681: right-click menu not working
+ Bug: Thunderbolt missiles not doing correct damage with direct blow
+ Bug: Ammunition Explosion damaging adjacent units when exploding unit has CASE in effected location.
+ Bug 2043680: Woods Absorbing Damage
+ Bug: Badly named Weapons in some Aeros
+ Bug: PPC's not working with dial down rule
+ Bug: ECM ghosts not working correctly.
+ Added new messages and a Try/Catch to receiveEntityModeChange
+ Bug 2045753: Improved Heavy Laser Nomenclature
+ Bug: Units not falling down when failing PSR's
+ Bug: Hull Down units having to make PSR's when taking damage
+ Changed Code to log errors from receiveEntityModeChange.
+ Bug: Ejection Failure roll not calculating damage correctly
+ Bug: PPC Inhibitors not showing if Dial Down Damage rule used
+ added text "Hull Down" when unit is Hull Down on map
+ Bug: Heat Seeking Missiles not getting correct Bonus vs TSM active units
+ Bug: able to trip units that are not at the same elevation
+ Coolant Pods are now effected by Heat Sink Coolant Failure Mods
+ Bug: Careful stand not causing Movement Modifier when attacking.
+ Re-organized unit files
+ Bug 2048658: 3 Engine Crits
+ Bug 2049743: Several bugs
+ Bug Night Movement PSR not shown when reckless movement is used
+ Bug: F1-F3 Tornado's showing as F4 rules.
+ Bug: Ammo Explosion not hurting nearby units.
+ Bug: Direct Blow increasing cluster weapons damage instead of just hits on the CHT
+ Bug 2055501: Errors/Typos in Game Options
+ Bug: Streak weapons doing double damage with Direct Blow
+ Bug: Modes not loading correctly for MekWars
+ Bug 2051697: "permanent" hull down
+ Bug: Dial down Heat/Damage now display correctly on MekDisplay
+ Changed to how game options are loaded in Entity.
+ Bug: Tool tips not centering on Mouse Point
+ Bug: Ammo explosion rule causing NPE
+ Bug: Visual Range not calculated correctly in Planetary Conditions.
+ Bug 2062129: skips fire phase when /victory declared and no /defeat done
+ Bug: Streak LRMs not loading ammo correctly
+ Bug: Streak LRM's using wrong Weapon Handler
+ Bug: Direct Blows causing Crit rolls greater then 12
+ Implemented multi-hex buildings
+ Bug: Mechs carrying BAs on their backs shouldn't be able to dump ammunition
+ Bug: rapidfire MGs against conventional infantry should do normal damage
+ Bug: fix 3d view.
+ Bug 2022141: "Firedrake" Assault Needler
+ Added BPod Code.
+ Bug: AP ammo and TC Ammo not doing full damage to Hardened Armor
+ Bug: LK Munition and HE Munition using the same flag
+ Bug: Update entities for changed game options
+ curMode() now returns EquipmentMode.getMode("None") instead of NULL
+ Bug: PPC Caps all have same external name screwing up MekWars.
+ Bug 2069823: ATM Ammo Issues
+ Bug: Hull Down calculating MP cost incorrectly
+ Bug: Quad Left and Right Side table doing all Rear shots
+ Bug: HeatSeeking, Follow the Leader, and Tandem Charge ammo should only have half the number of rounds per ton
+ Bug 2080056: Direct Blows (two bugs)
+ Bug: Glancing Blows and Direct Blows not effect special crit rolls for TC and AP ammo
+ Bug 2071836: Sylphs able to Leg-Attack while hovering
+ Bug 2081205: Host Crashes when Fuel Tanks are shot
+ Bug: Crit rolls over 12 not getting calculated for Meks
+ Bug 2084738: RACs Unaffected By TacOps Cluster Hit Penalties
+ Bug 2084823: AP Gauss Rifles should explode
+ Patch 2060776: Enhanced ER PPC

v0.33.29 (2008-08-08, 16:54 GMT+2)
+ Bug: restore Java 1.5 compatibility
+ Added new 3d libs to build.bat
+ Added 3d libs to manifest.txt
+ Added boardview3d folder to build.bat
+ Added Tabs to Game Options Dialog in both Swing and AWT
+ Bug 2000044: Velocity in Space
+ Bug 2001104: Screen launcher damage scale
+ Added 3d start batch file for dos users
+ Avatar Prime had Rifleman image
+ Bug 2008251: BA secondary targets
+ Warship icons for Aegis, Avatar, Farragut, Fredrasa, Kimagure, Lola (I-III), Luxor, Monsoon, Riga, Sovetskii Soyuz, and Whirlwind
+ Corrected pilot skill BV multiplier
+ Bug: Cntl+Click ruler not working
+ Fix Swing UI
+ Bug: Rotary ACs not classified as ballistic
+ Bug: Null building being passed for a damage check to infantry in a building
+ Updated Mech BV calculation to upcoming TM errata
+ Bug: Heavy Duty Gyro causing +2 PSR on first critical hit instead of +1
+ Oodles of TacOps features:
    Standing Still (Expanded)
    Evading
    Hull Down
    Backward Movement
    PSRs: Taking damage
    PSRs: Taking damage (Weightclass mods)
    PSRs: Leg damage
    Vehicles: Movement: Lance Movement
    PSR: Falling (Expanded)
    PSRs: Attempting to Stand
    PSRs: Careful Stand
    Jungle (needs art for hexes)
    Heavy Industrial Zones, need art for hexes; explosion due to less than all 
        missiles hitting unimplemented
    Planted Fields (needs art for hexes)
    Rough (Ultra)
    Rubble (Ultra) (needs art for hexes)
    Sand
    Woods (Ultra-Heavy) (needs art for hexes)
    Fire
    Rapids (water flow not implemented)
    Swamp (need an image for quicksand (level 2 and 3 swamp). Until I get a
        rules clarification, being sunk up to your legs does not prevent leg
        hits or leg weapons from firing)
    Torrent (water flow not implemented)
    Atmospheric Pressure (Density) (waiting on rules clarification regarding
        aero movement in trace atmosphere; no changes to WiGE take-off
    Electromagnetic Interference (EMI)
    Fog
    Hail
    Light
    Rain
    Snow
    Wind
    Extreme Temperature
    Bog Down Rules (Protomechs need to be allowed PSRs (here and elsewhere)
    Careful Movement
    Line of Sight
    Glancing Blow
    Direct Blow
    Altered Energy Weapon Damage
    Cluster Hit Penalties
    Woods Cover
    Extreme Range
    Firing When Down
    Partial Cover
    Weight Class Physical Attack Modifier
    Jump Jet Attack
    Grappling
    Charging
    Trip Attack
    ECCM
    Autocannons: Rapid Fire Mode
    Ghost Targets
    Machine Guns: Rapid Fire Mode
    Energy Weapons
    Gauss Weapons
    PPC Inhibitor
    Extended Heat Scale (Assumes that quads get -2 on the roll)
    Heat Sink Failure
    Vehicle Firing Arcs
    Vehicle Effectiveness
    Digging In
    Battle Armor Infantry
    Battlefield Wreckage
    Skin of teeth ejection
    Minefields (The following related advanced technologies are unimplemented/
        unchanged in this commit: (1) minesweepers, (2) minesweeping specialist
        infantry, (3) mine dispensers, (4) EMP mines. The LOS rules on whether
        weapon-delivered mines are seen by opponent are implemented, but are
        only marginally useful because both the attack arrow and weapons report
        tell the opponent what they need to know. )
    Double-Blind Rules
    BAP
    Angel ECM 
    Actuator Enhancement System
    Modular Armor
    Chain Whip
    Spikes
    Talons
    Improved Heavy Gauss Rifle
    Silver Bullet Gauss Rifle
    Binary Laser
    Bombast Laser
    Chemical Lasers
    Variable Speed Pulse Lasers
    Improved Heavy Lasers
    Mech Mortar
    Flak Autocannon Ammo
    Inferno-IV Missiles
    Thunder/FASCAM Ammo
    Active Mines
    Inferno Mines
    Standard Mines
    Vibrabomb Mines
    Heat Seeking Missiles
    Tandem Charge Missiles
    Thunder LRM
    MRM Apollo FCS
    Advanced Hit Locations
    Engine Explosions
    Artillery (no counter battery fire, no laser-inhibiting ammo)

v0.33.28 (2008-06-17, 18:19 GMT+2)
+ Aeros can go up and down in atmosphere
+ Aero velocity halved every round in atmosphere
+ fixed misspelling of "chassis" for leviathan in mechset.txt
+ Aeros gain velocity when going down two or more elevations
+ Altitude effects on firing for low-atmosphere map
+ control rolls for damage in atmosphere
+ Bug 199123: all weapon bays limited to short range
+ minimum straight movement in atmosphere carried over from last turn
+ limit velocity in atmosphere to twice safe thrust
+ get proper bonus on control rolls for descending more than two altitudes
+ Fix lots of warnings and indent and imports
+ Bug 1991256: can't change map dimensions
+ Hovering for spheroid craft in atmosphere
+ Spheroids don't gain velocity when descending more than two altitudes
+ Customizing velocity has no effect on spheroids in atmosphere
+ Elevation is set to 10 by default for Aeros and restrictions placed on deployment based on elevation
+ Disabled turning for spheroids in atmosphere
+ no facing for spheroids in atmosphere
+ spheroid moves in atmosphere don't decrement velocity left
+ changed spheroid firing arcs and to-hit angles in atmosphere
+ fixed crash reporting during control rolls
+ Conventional fighter unit type
+ Fixed loading conventional fighters into Create Squadron dialog
+ Bug 1993188: Tele-Op Missiles always face "north"
+ Heat works differently for conventional fighters
+ Conventional fighter data
+ Fighter squadrons disallowed in atmosphere
+ Changed the way velocity is reported in movement costs
+ added VSTOL capabilities
+ Fixed: velocity increase due to altitude fall does not increase thrust nor prevent acc/dec next turn
+ more improvements to movement step display for Aero
+ Fixed: Aero elevation changing over water
+ Fixed: acc/dec next disabling acc/dec buttons in all future rounds
+ air-breather fuel efficiency option
+ Aero special maneuvers in atmosphere
+ damage to Aero if launched in atmosphere at velocity > 2
+ Optional 3D interface, thanks to Jörg Walter
  To use this, Java 3d needs to be installed on your machine 
  (https://java3d.dev.java.net/binary-builds.html.
  Then, run MegaMek with the commandline parameter
  -Dmegamek.client.ui.AWT.boardView=megamek.client.ui.AWT.boardview3d.BoardView3D
  Also, the memory allocated to MegaMek should be increased by using the command
  line parameter -Xmx256M, as soon as you want to play on somewhat larger maps.

v0.33.27 (2008-06-10, 23:50 GMT+2)
+ Bug: ISSRM3 not getting created
+ Bug 1973561: OSR-5W gyro doesn't match listed type
+ Bug: Ultra and Rotary ACs not doing enough damage when firing more than 1
    shot and targeting Infantry
+ space movement (including vectored movement) for Aeros
+ attack value damage for Aero units (including weapon bays)
+ added bundle.xml, containing a single target to create a MacOS X Application 
    Bundle. Needs JavaApplicationStub at the default location and jarbundler
    (from jarbundler.sourceforge.net), and works under MacOS X only
+ fixed indent (4 spaces instead of tabs) and added some javadoc comments
+ Aero structural integrity damage
+ capital-scale damage
+ Aero critical hit effects
+ resolution of standard-scale damage to capital-scale entities
+ fixed range of laser bay
+ fighter squadron damage resolution
+ Aero specific to-hit bonuses and penalties
+ fixed misspelling of Xerxes in mechset.txt
+ heat by arc for large craft
+ save and load Aero entities using MUL files
+ restricted bay weapon ammo to ammo in bay
+ to-hit bonuses for specific weapons in bay
+ rapid fire weapon handling for Aeros
+ changed display of heat in Mech Display to account for rapid-firing weapon modes
+ Bug: Infantry flamers not dealing correct amount of heat to target.
+ Fixed lots of warnings.
+ Bug: displacement off buildings due to DFA did not make target fall correctly
+ Weapon handling for screen launchers
+ Weapon handling for tele-operated missiles
+ TRO 3075 BA
+ Bug 1984925: Nuke Exception 0.33.27-Dev
+ FIXED: name of Killer Whale-T
+ Data 1981770: ASF
+ Data 1981757: Warships
+ Data 1981764: Jumpships
+ Fixed: tele-missile weapon launchers not being created
+ Data 1981763: Dropships
+ improved icons for Cheetah and Seydlitz
+ Data 1977277: New Inner Sphere Warship Icons
+ RAC and UAC jamming in weapon bays and unjamming for Aeros
+ disable mode switching of rapid-fire weapons for Aeros in Mech Display
+ disable most custom munitions for Aeros
+ disallow firing of weapon bays whose weapons are completely out of ammo
+ default icon for aerodyne dropships
+ Aerospace subphases for movement
+ added Small Craft and Space Stations
+ changed Fighter files to account for Artemis-IV capable ammo
+ Fixed munition reading problem in bay weapon ammo
+ changed Dropship files to account for Artemis-IV capable ammo
+ changed Jumpship and Warship files to account for Artemis-IV capable ammo
+ fixed angle of attack modifiers for regular aero movement

v0.33.26 (2008-05-28, 23:23 GMT+2)
+ Bug 1966400: Vehicle CASE/CASE II not working if attack destroys location
+ RFE 1941889: (i)Narc hit locations
+ Correct missile ammo for artemis 3058U tanks
+ Bug: BV calculation on heat efficient mechs did not factor in Artemis IV
+ Bug 1966507: Support vehicle BAR not used in game
+ Synchronized Swing and AWT as of 5/21/2008 (water/ice landing in bridge 
	hexes and large support vehicles)
+ Patch 1967302: Lower Atmosphere, Space Maps (MA integration)
+ Bug 1967351: MGA damage scatters
+ Bug 1966554: SN PPC doesn't need field inhibitors
+ Bug 1966560: Vehicle-mounted PPC capacitors not counted for heat sinks
+ Bug 1966712: crash w/ sending artydisplaypacket and player disconnected
+ Bug 1970865: Broken pipe error
+ Bug 1951561: stunned crew making actions they shouldn't be able to
+ Re-added commandline nukes
+ Bug: Falling on ice makes unit end up underwater
+ Patch 1971927: MegaAero Integration: Aero Entities and Displays
+ Bug 1975641: Hot-loading Thunderbolts vs. last shot in ammo bin

v0.33.25 (2008-05-18, 14:42 GMT+2)
+ Bug 1961220: MG array damage vs. infantry too low
+ Bug 1961295: RACs and UACs should still fire for the turn that they jam
+ Bug 1947072: Direct-fire artillery timing
+ Bug 1638857: displacement into building results in no damage
+ Bug 1890857: Off-Board Artillery Not Working for gunnery emplacement that need
    to turret twist to shoot their target with arty
+ Bug: PSRs needed for movement show wrong to-hit for skid PSRs
+ Bug 1962319: Clan LRT 16 shares internal name with LRT 15
+ Bug 1952416: 'Hunckback' typo
+ RFE 1961430: Artemis/Narc-equipped units lacking compatible ammo
+ Bug 1961368: PPC capacitor has no effect when firing
+ Start of Support Vehicle implementation
+ Bug: Don't halve missile damage twice for reactive armor
+ Bug 1963064: Aimed shots at immobile vehicles not implemented
+ Bug 1961423: CN9-YLW2 image reference broken
+ Bug: Report MaxTech weight class modifier for kick/push PSRs in phasereport
+ Bug 1949414: Noncritical rotor hits cause critical damage
+ Bug: When falling onto ice, fall elevation was calculated wrong
+ Bug 1961233: PSR for pilot damage counts gyro hits multiple times
+ Bug 1944667: Bad defaults when configuring some missile types
+ Data 1947198: 3058U IS meks and vees
+ Bug 1963577: Reactive armor reporting error
+ Bug: Energy weapons should not be able to hit in blowing sand weather.
+ Bug 1947673: Jumping onto bridges causes PSR
+ More work on Support Vehicles
+ Bug 1891505: Falling Damage Calculated Incorrectly
+ Bug 1963924: WiGE lands mid-turn on sideslip
+ Bug: ATM 9 should cause 6 heat
+ Bug 1966165: Fragmentation missiles do too much (!) damage to infantry
+ Bug 1966086: No critical hits on just-destroyed locations
+ Bug 1965864: Supercharger weight not accounted for in verifier
+ Bug 1966400: Vehicle CASE/CASE II not working if attack destroys location

v0.33.24 (2008-05-09, 22:36 GMT+2)
+ TW changed avoid-damage-from-autofall mods to +5 for leg destroyed and +6 for
    gyro destroyed
+ TW change: the +1 modifier per level fallen for avoiding Mechwarrior Damage
    during a fall is per level above one, not every level.
+ Bug 1955526: Glancing Blow Rounding Inconsistency
+ Attempt to fix some artilery bugs, and some inferno srm bugs.
+ Handle an exeption for missing files while drawing hexes.
+ Bug 1959257: IS light MG 'out of range' at long range
+ Bug: double PSRs when entering a minefield triggers a PSR
+ Initial WiGE implementation.
+ Added Hiryo WiGEs from Jihad Hotspots: 3072
+ Bug: WiGE costs for moving up/down hills wrong
+ Bug: WiGEs should be able to go down as many levels as they want
+ Bug 1959563: 'Mechs misreported as unsalvageable
+ Bug 1960001: Vulcan VT-6C - no Light Machine Gun Ammo
+ WiGEs can spend 2 MPs to stay at current flight level when moving over a down-
    wards level change
    WIGEs need to start their movement with a "Go Up" step to start, this costs
    5 MPs. To use the "spend 2 MP to keep altitude when going over a cliff"
    rule, climb mode needs to be activated and be in the "keep elev" setting.
    In the hex before you again reach terrainof the original height and/or if
    you don't want to spend the extra 2 MPs per hex moved to keep the elevation
    anymore, click "climb mode" again to use the normal movement rules for 
    elevation and spend only 1 MP per hex moved.
+ Bug: Shut down server correctly when savegame loading fails.
+ Bug: WiGEs should crash when reduced to 0 MP while flying
+ Bug 1960932: Incorrect PSR for pilot damage when being pushed down a chasm

v0.33.23 (2008-04-30, 17:30 GMT+2)
+ Bug 1947060: Leftover vehicle damage bugs
+ Bug 1947285: Aimed shot hit location oddities
+ Bug 1948927: Confusing report on Narc vs. Stealth
+ Bug 1947634: VTOLs at level 2 can pass through light woods
+ Bug 1947204: Hot-loading Thunderbolts no longer works
+ Bug 1947075: Sloth BA missing second laser
+ Bug 1935565: Death From Above with target in water automatically fails
+ Bug 1949088: Rocket Launcher 15 and 20 have wrong ranges
+ Bug 1949195: Damage vented by vehicle CASE shouldn't cause critical hits
+ Bug: Mechanized infantry should need 2 MP to enter buildings
+ Bug 1949421: Ammunition hits should destroy vehicle Gauss ammo
+ Bug 1949684: Fa Shih BA shouldn't ride non-Omni VTOLs
+ Bug 1949602: A couple more duplicate vehicle crits
+ Bug 1949558: Mechanized infantry should follow terrain restrictions
+ Bug 1949453: Inferno damage vs. infantry too low
+ Bug 1950404: Vehicles destroyed by ammo explosion listed as salvageable
+ On weapon destroyed Tank crit, improve auto-choosing of weapon that's
    destroyed. When the attacker should choose, the highest BV weapon is chosen,
    when defender should choose, the lowest BV weapons is chosen.
+ Bug 1951149: melting ice -> units don't fall from ice to bottom of water
+ Bug: Fix NPE in WeaponAttackAction#toHit when targeting an ice/water hex for
    clearing    
+ Bug 1951620: Vehicle CASE blows off wrong armor on turret hits
+ Bug 1951811: PSRs due to damage not reported
+ Fix a whole lot of missing reports
+ Bug: Swarm missiles could cause a ClassCastException when firing the last shot
    of ammo in a ton.
+ Bug: Fix double blind report error
+ Bug: Fix report error when targeting a building with infernos
+ Bug: correctly report remaining ammo in end-of-game unit status report
+ Bug: Rapidfire AC doesn't generate heat

v0.33.22 (2008-04-19, 23:30 GMT+2)
+ Better text for artillery adjust/autohit hex tooltip
+ Bug 1931634: Vehicle CASE has no effect
+ Bug: Fix Kobold single trooper weapons for real
+ Bug 1932743: Single trooper BA weapons unnecessary complicated
+ Bug 1934051: AMS working on shutdown units
+ Bug: Tank crit "commander hit" should also cause effects of crew stunned
+ Bug 1936068: Buildings Damage Errors
+ Patch 1936898, Bug 1934990: Errors when loading HMV submarines 
+ Converted Phases to an enum type.
+ Display artilery hits and targets for the turn after the effect.
+ Possibly fixed the first turn bug in mekwars.
+ Bug: createSpecialHexDisplayPacket trying to use a push() method
+ Bug 1941348: Targeting computers still follow BMR rules
+ Bug 1941890: Infernos used up at double rate
+ Bug 1940670: Screwy vehicle criticals
+ Bug 1941589: MML Ammo gets no Narc bonus
+ Bug: Sylphs starting movement over water must incorrectly first move up to
    continue moving
+ Always search for boards in subdirectories, too
+ Bug with Artillery building damage report fixed
+ Added default image for submarines
+ Added image for Neptune Submarine
+ Bug 1944653: OmniVehicles missing battle armor handholds
+ Bug 1944670: Hot-loaded Thunderbolts do only half damage at minimum range
+ Bug 1944667: Thunderbolt ammo wrong
+ Bug 1944653: Set OmniTanks and OmniVTOLs to actually be Omnis when loading 
    from BLK.
+ Bug 1946544: Too many driving skill penalties from mobility hits
+ Bug 1945587: Physical weapons do full damage vs. infantry
+ Bug 1946560: 'Stop Swarm Attack' not working
+ Bug 1946565: Swarming conventional infantry shouldn't get TACs

v0.33.21 (2008-04-01, 00:47 GMT+2)
+ Bug 1718067: Physical attack against VTOL does not destroy rotor
+ Fix elevation checks for physical attacks against flying VTOLs
+ Bug 1748780: Glancing hit crit penalty not applied with transfered damage
+ Bug: don't grant +1 mp for tanks when skidding onto a road, and we didn't
    start movement on pavement
+ Don't show "+" indicatin extra MPs for tanks when they don't actually get them
+ Bug 1784026: ECM,ECCM and C3 issues
+ Bug 1584013: Reworked how ECM/ECCM/Angel ECM calculations work
+ Added IS Medium Laser cost
+ Bug 1817504, 1785731: PSRs wrong when moving under bridges.
+ Bug: Fix bridge on battleforce2 map
+ Bug: Hovers falling into water when breaking through ice
+ Bug 1908899: bug with climb mode and bridges in turn of mode change
+ Bug: multiple ammo weapons of the same type firing even when only one shot of
    ammo left
+ Bug 1915252: Kobold BA has weapon on whole squad instead of on single trooper
+ Bug: prevent division by zero in BV destroyed victory checking
+ Bug: Streak misses possibly ignite woods
+ Bug: Punch at flying VTOLs possible if level difference is 3
+ Moved submarine unit files from unsupported directory, they should work
    correctly
+ Show submarine depth next to unit name, like flight level for VTOLs
+ MASC weight and crits are rounded up to the ton or crit with TM
+ Bug 1897182: swing UI missing selected hex/unit cursors

v0.33.20 (2008-03-04, 12:32 GMT+1)
+ Bug: Victory NPE in Scenario games
+ Bug: transported entities don't unload correctly when transporter dies
+ Don't calculate ECCM stuff when game option is not set
+ Bug 1902346: Clan LRM 16 has same internal name as Clan LRM 15
+ Bug: glancing blows often not reducing damage by half
+ Bug: torpedoes not loading correctly from HMP/HMV
+ More fixes to calculate BV of damaged units correctly
+ Bug: split weapons able to fire if arm destroyed and weapon split across arm
    and torso
+ Bug: Fix artillery reports
+ Bug: Torpedoes not working
+ Bug: Enemy commander destroyed now actually means all enemy commanders 
    destroyed, instead of "last commander standing"
+ Bug: victory triggering in single-player game even when check for victory game
    option is disabled
+ Bug 1880496: NARC-asissted indirect fire taking spotter firing penalty
+ Bug: Narc/INarc Pods not removed on location destruction
+ Bug 1903999: Bot attempting Charge/DFA when not possible
+ Bug: Edge (Deep) deployment zone not working
+ Bug 1878787: Reflective Armor still not perfect
+ Fix special armor reports
+ Bug 1809070: ECM not breaking std C3 links
+ Bug 1806961: C3i and ECM handling
+ Fix C3/C3i link drawing

v0.33.19 (2008-02-26, 2:13 GMT+1)
+ Patch 1865696: Weather effects
+ Patch 1890761: RPG Skills
+ Bug 1890785: Fragmentation LRMs/SRMs not working right
+ Bug 1890845: some Protomech LRMs missing
+ Show swamp in tooltip
+ Bug: Fix NPE with swarm missiles
+ Bug: Fix NPE in BoardView
+ Bug: Fix victory checking
+ Bug: Fix SingleChoiceDialogs in Swing UI
+ Bug: Fix flamer damage against infantry
+ Bug 1897329: maps from subdirectories cannot be found
+ Bug: Prevent NPE when gameoptions.xml is corrupted
+ Fix Frag missiles for real
+ Bug: minor bug with VTOL BVs.
+ Calculate ingame BV based on current MP, not factored for gravity
+ Bug: Rapid Fire MG against conventional infantry used too much eat and ammo
+ Bug: Flechette ammo doing half damage when clearing
+ Bug: Fix swing ammo choice in mechdisplay
+ Bug: Frag ammo not doing damage to woods
+ Bug: when using assault drop and deploying last assault-drop-capable unit 
    using assault drop, further non-assault-drop-capable units couldn't deploy
+ Bug: flechette ammo AC shots got their damage halved twice agains hardened
    units
+ Some code simplification in weapons firing code
+ Fixed a bug in MechSummaryCache for saving unit file name Used by MekWars 
+ Bug: pilot damage from heat not applied correctly, and not reported correctly
    when MaxTech heat is used.
+ Bug: Fixed a few report errors.

v0.33.18 (2008-02-14, 23:31 GMT+1)
+ Bug: Flechette and Frag ammo not doing full damage to Infantry
+ RFE: Force Victory skips all units in every phase to end game.
+ Bug: BattleArmor being effected like Infantry against Frag and Flechette
+ RFE: Moved Force Victory option to top of the victory group
+ Plasma Rifle and Plasma Cannon also deal half damage to pain shunt infantry
+ RFE: MechSummary now saves and retrives entity files based on file name as
    well as just entity mode+chassie
+ Bug: multiple weapons of same type using up one of several ammo bins sometimes didn't work correctly
+ Removed duplicate weapons for Protos
+ Remove StackPole Removal Code. Was no longer needed
+ Fixed javaDoc for Server.destroyEntity();
+ Patch 1889352: Scenario Updates
+ Patch 1889029: Save MD abilities to XML
+ Bug: Artillery damage to BA
+ Fix FLAK artillery against VTOLs
+ Patch 1889327: Random skill generation
+ Patch 1889714: initiative bonuses
+ Bug 1889760: SRM damage vs adjacent building
+ Changed MechSummaryCache to save sourceFile.getFileName() as the m_fileNameMap key  
+ Bug: fix report order when igniting hexes
+ Bug: Maps no workie cannot be loaded
+ Bug 1881340: NPE when checking for Victory after loading a savegame
+ Bug: Infantry Laser (ie. Energy Rifle Infantry) should have 2/4/6 range
	
v0.33.17 (2008-02-01)
+ Bug: Flamers causing 3 heat instead of 2
+ Bug: Swarm LRMs causing ammo-use and heat for each target they hit
+ Cleaned up warnings in Mech.java and MechSummaryCache.java
+ Bug 1878681: All missiles showing "ECM Prevents Bonus"
+ Fix PSR reason when skidding on ice that also has pavement (ice is above the road)
+ Bug 1879828: RAC firing to many shots
+ Updated HACKING file
+ Bug 1880143: swarming infantry can damage themselves
+ Merged refactor server branch: Refactored Victory Conditions, easy to implement new ones
    Should work just the same
+ Bug: Field gun infantry BV way too high
+ Bug 1878790: Fuel Tanks locking Server
+ Bug: RACs and Ultras not jamming correctly in 2-shot/Ultra mode
+ Bug: DFM LRM/SRM/MML ammo not working correctly
+ Bug: Follow the Leader LRM/MML not working correctly
+ Bug: Tandem Charge SRM/MML not working correctly
+ fixed some warnings
+ Bug: All !Draw Victores showing as Draws.
+ added Tooltips back to Swing gui
+ Bug: HGR PSRs not working
+ Added Starterbook Sword and Dragon units with prototype equipment
+ Bug: damage during swarm attack should be applied as one lump
   NOTE: this is not working completely correct, right now it's one lump and one location
   per weapon the attacking BA squad is carrying, not one lump of damage overall
+ Bug: clearing woods should always do full damage
+ Bug: do damage to woods from artillery shots
+ Patch 1883999: Manei Domini VDNI, BVDNI, and Pain Shunt
+ Patch 1875860, Bug 1776718: Double Entries in the Mek selection search
+ Data 1879903: New Artillery Gifs and a Resized Mechwarrior Gif
+ Bug 1882694: Map rotation error
+ Bug: movement along road not checking destination hex for road, too
+ Physical Attacks against Infantry should do only 1/10 damage
+ Bug: Draw occuring on Team Game Victories

v0.33.16 (2008-01-19, 18:45 GMT+1)
+ Patch 1869642: Clan Streak6 Heat Fix and Recoilless Rifle Name Change
+ Fixed Server.writeInitiativeReport(boolean) for DB. Will show all players
	rolls without Individual Initiative on but not player unit turns. With
	Individual Initiative on only the Inititative of units that are visible 
	to the player will be showing.
+ Added missing IS BA Magshot Gauss Rifle
+ Fix MaxTech Rapidfire AC option. Note: With submunitions, the special effect
    currently does not work when using rapidfire.
+ Bug 1869698: Custom BA editor no longer functional
+ Bug 1653277: Proto movement in cities
+ Bug 1749177: Can't kick adjacent infantry
+ Bug 1745274: allow all weapons to be fired at clear hexes to raise heat
+ Bug: Infantry Rifle long range wrong
+ Bug: Fix Narc/iNarc report bug
+ Bug: External heat for plasma weapons and flamers not capped at +15
+ Bug: Fix leg attacks
+ Have less verbose megameklog when catching IOExceptions in AbstractConnection
    #update()
+ Fix rounding issues with anti-infantry damage
+ Added isAntiMek() to Infantry class.
+ Bug: MG infantry should do d6 extra damage to conventional infantry
+ Bug 1870439: Broken BA weapons
+ Allow right-click-drag scroll also in offboard firing phase if option is set
+ RFE 1742627: pop up message when firing will change previous to-hits
+ Bug 1685545: BA Mine Launcher doesn't work
+ RFE : MTF files are loaded more dynamically
+ Bug: Allow for tank weapon malfunctions and turret jams to be fixed.
+ RFE : MTF files loaded at 95% dynamically
+ Bug: Not removing unjammed weapon from jammed weapons list.
+ Do weapon malfunction repair and turret unjam in the server
+ Bug: Fix Heavy MG range
+ Bug: units in ground zero of a Davy-Crockett M attack not destroyed
+ Bug: Fix some AMS issues
+ Bug 1741939: HMP problems with laser AMS
+ Bug: Infantry LRM has wrong range
+ Bug: Fix MGA issues
+ Remove old MaxTech infantry damage option
+ Bug 1870305: Guided Arrow IV not working.
+ Bug: Report error with artillery when attacking unit dead or fled when arty lands
+ Bug: Taggers not allowed to shoot when no arty units left in game, but an 
    homing arty attack in the air

v0.33.15 (2008-01-11, 20:35 GMT+1)
+ Swing GUI: elevation/depths listing added back, 
	made combobox initial state in some dialogs make more sense.
+ Swing GUI: center on hex works correctly now, also, drag-scroll works again.
+ Bug: damage to woods using old clear terrain code by subtracting damage from
    14
  then subtracting that number from the current terrains CF
+ Bug: Flechette ammo not doing double damage to woods
+ Bug: Fragmentation ammo not doing double damage to woods
+ Bug: Missiles not hitting for full damage against woods
+ Bug 1859840: Leg damage in Partial Cover
+ Bug: Last Entity Targetted was not being saved
+ Bug 1862748: 0.33.14 dev incorrect handling of cluster weapons
+ Bug: LAC not using AC special Munitions.
+ Bug: Infantry flamers can't cause heat and have wrong range
+ Bug: Missing BA MGs
+ Bug: Under a variety of circumstances savegames would stop working
+ Bug 1853753: Reflective armor not working
+ Bug 1866014: Arrow IV fireing double Shots
+ Bug: Fix clearing woods
+ Data 1865963: Updated BA Files
+ Data 1843823: White Flame sprite
+ Data 1845005: Solaris Map Update, corrected Boreal Reach map and Colosseum
    in chaos mode
+ Data 1831037: Vehicles from 3050 Upgrades
+ Bug: Artillery only doing splash damage
+ Bug 1858586: AP Gauss Rifle doesn't read ammo 0.33.14 dev
+ Bug 1857824: double blind weapons fire results don't show in turn report
+ provisional infantry BV 2.0

v0.33.14 (2007-12-28, 21:05 GMT+1)
+ Malak Dominus fixed
+ Bug 1851887: NPE with bot and PPC weapons that can't have a capacitor
+ Partial fix for Bug 1852029: client crash when deploying c3i units
    now only happens when c3i units are actually on a network
+ Bug 1852058: flags in weapontype don't work correctly
+ Bug 1853433: energy weapons glancing blow causes no damage
+ Bug 1853428: adding a bot takes very long
+ updated ai-readme.txt
+ Fix AMS
+ only allow 5 arty-autohit-hexes
+ fixed the phase tabs on the Swing gui
+ "Driver Injured" does not work properly
+ Refactored the Server.damageEntity function for readability.
+ Fix bug with C3 lines. TODO: some lines are not correctly removed
+ Fix Plasma Rifle and Plasma Cannon
+ Fix Clan Narc Techlevel
+ Fixes and improvements to some client commands.

v0.33.13 (2007-12-13, 21:34 GMT+1)
+ Fix lock when sending large packets
+ Patch 1830744: doubleblind improvement
+ Don't center on artillery unit's location in artillery firing phase when that
    unit is offboard
+ Reverted all network changes for now, until we have stabilised them
+ Infantry shouldn't sideslip
+ Bug 1839351: No vertical scroll on initial help screen
+ Show when ammo is dumping in system view.
+ Bug 1841267: Consciousness rolls should be made immediately, not at end of
    phase.
+ added Mounted.getBaseDamageAbsorptionRate() for MW Use
+ added Mounted.getBaseDamageCapacity for MW use
+ fixed initial board paint problem (partly related to network fix) and put
    back LOS Ruler and keyboard scroll
+ Fix infinite loop with c3 line drawing.
  TODO: when the c3 master moves first, lines are not updated correctly
+ Add unofficial gameoption to specify from which round onwards ammodumping is
    allowed
+ merged weapons refactoring branch
   NOTE: This necessitated the removal of command-line nukes
   NOTE: there might be some bugs lurking in weapons firing code, report them as
    you find them
   NOTE: They'll now be a whole lot easier to fix.
+ Bug 1811135: iNarc homing pods not allowing indirect LRM fire.
+ Bug: indirect fire using narc homing pod was getting +2 on the cluster table
+ Bug 1747264: AMS engaging Swarm missiles (fixed with weapons refactor)
+ Bug 1690655: BA Flamers should be able to cause heat
+ Bug 1630629: Conventional SRM Infantry number of Inferno missiles (fixed with
    weapons refactor)
+ Improved LOS-Tool. If both hexes contain a unit, the respective unit's
    current height will be used for the calculation
+ Bug: mechs always had elevation 1 when in a hex with a building
+ Bug 1775622: Hovers sink in broken ice hex

v0.33.12 (2007-11-09, GMT 22:21 GMT+2)
+ Corrected names of the Celestials
+ Tanks movement not getting adjusted for carried cargo
   when not in extreme gravity
+ Patch 1830140: AWT/swing redrawworker improvement
+ Bug 1831073: B-Pods should explode upon crit
+ Major change to Swing GUI.  Four major issues remain:
  a) the initial board paint won't display until a redraw is forced.
  b) keyboard scroll and right click scroll have been disabled.
  c) zooming does not work.
  d) LOS Ruler has been disabled.
+ Synchronized AWT and Swing GUIs to current date (11/15/07)

v0.33.11 (2007-11-09, 15:26 GMT+2)
+ Bug 1748167: Spot-and-fire penalty being applied to TAG/Semi-Guided
+ Updated equipment.txt
+ Automatically generate equipment.txt whenever ant is used to compile MM.
+ Fixed NPE in MiniMap when using the board editor
+ Bug 1817499: Falling on bridges not working right
+ Bug: Deploying on bridges now gives correct elevation
+ Bug: 1746114: 'Free' standard flamers on vehicles?
+ Bug 1806296: Vehicle critical hits problem
+ Bug 1806550: A-Pods can fire multiple times
+ Data 1787475: Tallassia Mapset with original Mapnames
+ Data 1801670: 3050U IS Mechfiles
+ Data 1794069: Missing Mechfiles
+ Data 1789446: Celestial Invictus Omnis
+ Bug 1714093: NPE in BrushOffAttackAction in certain situations, removed most 
    Vectors from BoardView1
+ Bug 1678555: Illegal Number Format when an anticipated Game option input is
    empty, defaults to 0 now
+ Added the Celestial Dominus variants and some pics for them
+ Bug 1824240: Pilot has been picked up with 2 different units
+ Minor refactoring, yay Javadoc!
+ Fix BV bug for Mechs, explose equipment did not subtract correctly in most
    cases
+ Bug 1600957: Selected boards could be null (our placeholder for "surprise") 
    which caused an NPE in some cases
+ Sometimes our target loses it's position, causing the display thread to throw
    an NPE
+ Bug 1587654: NPE resolving nuclear effects on offboard units
+ Patch 1827968: swing minimap and network improvements
+ More Celestial images
+ Updated build.xml to allow automatically built client releases

v0.33.10 (2007-10-28, 16:13 GMT+1)
+ Implemented Retractable Blades. TODO: make them actually retractable (should
    be able to retract or extend at end of movement, no pushing/punching or
    carrying stuff when extended, no physical attack when retracted.
+ Mechs with extended retractable blades can't push or punch (no way to retract
    the blade currently)
+ Bug 1787586: Plasma rifles not causing damage (0.33.9)
+ Bug: Abandon Crew Message being reported on Tanks with dead crews.
+ Bug: Inferno Infantry hitting with twice the number of missles they should be.
+ Retractable Blade now fully Extend and Retract.
+ Bug: Retractable Blade was not getting full -2 bth mod.
+ Bug 1753636: CASE II still somewhat buggy
+ Minimap not correctly initialized with Java 1.6
+ RFE 1767865: Mapselection from folder tree - for real
+ Added Tech level to ISAPPOD and CLAPPOD MiscType Object's
+ Added Clan BPOD MiscType object.
+ CASEII and Magshot not being calculated with BV 2.0
+ Bug: Clear Hexes from heavy to light would reset TF
+ Enhancement Request from Mekwars forum: Draw markers on minimap for pre-
  designated artillery auto-hit hexes.
+ Patch 1714216: BV checking command
+ Patch 1694672: Board/map size configuration
+ Patch 1804518, Bug 1788089, Bug 1813331: Heat and min range incorrect for HAG
    30 and 40
+ Bug 1801922: Cannot charge after starting Movement Phase prone
+ Bug: Quad mule kick should only be allowed to the rear arc, not the side arcs
+ Bug 1806055: C3 Master and Advanced Search
+ Bug: After reset, starting position got set to any, but UI still showed old
    starting position
+ Bug: when changing a game option that possibly changed BV (like force-size
   mod), BV displayed in the chatlounge didn't change
+ Skidding Bug: Hex just entered counted for distance.
+ Bug 1751666: Made the option apply only to 'Mechs as per suggestion of 
    initial submitter.
+ Enhancement: Show both base BV as well as BV modified by force modifier for
    each player.

v0.33.9 (2007-09-02, 17:47 GMT+2)
+ NPE in SearchlightAttackAction.java
+ Changed Font.SANS_SERIF to "Sans Serif" in ChatLounge.java
+ Syncrhonized Swing and AWT side.  Swing BoardView1 still needs work.
+ Bug 1753425: Correct cost of MRM40(OS)
+ Patch 1758243, Bug 1734691: LOS walking "both sides of the fence"
+ Added new piloting skill multiplier which will be featured in an upcoming
    errata, derived from BV2 version of HMP
+ Bug 1758296: Cost of Special Ammo Types
+ Allow piloting and gunnery skills of up to 8
+ Corrected Locust IIC 6 file to make MGAs work
+ TM rule change: FF armor points now round down
    This makes lots of existing mechs illegal, because they have one point of
    armor too much. We need to recheck our units against TRO3050U (or better,
    the forthcoming RS:3050U).
+ Allow sorting the MechSelectorDialog by Level
+ Bug MtfFile.java was case specific for Split and R weapons.
+ Prevent NPE when spotting and no target selected
+ Bug 1762455: Unable to fire if previous mek uses SL
+ Bug 1757632: Plasma Cannon Damage for clearing incorrect
+ Bug 1756810: Plasma Rifle damage incorrect
+ Bug Clan MGA's had the wrong racksize. Ammo would not load.
+ Bug NPE when calculating Tank BV on the fly in games for excessive ammo
+ reverted common.actions.PushAttackAction.java back as it was throwing
	exceptions and not checking if te was null instead of returning 
	ToHitData.IMPOSSIBLE. This caused a players to be disconnected Meks
	where near buildings.
+ Jump Boosters causing an invalid unit erorr when Jump was greater then run
+ Bug: Plasma Cannons not delievering heat on a glancing blow.
+ Backed out patch 1758243, caused lots of LOS bugs.
+ Added several new server commands, most are intended to enable megamek to be 
    useable by visually impaired people, but some of them (ruler forinstance) 
    should be useful to normal users too.
+ ejected MechWarriors don't need to make consciousness rolls now
+ Bug 1771542: MASC bug
+ Fixed a null pointer server crash releated to the camo image in swing. Note
   that the	camo image is still behaving very odd.
+ Begun making client commands in the swing GUI. Client commands start with a #
+ Help command for client commands added.
+ More client commands and slight improvements to chatting using the swing GUI.
+ Added the replacePlayer command as both a server and as a client command.
+ Bug: Plasma weapons causing NPE when targetting Woods/Buildings.
+ Bug 1777145: Option bridgeCF changes all CFs on map
+ Bug 1755219: PPC capacitors now load from HMP/HMV files
+ Bug 1748916: stabiliser crits now skipped if location has no weapons
+ Fix VTOL armor display
+ New victory condition "commander killed", where a force can win by defeating
    all enemy command units.  Command units are configured by customising in
    the lobby or in the scenario file (see example.mms).
+ Added unofficial option to allow Tanks to use level 3 targeting systems, too
+ Bug: unload stranded units turn was being skipped, so infantry couldn't get
    out of immobilie APC
+ Set starting position to Any after /reset
+ Infantry entering boggy terrain now handled correctly
+ Bug: ISLMGA had extreme range set to 4 instead of 8
+ Bug: BattleArmor was ignoring stealth armor

v0.33.8 (2007-07-16, 21:00 GMT +2)
+ Bug 1726461: Indirect Fire +1 for spotter missing
+ Bug 1726513: Spotting for multiple Units
+ Bug: NPE error caused with units loading Semi-Guide for MekWars Servers
+ Bug 1727343: Multiple Targets for BattleArmor
+ Bug 1726672: AP Gauss is clan, but it's ammo is IS
+ Bug 1727244: Lobby Battle Value != In-Game Battle Value
+ RFE 1726259: Option disable force size BV multiplier
+ Cleaned up batchall.de.zip: removed no longer needed units
+ MG arrays now work, LCT-5T mechfile updated
+ Added TeamCommand allowing players on the same team to speak to each other in
    game
+ Bug: Visibility limiting BAP range.
+ changed TeamCommand command from /team to /t make it easier to type. 
+ Made Server.sendChat method public so TeamCommand could access it.
+ Started adding code for PPC Capacitors.
+ Added PPC Capacitor.
+ Bug: PPC not exploding when critted and Capacitor is charged.
+ Added Reactive Armor
+ Added Reflective Armor
+ Added CASE II
+ Bug 1745050: Water partial cover vs. physical attacks, should be +1, not +3
+ Bug 1742624: NPE when calculating BV of Plasma Rifle Ammo carrying units
+ Bug 1736000: Bugs with the Plasma Rifle
+ slight (very slight) improvement in bot speed, cleaned up some code in the 
  ui while looking at ways to finish the swing conversion
+ Added validate command line option to validate files in data/mechfiles quickly
+ Bug: Unit could enter walls that where taller then them as if they where 
    buildings.
+ Improved breach reporting
+ Fix ammo BV for protos, dbv multiplyer now correct for super fast units
+ Bug: if missing entry in mechset.txt or wreckset.txt map does not load. Will
    now default to light mech image and print an error message to STDERR
+ Bug: Silver Bullet Gauss says Missiles instead of projectiles in firing phase
+ added more fixes to db messages
+ Code cleanup (more javadoc, more generics, few small bug fixes, etc)
+ Partially working AirMechs.
+ Bug: Fuel tank explosion causing NPE
+ RFE: Skip all MG's when linked to an MGA
+ Bug: NPE when getting proto BV.
+ Bug: doExplosion() could have a 0 length myDamages array.
+ RFE: do not rotate rectangular Maps.
+ Bug 1747502: NPE: Mek designed with TAG/C3M and semi-guided missiles
+ Bug 1732189: Fixed two read errors committed into HMVFile during unused 
   variable cleanup.
+ Different speed factor calculation, depending on speed, as per the rules
   question forum

v0.33.6 (2007-05-26, 20:00 GMT +2)
+ added some javadoc documentation. This is a work in progress.
+ Made pilot BV fetchable as a static function in case someone wants to 
   implement requrest #1636523
+ Fixed a null pointer exception.
+ Bug 1706265 fixed
+ Added House rule MW pilots cannot spot.
+ RFE 1701138: Spotting and firing
+ Bug: NPE in multi player game where a player ejects and disconnects.
+ Found the Real cause of above bug. Caused when adding new Removal Cause. 
+ Fixed it this time for sure!
+ Bug: Meks could skid into wall hexes.
+ Bug: Meks that fell while on a wall fell to the bottom of the wall hex
+ Correct weight on Clan Machine Gun Array
+ Added the rest of the RS:PPU 'Mechs.
+ Corrected tech on CLIJJ
+ Patch #1705501: Bot ammo/color can be changed in chat lounge.
+ Bug 1706879: Megamek thread problems when changing teams
+ Added save-to-XML functionality to weapons.
+ Per rules clarification/change, HAGs cannot make targetted shots with a TC.  
+ Patch #1707730: ER Pulse BV Correction
+ Bug: Victory conditions used the first player in the winners Map as the 
  winner even if they didn't accomplish all the objectives. This only occurs
  in games with more then one victory condition.
+ Bug: MML torpedos did not work under water.
+ Bug: C3 and C3i where able to use level 3 targeting systems
+ Begingins of a LAM implementation.
+ Significant reduction in compiler warnings through refactoring.
+ Removed some unused functions
+ Data 1713994: Mechs from Starterbook: Sword and Dragon
+ Data 1577478: Solaris VII Mechs from 3055U, still missing:
  Copperhead (reflective armour not supported)
  Flashfire (reflective armour not supported)
  Longshot (reactive armour not supported)
  Silver Fox (reflective armour not supported)
  Aquagladius (Battlemech Taser not supported)
  Spatha (reflective armour and PPC Capacitor not supported)
  Sasquatch (large engines not supported)
+ Data 1667079: Fury, Lightning, Puma, Zephyr, Kanga, Burke and Chaparral tank 
  images
+ Data 1579068: some new Mek Images
+ Data 1577478: Most 3055U L3 Solaris Mechfiles
+ Added Generic <Entity> to Entity.getKills(), was causing Warnings in MW 
+ Fixed various ammo and weapon BVs per the table in TechManual
+ Bug: No PSR roll when Jumping in Low Gravity.
+ Bug 1725205: Damage applied to wrong facing on failed entry into buildin

v0.33.5 (2007-04-14, 19:12 GMT+1)
+ Fixed Pouncer Prime name in MTF
+ Added IS MGA
+ Added 4 Battle Corps Mechs
+ Added unit list export command
+ Added Preta Dominus
+ Bug 1686313: HAG/40 now splittable
+ Added Marauder IIC 4
+ Juggernaut image misnamed.
+ Fix BV 2.0 bug where one-shot weapons counted for their BV plus a full ton
   of the respective none-one-shot weapon's ammo.
+ Added BV Force size modifier for BV shown in the chatlounge.
   For games with more than 2 players, all units that are not in your team are
   counted as the opposing force.
+ Bug 1695464: C3 Master not in equipment list of advanced search.
+ Bug: rear punches to quad mechs now do hit rear locations instead of front
   locations.
+ Added a couple more RS:PPU 'Mechs
+ Corrected RS:PPU 'Mechs to be level 2 rather than 3
+ Added House rule that Mechwarriors on the field only have 1 hex vis in double
  blind games
+ Corrected internal structure points for meks<=20t (they missed 1 point in the
  legs)
+ Reverted last change, developer was half-blind :|
+ Added Building type Wall(5) Units can stand on but not enter.
+ Fix C3 extra BV error.
+ Added IEntityRemoveCondition REMOVE_STACKPOLE for units that where completely
  destroyed. This is used by MekWars.
+ Bug: Hexes with collapsed walls not reverting to rubble.  
+ Added MaxTech Walk Backwards rule option
  
v0.33.4 (2007-03-24, 23:00 GMT+1)
+ Bug: tool tips not displaying in ice hexes
+ Bug 1624745: Vehicle crew created when Battle Armor destroyed
+ Bug 1627200: Div by Zero Exception in Random Unit Generator
+ Bug 1631584: Bug in TSM
+ Bug 1211496: possible to have 2 mechs in same hex with swamps
+ Bug 1453975: stuck-in-swamp mech that gets displaced can't get unstuck
+ Bug 1609577: Problems after fall from a lvl 2 collapsing bridge
+ Bug 1631584: Bug in TSM
+ Bug 1635383: Pilot takes 2 damage from Tandem Charge missiles
+ Bug: Tanks shouldn't be able to spot when stunned.
+ Bug: Victory conditions now explicitly ignore observers
  and fixed victory report error in double blind.
+ Moved BoardView1 back to AWT so that at least it works...
+ Tank critical hits - ammo explosion damage wrong
+ Tank critical hits - cargo damage applied to tank
+ MtfConvert now also converts tanks to .blk format
+ Bug: Fuel tank elevation display was wrong
+ Added a crappy image for singlehex fuel tanks to make them look different to buildings
+ Bug 1609741: Done Button Locks up when player connects and reconnects -- Again.
+ RFE: House rule added to allow players to set how much CF damage each burning
  hex takes each turn.
+ Hatchets and swords can now be aimed at punch or kick table for +4 to hit
  (sword-like and hatchet-like S7 map pack weapons are included)
+ Bug: NPE when using aimed shots for swords and hatchet weapons.
  (Now checks to make sure ce() and target are !Null before continuing
+ BV 2.0 for Mechs and Tanks and Protomechs
+ Update to BV 2.0 rules Rounding Jump MP/2 in Speed Factor Formula
+ Bug: NPE when calculating BV for excessive ammo on Coolant pods.

v0.33.3 (2007-01-03, 14:20 GMT+1)
+ Bug 1582609: Cannot load MUL that includes the TMP-3M2 "Storm Tempest"
+ RFE 1582909: "Under the effect of ECM (Stealth On)"
+ Updated rules for skids and sideslips
+ Bug 1598114: changed improved jumpjets to level 2
+ Bug 1598576: fragmentation/flechette ammo now does x2 damage to woods
+ Bug 1598976: 'Mech with Torso-Mounted Cockpit destroyed by head blown off critical.
+ Bug: fireproof armour not preventing inferno explosion
+ Bug 1591093: no units to move error when swarming infantry knocked off in accidental fall
+ Bug 1596917: CF of bridges fixed at 40. Doesn't work for scenarios yet.
+ Skidding Modifier Table expanded to speeds of up to 25 hexes in a turn
+ Building Movement Modifier Table expanded up to speeds of 25 hexes in a turn
+ Protomech physical attack renamed to Protomech frenzy attack (TW name)
+ Protomech inferno effects (from TW errata)
+ Bug 1598753 Swarm-attack damage hits swarming infantry
+ Body-mounted C3 Masters in Tanks should fire their TAG into the front arc,
  per the Ask the PM Forum.
+ Bug 954406: Charge declaration and stacking
+ Bug: VTOL should crash when sideslipping into woods at elevation 1
+ Optional house rule for pilot survival in extreme temperatures
+ TW rules change: A �Mech missing both arms and one leg may no longer attempt to stand
+ RFE 1606530: Current total BV's (& starting BV's)
+ Bug 1608682: heavy ppc inhibitor not working right
+ Maxtech clan physicals penalty (pilot option)
+ Patch 1607480: Rules Change for Shields & bug fix for Vibros
+ Patch 1607164: Bug Fix for IS Improved JJs
+ Patch 1606263: Name Patch for new PPC Types
+ Patch 1592376: Bug FIx for Follow The Leader
+ Bug 1609741: Done Button Locks up when player connects and reconnects
+ Remove unnecessary casts and elses.
+ split battle armor and conventional infantry in the unit selector
+ 1st revision of random army creator (not UI integrated yet)
+ Bug 1610484: Dangling 'if' in Server.artilleryDamageHex
+ RFE 1603578: Random army generator
+ Bug 1612873: MML5 heat incorrect
+ Bug: Fixed missing random army dialog property
+ Bug: Added check to make sure allowed BV variance (random army generation) is always positive
+ Bug: Turret blown off critical hit now destroys the tank immediately
+ Crew stunned status shown on the minimap
+ Bug: Weapon destroyed critical hit now explodes weapons eg gauss
+ Bug: Don't crash when no .board file is available and "Random Map" is selected.
+ Remove unnecessary casts.
+ One shot ammo with 0 shots left no longer illegal in verifier
+ Bug: Megamek required "Helvetica" font
+ Bug: NPE in stop swarm attack if the swarmed unit was destroyed earlier in the phase
+ Bug 1613504: Unloading BA from prone mech didn't work
+ Bug 1610653: Flying BA can be thrashed
+ Bug 1598816: Description of Game Option "Friendly Fire"
+ Bug 1623985: Swarm LRM attacks source
+ Bug: Tank BV calculation was missing misc. offensive equipment.
+ TW Rules change: AMS now works only against attacks that come from the firing
  arc the AMS is covering

v0.33.2 (2006-11-12 21:32 GMT+9)
+ Cleanup of type safety in bot code
+ Patch 1587555: Bug Fix for Heat Seeking and ThunderBolts
+ Added a number more RS:PPU Mechs
+ Added non-functional placeholder for B-Pods (so that the BLR-10S loads)
+ Bug: bot died when only unarmed targets available
+ Bug: occasional exceptions observing bot v bot games
+ Bug: missing misc equipment in equipment.txt
+ cleared a lot of warnings
+ Design year option in the add unit advanced search.
+ RAC can still hit when they jam (TW change)
+ Tank carcasses (after crew killed crit, tank remains on field)
+ Added alternate ammo names for plasma ammos
+ Refactor destroyLocation out of Server, into Entity
+ Corrected 2 RS:PPU Mechs
+ Added 4 RS:PPU Mechs
+ Woods burn down house rule now damages woods 5 points per turn instead of clearing on 11+
+ Bug 1588924: Cannot Open Custom BA Panel with Java 1.4
+ Display "CREW DEAD" on carcasses
+ Don't count C3 Masters as TAG for "no more than 1 TAG per Mech" purposes.
+ Bug 1589699: infantry with jumping MP can now be unloaded from a VTOL in flight
+ Anti-Mech skill of 8 (for an untrained unit) can now be set when customising a unit.
+ Client option to use the average skills table when adding units.
  Default is on.  Note infantry are assumed to be anti-mech trained.
+ Mechs can now move through enemy infantry
+ Bug 1589704: AMS still fires on missile attacks that miss
+ AMS are no longer allowed to be switched off.
+ Data 1589921: added some more RS:PPU mechs
+ Changed a couple of RS:PPU 'Mechs to level 2
+ Changed light & heavy FF from level 3 to level 2
+ Bug #1585497: Check for partial cover when hitting with infernos
+ Bug 1593129: Clan BA blocking CT weapons
+ Bug: wrong attack arrows removed by ESC key
+ Changed some FileDialog instances to use OS independent paths

v0.33.1 (2006-10-31 22:40 GMT+9)
+ Fix filename case for IS Omni images, so they show up on filename case-
 sensitive OS.
+ Bug 1577506: BA SRM2 launchers don't show any ammo in game
+ Bug: multiple copies of same ammo in the customise dialog
+ Bug: .BLK format omni vehicles weren't omni. (now include <omni></omni>)
+ Default images for mechanized platoons - thanks to Carpe Mortis
+ Bug: AMS was engaging HAG fire
+ Snub nose PPC range, heat and damage degradation set to TW values
+ IS light and heavy machine guns
+ Bug: unit shown "destroyed by pilot error" if the unit that destroyed it was itself destroyed
+ Bug 1577419: MMLs Cannot Load Torpedoes 0.33.0
+ Bug 1577026: Nuclear Explosion Stops MegaMek 0.33.0
+ Bug 1577420: ELRMs Cannot be loaded from TDB
+ Rules changes for Narc
+ Bug: Tanks with no turret could take turret hits and die on a 12
+ Plasma weapons
+ Pulse lasers can't be aimed with TC
+ Bug: RMG rivers are at level -3
+ BA IS ER medium laser and improved sensors
+ Data 1581617: New and Corrected BA
+ Bug: NPE with infantry LRM
+ Non infantry vs infantry damage
+ Corrected some conventional infantry unit files.
+ Bug: tank verifier didn't understand level 3 armour
+ Change TC aimed shot check to check for F_PULSE flag.
+ Don't explode non-explosive ammo when a tank gets a Ammo Explosion crit.
+ Bug 1581512: LAC/2 and LAC/5 won't load from TDB Files
+ Light AC changed from level 3 to level 2
+ Bug: swarming mek could hit itself by "getting in the way" of damage
+ Bug: ammo explosion from heat could select an empty bin
+ Bug 1584814: check game option for fire is enabled before creating fires.
+ AP gauss
+ Changed new PPCs from level 3 to level 2
+ Fix break in fire processor
+ RFE 1585612: Add info on why a mech is invalid
+ RFE 1585610: Mark mechs with multiple TAG units as invalid
+ Bug: mule kicks used front leg criticals to detemine damage instead of rear
+ Patch 1556051: 
+	Silver bullet gauss rifle (aka IS HAG/15) from unbound
+	Dead fire missiles from THB
+	Heat seeking missiles from maxtech
+	Tandem charge SRMs from THB
+	Follow the Leader LRMs from THB
+ Update build.xml to work with retroweaver 1.2.5, updated retroweaver rt lib to 1.2.5
+ cleaned some unused variable warnings
+ BattleArmor can now be saved to BLK file. 
+ Custom BA dialog has a new save button.
+ rule change: TAG is no longer exclusive with weapon fire
+ rule change: Semi-guided can be fired as standard at a non tagged target
+ rule change: infantry have no movment modifier when spotting
+ build.xml updated with svn targets
+ fix to sylph upgrade BV and fenrir ERML model name

v0.33.0 (2006-10-13 22:39 GMT+9)
+ Corrected names of snub-nose, light, and heavy PPCs.
+ Added PXH-7K and MAD-4K (RS:PPU)
+ Clearing woods changed to TW rules
+ Anti mech attacks partially updated for TW rules (swarm pulls in too many rules)
+ Tank and quad hit location tables partially updated for TW rules
+ Infantry anti-mech skill is customisable
+ Update the motive system damage table, and make vehicles use it
+ Bug: NPE firing infantry rifle
+ Implemented infantry weapon changes from TW
+ New <troopers> tag in infantry BLK files
+ Updated infantry unit files to have the correct number of troopers
+ Foot infantry now restricted from firing on the move except with rifles
+ Created unit files for mechanized infantry, they load but don't work correctly yet
+ Infantry flamers can now inflict heat (TW rule change)
+ Non mechanized infantry pay 1 less MP to enter woods
+ Support for 6 man BA squads
+ Blakist versions of Achileus, Longinus and Purifier
+ Comstar version of the IS standard
+ Updated german translations.
+ Combat vehicle critical hit table (no chance for unjam yet)
+ VTOL critical hit table
+ removed maxtech mechanised BA option, as its now integrated to core rules
+ implemented instant death roll for mechanized BA on a dying transport
+ implemented avoid damage roll for mechanized BA when their transport is shot
+ mechanised hover infantry and UMU infantry can cross water (removed the undine hardcode)
+ MP reduction for carrying Fa Shih on a non-omni
+ Omnivehicles can carry BA
+ removed maxtech physical BTH, as its integrated into core rules
+ removed quad punch/kick tables - great minds think alike :)
+ fire and minefields now default to off as they are now advanced rules.
+ removed maxtech target movement modifiers, as its integrated to core rules.
+ new target movement modifiers for 18-24 and 25+ hexes
+ removed maxtech mulekick option, as its now a standard rule
+ made TW partial cover rules standard.  Maxtech option is retained
  for 75% and 25% and vertical cover.
+ rules changes for mimetic and basic camo
+ infantry ignore stealth modifiers except camo/mimetic
+ rules changes for AMS
+ rules changes for inferno
+ rationalised BA ammo and weapon types
+ new unit files for most BA carrying SRM launchers
+ rules change for advanced SRM
+ custom BA can use the disposable missile pack of the longinus
  by specifying the "BA Disposable SRM 2 Ammo".
+ new document: equipment.txt which is an auto generated 
  equipment database.  Use -eqdb <filename> to update.
  This database gives you all the equipment names for use in
  text based unit files (mtf, blk).
  You can import into your favourite spreadsheet or DB as a comma separated value file.
+ BA can customise ammo loadouts by TW rules.  Inferno SRM are working,
  but torpedo and multipurpose missiles are not yet.
+ rules change for leg attack and popup mine (4 damage always inflicted as well as TAC roll)
+ Infantry UMU movement
+ BA multi-purpose missile
+ Clan Undine
+ IS Submersible infantry (laser) [maxtech rules]
+ Bug: multiple crash problem for VTOL engine critical hit
+ extended protomek initiative rules to cover all phases 
  (TW style) instead of just fire phase (BMR style).  If you *don't*
  want protomechs to move as points, use protos move multi with 1/mech
  or individual initiative.
+ Mechs standing in water no longer suffer weapon fire penalties
+ Added water ranges for BA weapons
+ RAC can now fire any number from 1-6 shots
+ Rapid fire weapons are no longer allowed to use TC to aim shots
+ sylph no longer suffer a +3 to hit penalty when they move
+ +1 to hit penalty for skidding (stacks with +2 for running to make +3 total)
+ A-Pods now do a minimum of 1 point of damage on discharge
+ vehicles dumping ammo can suffer ammo explosion if hit on rear armour
+ units going underwater while dumping ammo suffer automatic breaching
+ Bug: crew stunned criticals weren't having an effect
+ Bug: weapon destroyed/jammed criticals could hit weapon in different location
+ Swarmed vehicles can now shake off the swarmers
+ HAG/20, HAG/30, HAG/40 (using reverse engineered stats - bv and cost are wrong)
+ Bug: flak bonus not applied for vtol at elevation 1 over height 2 terrain
+ Converted thunder-inferno minefields to deliver new style inferno hits
+ MML3/5/7/9 (using reverse engineered stats - bv and cost are wrong)
+ Summoner Coelocanth / Drillson (MML) in unofficial.zip to demo the new tech
+ Bug 1575587: Shield Absorbs Low Gravity IS Damage
+ Some 3058U clan BA
+ Rules changes for MASC failure

v0.32.0 STABLE RELEASE (2006-10-04, 18:55 GMT+2)
+ no changes since RC1

v0.31.15, 0.32.0 Release Candidate 1 (2006-09-27, 22:55 GMT+2)
+ Bug 1293410: Minimap can become too big
+ Bug 1556062: Units can fall to MIN_INT elevation.
+ Bug 1556279: tanks can't set modes on all mode-switchable equipment
(log edited to reflect reality, above 3 weren't included in 0.31.14)
+ Bug 1556826: Vehicle loses charge on falling 'mech.
+ Bug 1557074: jungle appears as clear hexes in atmospheric and simplified
  tilesets.
+ Bug 1557077: Changed MASC to not raise the to-hit too high if MASC isn't used.
+ Bug 1556870: Changed method of elevation calculation for DFAs.
+ Bug: night battle modifier added twice for anti-mech attacks
+ Bug 1557275: Bogging down (mud)
+ Bug 1294302 / 1294309: any weapon with a "indirect" mode can now fire 
  using LRM indirect fire rules.
+ Bug: Dual saw was not working correctly.
+ Bug 1555000: Buildings now collapse immediately after area-effect explosions.
+ Cleaned up a couple of no-subject non-public report errors.
+ Better error handling for map size errors in scenario files
+ Corrections to weapon stats for light/heavy/snub nose PPC
+ Update BMRr features list
+ add MaxTech features list
+ Bug 1562560: LAC's with special ammo cost the same as standard ammo
+ Bug 1562913: wrong elevation after walking into depth 2 water on level 1
+ Data 1554992: IS Omni images
+ Bug 1563886: NPE in engine explosion with loaded BA
+ Patch 1563222: Maxtech Rapidfire AC's

v0.31.14 (2006-09-11, 19:00 GMT+2)
+ Bug: assertion failure when observing double blind games
+ Bug 1306432 / 1456639: roads/buildings don't connect automatically
+ Bug: Davy Crocketts now correctly listed as level 3 for Clan A-IVs.
+ In map editor, shift + click adds terrain to the hex
  left click alone sets terrain without changing elevation
+ Some cleanup of hex fitness code in BotClient.
+ Patch 1552344: Shield Fix Patch.
+ Added board preview to Swing UI.
+ Bug 1430249: infantry take double damage from minefield in woods, when moving
  from clear terrain into woods
+ Bug 1365757: Golem BA : ACs fires wrong
  (note this fix includes an updated golem.blk unit file)
+ Show in victory report who killed each dead unit
+ RFE 1550948: Option to have falls end movement
+ Patch 1553164: MPOD Bug Fix
+ Bug 1552980: Problem with nukes and infantry carriers
+ Bug 1433534: Units always enter buildings on ground level
+ infantry/BA can now jump into buildings per BMR clarification/TW book
  (first jump into the hex, then use the up/down controls to select floor)
+ Jumping out of a building now requires a PSR to avoid damage as it should
+ Updated the readme to explain how to move in cities, mention GCJ and move 
  MS java to unsupported/won't work.
+ Hilight deployment zone during artillery-autohithex-selection.
+ Bug 1468767: No displacement after Accidential DFA
+ Some infrastructure towards hidden units.  No way to hide or unhide units yet.
+ Bug 1553806: change MM to match common sense (prone/immobile mods from secondary target)
+ Bug: Nukes should cause a piloting check at +6 for units in the blast.
+ Patch 1555131: Maxtech LRM HotLoading
+ Bug hotloading didn't work properly if other maxtech missile options disabled
+ Mech display now shows no minimum range for hotloaded ammo
+ Mech display now updates the "is hotloaded" label when changing ammo
+ made cluster hits table static member
+ Bug 1435078: Purifier (Narc) should be able to fire missiles individually
+ Bug: mechs could fall through bridges in some circumstances
+ Implemented a connection watchdog on the server to handle pending connections
  that don't do anything.  After 1 second, the server greeting packet is resent
  every 500ms.  After 10 retries if the client still hasn't responded they are 
  dropped.
+ Bug 1297233: C3 master should be able to act as slave
+ Bug 1555770: Spotlight Activation
+ Bug 1556279: Tanks can't switch ECM to ECCM.
(log edited to reflect reality, 3 bugs moved to 0.31.15)

v0.31.13 (2006-09-04, 22:08 GMT+2)
+ Bug 1471321: when removing units in deployment, nonskippable turns happen
+ Bug 1508964: Critical Hits Not Reporting in entitystatus.txt
+ Added data files from MercSupplement: Updates and Jihad Hotspots: 3070
+ Some bot debug information which is only interesting for a developer working
  on bot strategy is disabled by default, it can be enabled by adding "Debug=true"
  line to mmconf/bot.properties.  This substantially reduces the size of MoveOption
  so the bot memory leak is manageable. (379 rounds for bot vs bot lance size game)
+ Bug 1550129: can now charge unit standing on bridge again
+ Bug 1550208: mad dog B has wrong ammo
+ Bug: Clan half-ton MG ammo had BV 1 instead of 0.5.
+ Bug: NPE in cache loader when starting scenario
+ Initial implementation of nukes.
+ Partial implementation of ProtoMech cost calculations.
+ A couple of other minor bug-fixes that I can't remember offhand.
+ Bug 1550556: initial BV wasn't calculated for scenarios
+ Bug 1519330: Getting up and running in water now not allowed
  unless you fell in starting hex, which is allowed.
+ Bug 1326043: No movement modifier for VTOLs after sideslip
+ bug 1551047: Incorrect JJs on Pouncer Prime
+ Corrected multiple filtering errors in nuclear explosions.
+ Corrected wrong report number in nuclear explosions.
+ Improved report formatting for nuclear explosions.
+ "/nuke" chat command now functions to allow nukes of all types.
+ Corrected /nuke to accept coordinates rather than hex index numbers.
+ Changed Hex.removeAllTerrains to set new elevation at the bottom of Water, if present.
+ Corrected missing files (NukeAttackAction and NukeCommand).
+ Changed default color of building-height text to blue, and made it
  configurable. See advanced Client Setting, BuildingTextColor.
+ Data 1545661: updated RS 3055U Mek MTFs
+ initial implementation of Board preview in the BoardSelectionDialog, not
  yet working
+ remove unnecessary casts and imports
+ Units that are the attacker in a charge sometimes got their damage applied to
  the wrong table.
+ Improve board preview
+ Make "remove unit" command work better.
+ More improvement for the board preview.
  Someone please make the MouseListener in MapPreview and the WindowListener
  for mapPreviewW in BoardSelectionDialog work, I can't figure out why they
  don't work :(
+ Bug: selected hex cursor wasn't rescaling when zoom level changed
+ Bug 1478186: Battlefield Screen could be placed offscreen

v0.31.12 (2006-09-31, 21:04 GMT+2)
+ Bug 1542764: Clans allowed incorrect ammo types
+ Bug 1371053: Fixed handling of pilot modifiers for BV.
+ Bug: fixed spikes break rolls
+ Bug 1424574: GE's not saved as MUL's properly
+ Added wood hex images as default for jungles (better than nothing!)
+ Added woods and jungle to tool-tip to help avoid confusion in multiple cases
+ Bug 1546852: Unit verifier now checks jump MP
+ Generalized engine explosions to area-effect explosions
+ Initial implementation of explosive fuel tanks (similar to buildings)
+ Added four unofficial maps to showcase alternate terrains
+ Added missing message to German report string files (in English, sadly)
+ Bug 1422110: Frags no longer damage buildings.
+ Cleanup of warnings in gui
+ Bug 1528962: large memory leak when changing zoom levels
+ Bug 1526913: ECM bubble redraw issue
+ Discard unit cache and canon units list when game is started, to free memory
+ Explosions now correctly damage buildings.
+ In double blind, observers can now see units that are
  visible to at least one enemy, without doing /seeall
+ In double blind, /seeall sends you the entity list immediately,
  so you can see units on the board without waiting for them to move
+ Added artemis capable ammo to MTFs with artemis IV
+ Bug: fixed exception when calculating BV of absurdly fast vehicles
+ Bug 1424570: light AC treated as AC everywhere special ammos are checked
+ Bug 1461254: Push against Push
+ Removed JRE1.5 APIs
+ Added missing german translations.
+ Fixed wrong Exception-catch
+ Removed oodles of unnecessary casts and 'else's.
+ Patch 1534314: Solaris 7 MPod Weapons
+ Data 1545661: 3055U Mek MTFs
+ Added updated retroweaver-rt.jar, so clients work again with Java 1.4
+ Bug 1464952/1298206: purifier's mimetic armour now cancels +1 for jump
  Note this is changed in TW so mimetic doesnt cancel anything so I've 
  documented that and added a FIXME for when we change ruleset
+ Changed "host game" startup so that game options are loaded by the Server
  instead of the MegamekGUI, to address a rare lockup caused by game options
  being sent before the player name.  (unfortunately unlikely to be the same
  as 1546375, although the symptom was the same the log is different).
+ errors setting up games are now alerted to the user (or logged for 
  dedicated server).  As a consequence, Server's constructor now throws 
  IOException.  No impact on mekwars as far as I can see.  Previously we
  we threw NullPointerException.
+ /reset command now removes ghosts
+ Disable autoeject when loading a mech with CASE.
+ Added "Instant Fame" Northwind Highlanders Scenario by Slade
+ Scenarios can specify their own gameoptions.xml file (see Example.mms and the readme)
+ enabling individual initiative disables infantry/protomech initiative rules
  because they are incompatible.

v0.31.11 (2006-08-11, 3:33 GMT-8)
+ Corrected map size label message reference.
+ Excluded SVN files from data load to avoid larger numbers of errors.
+ Corrected capitalization of MaxTech in several places.
+ Bug 1539802: Fixed it so it loads FF and ES for TDB mixed-tech units.
+ Bug 1540146: Engine explosions not checked for doomed mechs
+ Added optional turn limit.
+ Bug 1433393: Gray Death now correctly loaded as level 3.
+ Battle Armor BLK loader now more correctly loads levels.
+ Bug 1433405: Nighthawks moved to CE infantry zip file.
+ Make the unit loader ignore _svn directories.
+ Bug: Fixed HMVFile so it now detects zero-armor turrets.
+ Bug 1282055: No more jumping torpedos.
+ Bug: Long Range Torpedos now hit in clusters of 5.
+ Bug: Fixed a number of BV Calc errors for vehicles.
+ Corrected both Sea Skimmer version Speeds.
+ Corrected Mantis VTOL Unit File.
+ Corrected Cavalry VTOL (Infantry variant) unit file.
+ Corrected Sprint VTOL (Troop Transport variant) unit file.
+ Corrected Warrior 8-7C VTOL unit file.
+ Corrected loading error for zero-equipment BLK vehicles.
+ Corrected BV Calc for Clan Active Probes on VTOLs.
+ Bug: melee specialist reduces attacker movement mod not targets
+ Added TW_BMR_Differences.txt
+ Bug 1412726: Corrected behavior of light engines, CASE and ammo for BV.

v0.31.10 (2006-08-11, 17:00 GMT+2)
+ Fixed a few spelling errors in a Server.java comment
+ Bug 1524826: No heat while jumping
+ Bug 1418618: heat ammoeplosion autoejection crash
+ Client setting to enable mouse wheel zoom.
  Default is off, because of bug 1528962 and conflict with ruler
+ Bug: JJ attack possible without JJ for 0 damage
+ Bug 1449364: Delayed Deployment causes skipping of other phases.
+ Bug: Delayed deployment says "after" but deploys "before" the round.
+ Bug 1530481: Flail dealing wrong damage
+ RFE: attack arrow transparency
  (you can set 0-clear - 128-default - 255-solid in advanced options)
+ AlerDialog -> JOptionPane.showMessageDialog
+ swapped one JScrollBar to the more appropriate JSlider, made sure all
    TextArea are opaque and editable as appropriate.
+ Solaris 7 spikes.
+ Bug 1275427: missing line break when pilot bakes to death
+ Bug: lots of Weapons erroneously counted as HarJel.
+ Bug 1451767: building damage report missing linebreak
+ Bug 1535114: Loads weapons wrong in some cases with spaces in crit list.
+ Bug 1537164: Fixed multiple Charge NPEs against building.
+ Bug 1495133: 'Mechs now height 0 if in the same hex as a building.
+ Bug 1474146: C3i 'Mechs now correctly interact with ECM.

v0.31.9 (2006-07-15, 17:15 GMT+2)
+ Bug 1497813: NPE on player reconnect
+ Bug 1496668: Plasma Rifle Subtracts heat instead of dealing heat.
+ Bug 1487415: A Bug With Water/Buildings/Skidding
+ Bug 1483413: Stealth armor bug
+ Bug 1475493: I Narc ECM not working
+ Bug 1471684: reporting errors when brushing off
+ Bug 1451176: Streak LRMs cause NullPointerException
+ Bug 1446033: Maxtech damage PSR not showing the weight class modifier
+ Migrated List -> JList, Scrollbar -> JScrollBar, ScrollPane -> JSCrollPane
    BoardView1 scrolling is screwed up, still need to fix, removed useless
    BoardComponent
+ Migrated Menu/MenuItem/Menubar, Tooltip, PopupMenu 
+ Bug 1502289: prone mechs can charge
+ Bug 1448481: Units on bridge over lava still suffer damage 0.31.6
+ Bug 1433738: unable to load same team units
+ Bug 1438656: MM Reports victory before last end phase
+ Bug 1431994: Firedrake needler doesn't damage infantry
+ Modified the static maps which have bridges to use actual bridges.
+ Don't count destroyed weapons for heat curve in Mech BV calculation
+ Bug 1505555: Unable to standup and turn
+ Hopalong's weapon patches
+ Patch 1464393: Torpedo AddLookUpName Additions (from battlemaster)
+ Patch 1488173: Bot AI fix: secondary targets (from dgorsman)
+ patch 1496212: Bot AI upgrade: CEntity.java (from dgorsman)
+ Fixed minor bugs (adding Bots) in the swing version of the ChatLounge
+ Patch 1277708: Draw optimization
+ Fixed layout in the swing version of the StartingPositionDialog
+ Fixed minor porting bug in the swing version of the ChatLounge
+ Bug 1510342: Improved JJ MP Calculated Wrong
+ Taught the bot how to play under individual initiative
+ MechDisplayEvent.getWeaponId() returned entityId
+ Show execution of charge/dfa on unit tooltip
+ Victory condition game options (% enemy BV destroyed and BV ratio)
+ RFE: maxtech infantry damage
+ Bug 1515671: /victory and /defeat does not end game
+ Show Charges and DFAs in the firing phase.
+ Bug 1517652: don't NPE with delayed deployment.
+ Warhawk C corrected (removed lower arm actuator)
+ Bug 1519734: Ejected VTOLs Listed as Salvage
+ Bug: VTOL explosion not starting fires in open hexes correctly
+ Bug 1375466: VTOL Crash Errors.
+ Bug 1519666: Facing ignored in Scenario
+ Bug: Wrong information on failed PSR after thrashing attack
+ Bug: With MT Heat Rules, sometimes there were no critical hits due to heat
  even when there should have been one
+ Bug 1520633: HeatSink Cutoff Not working
+ Bug 1452190: HMVee files missing equipment with MM
+ Bug 1515056: FF Prototype Armor has incorrect weight
+ Bug 1297802: Movement after skid
+ Bug 1521855: swarm LRM can hit with too many missiles
+ Bug 1521802: Swarm LRM can't jump to out of range targets
+ Bug 1522579: prone mechs can't turn
+ Bug 1304304: mapchoice dialog regression wrt selecting boards
+ Bug 1457544: LOS issues with indirect fire and clearing woods

v0.31.8 (2006-05-28, 16:58 GMT)
+ Bug 1467018: c3i can crash the map on deployment
+ Bug 1468738: Accidential DFA on tanks MISSES
+ Bug 1470202: Cannot kick buildings
+ Make tab names in the chatlounge clearer.
+ Make main menu button names more newbie-friendly
+ Bug 1469940: Split critical locations showing wrong firing location
+ RFE 1463286: Clan physical attacks -- allow brushing off.
+ Bug 1459060: removed iterator modification
+ migrated various AWT fixes from last month to Swing fixes
+ JDialog, JFrame, JTextArea moved swingized 
+ Bug: 3 Sensorhits on a torsomounted cockpit forbid all attacks
+ Bug: ClassCastException attacking with tanks
+ Engineer platoons' fire extinguisher ability
+ Coolant System (fire extinguish / cool mode for veh. flamers)
+ JWindow swingized, JWindow/JFrame .add() and .setLayout() need to be converted
    to .getContentPane().blah, migrated coolant system fix to swing.
+ Heavy infantry
+ FileChooser migrated, Choice, ScrollPane and others in the process
+ MaxTech new physical attacks: Jump Jet attack and Trip
+ MaxTech new physical attack : grapple
+ Remember last entity target in firing phase
+ RFE 1468188: skip offboard phase (TAG) unless at least one unit
  carries semiguided LRM or homing artillery ammunition
+ Bug 1478478: artillery shooting at previously hit hex can't target hex
+ Patch 1478781: Various Bot patches
+ Patch 1478358: Start/finish BV for victory report
+ Bug 1486403: grapple class cast exception
+ Fixed NPE in processMouseMotionEvent in the swing version of the PicMap.java
+ Migrated Choice -> JComboBox, deleted Prompt (replaced with JOptionPane)
+ Bug: BA armor not loading
+ HMP loader auto split ammo type for LBX and ATM
+ HMP loader a couple of missing mixed tech weapon entries
+ Units that did not leave their hex can now be loaded, solving the
  problem of loading units under non standard initiative schemes in
  a way consistent with the BMR.
+ Bug 1478482: /localsave does not save in savegame dir
+ Fixed minor Choice -> JComboBox migration bug
+ mountains RMG option
+ Bug proto-physical attack didnt consider terrain height
+ Town RMG option - MapSettings interface compat break.
+ Bug: load and save map settings ignoring directory selection
+ Bug: invert negative terrain option in dialog ignored
+ Bug: mountain width checked when no mountains
+ Lots of JDialogs were not using getContentPane().add and .setLayout()
+ Refactor: Cleared off multiple UI classes in the same file by inner classing
  panels and externalising dialogs
+ Typo in above refactor... 
+ Don't refer to megamek.log in report error, but to megameklog.txt
+ Patch 1495220: mountain lakes

v0.31.7 (2006-04-13, 13:30 GMT)
+ RFE 1443896: Roll command - show what dice were rolled.
+ RFE 1443180: show target arc when firing weapons
+ Bug: Active Shields prevent AMS from shooting.
+ Bug 1448489: Torso Cockpits Do Not Load Right from XML Files 0.31.6
+ Patch 1447682: More AI Refactor/Optimization
+ allow trailing spaces in MTF critical slots.
+ Bug: Targeting misspelled as Targetting.
+ Patch 1450943: Minor Bot patch: PBIs
+ Patch 1450899: Buzzsaw from Unbound
+ Patch 1452628: UMUs and Large shields.
+ Patch 1452629: Harded Armor and Lance Fix.
+ Bug 1450981: mek making PSR when standing still
+ Bug 1448611: NoSuchMethodError with java 1.4
+ Patch 1452887: Entity Vectors to ArrayLists
+ Bug: Shield damage capacity was calculated wrong for passive shields
+ RFE 1458778: Negative terrain inversion option for RMG
+ Track which board-direction a unit retreated to, for MekWars tracking.
+ RFE 1458261: show building height in the hex
+ Bug: Building targets 1 level taller than they should be
+ Bug: PSR made for stepping off building as 1st step
+ Rules change for BA, now troopers already killed in the same
  phase can't absorb hits.
+ Dig in ability for infantry (declare in move phase)
+ Fortify ability for engineers, with vibroshovels (declare move phase)
+ Order of buttons in move phase depends on unit type,
  e.g. VTOL see the go up/down buttons on the 1st page
+ Bug: EC(C)M was working when pilot is unconscious.
+ In RMG, invert negative terrain before placing lakes etc.
+ Bug: getting stuck in a swamp was not checking for road movement.
+ Patch 1459736: Initial Swing update.

v0.31.6 (2006-03-12, 16:48 GMT)
+ Bug 1427812: Thundergod mislabeled as Cerberus
+ Bug with movement initiative report when non-canon deployment and movement
    initiative options set.
+ Bug 1432484: TAC on RA of armless mech caused exception
+ Bug 1352552: Terrain Messages while Jumping
+ Bug 1410887: Anti-mech and inferno infantry should be canon
+ Bug 1434301: Split weapons not loading correctly from XML files.
+ Bug 1376291: weapons can target clear hexes
+ RFE 1434128: Override default hex tile setting (select "simplified" tileset)
+ Bug 1436078: Tactical genius + individual init
+ Bug 1433947: artillery is hitting vtols in flight
+ Bug 1424103: artillery doesn't specify hit table
+ Bug 1424101: missed homing arrow shots should do damage
+ Bug 1424098: buildings absorb artillery damage incorrectly
+ Bug 1420967: artillery splash damage uses wrong hit table
+ Clicking a hex during targetting phase now targets the hex for artillery
+ Removed target hex (fascam, inferno IV, vibrabomb-IV) types, use artillery
     target
+ Implemented maxtech artillery rules, and cluster/flechette ammunition.
+ Game option: "maxtech artillery", uses the improved flight times and damage.
+ Smoke artillery partially implemented, works with level 3 smoke only.
+ Patch 1436340: Refactored TestBot a little bit and fixed a bug.
+ Patch 1439854: MapPack Solaris VII Shields
+ Patch 1438465: ECCM Patch
+ Bug 1438580: Tanks on bridges drown at end of physical phase
+ Bug 1436167:  Unloading Battle Armour on top of buildings with VTOLs
+ Bug 1288101: VTOLs crash multiple times when movement system destroyed
+ artillery flak use artillery damage functions
+ Patch 1440745: S7 Claws
+ BattleMech HarJel system, from MapPack Solaris VII
+ Patch 1442366: Edge Bug fixed.
+ Bug: claws ClassCastException for non mechs
+ Bug: bot infinite loop deciding if push damage can break armour (100% cpu lockup)
+ more logging for bot
+ Bug 1443288: lock up when targeting buildings
+ don't report HarJel when no breach roll would be made.
+ change EquipmentType flags to long, we ran out of flags for MiscType.
+ Set gridx and gridy in WeaponPanel (in MechDisplay.java) to prevent
  layout problems using GNU Classpath.
+ Patch 1444346: S7 UMU Equipment
+ S7 shield patch was missing changes to one file.
+ Patch 1445349: S7 Flail
+ Patch 1445360: S7 Wrecking Ball
+ Patch 1446780: S7 Vibroblades
+ Patch 1446679: S7 Lance 
+ Patch 1447385: Heavy Duty Gyro
+ Patch 1436052: unofficial Super-Heavy 'Mech IS Values

v0.31.5 (2006-02-14, 14:19 GMT)
+ Bug: more problems with HMV and ammo, typo in HMPFile for ISLaserAMS
+ Added some missing level 3 equipment to HMVFile from HMPFile data
+ HMVFile now reports failed equipment
+ Fix some bugs in getMtf functionality.
+ Bug 1295062: Heavy Gauss PSR slightly off
+ Patch 1376607: Full Double Blind Message Filtering
    Note: use Server#addReport() to add Reports instead of 
    vPhaseReport.addElement() from now on.
+ Bug 1417988: full double blind causes NPE starting game
+ Bug 1410795: Unit on top of a building receive protection
+ Bug 1413027: PSR should not be required for turning in a building hex
+ Bug: VTOL undamaged by sideslip into building
+ Bug: Offboard artillery revealing enemy in double blind
+ Bug 1409596: Engine explosion damage counts multiple times for 20+ damage PSR
+ Bug 1419144: BoardView1 deadlock
+ Bug 1415093: Hardened armor not loading correctly.
+ Bug 1412726: Some clan mechs have wrong BV
+ Bug: Hardened armor weight incorrect.  Also fixed GTR-1 data file.
+ Bug 1420971 artillery home edge chooses "north" for SE and SW starts.
+ Armless mechs
+ Bug: Infantry in level 0 of building on level 1 terrain didnt take damage
+ HMV loader support for arbritrary sized infantry bays (rounded down to 1 ton)
+ Prevent (&log) server from sending null entity packets to the client.
+ Hopalong's weapons patch (except phoenix, hawk and streak mrm missiles)
+ Bug 1421043: MASC psr roll not in phase report
+ BAP subtracts 1 from wood BTH mod, when MaxTech option is enabled
+ Bug 1424137: class cast exception targetting woods with IDF
+ Bug 1424104: Some ammo types missing hyphens
+ Bug: Splittable Weapons act as if they were split when loaded from HMP.
+ Bug 1363690: Weapons w/ split location should be affected by actuator hit
+ Bug: It was possible to fire with a torso/arm split weapon when prone and
    firing from the other arm already.
+ Patch 1400294: Edge
+ Magshot Gauss Rifle for Mechs from MapPack Solaris VII
+ Bug 1424106: "All" unit type filter causes error
+ Bug 1420876: rapidfire MG can fire when ammo is used up
+ Bug 1424586: GE's need a proper BV
+ Bug 1424570: Light AC's need special munitions
+ Bug 1413335: physical attack vs building
+ Bug 1414795: remove underweight duplicate of Mantis VTOL
+ Protect MaxTech BAP rules by game option.
+ Bug 1415157: doubleblind not working correctly on disconnect
+ Bug 1297704: LOS tool not working correctly
+ Bug: HMP Mechs with split weapons did not load correctly.
+ Show ECM bubbles on map
+ Bug 1427812: Thundergod mislabeled as Cerberus
+ Bug 1427926: Stealth BA can be secondary targets.
+ Bug 1428707: turn lost when loading infantry with inf_move_multi
+ Individual initiative game option *not compatible with other
     initiative options*
+ Patch 1428586: GetAllEntites function in Game for MekWars cooperation.
+ Bug: Splitable weapons that are not split loaded multiple times in MTF files
+ Bug: Compact heatsinks not loaded from HMP files.
+ Bug: 1428707 should be for movement phase only
+ Bug 1429290, Patch 1429092: Mechs with split weapons are "illegal units"
+ Bug 1429416: Unable to target units after null pointer exception
+ Patch 1430986: BAP woods modifer bug fix Fix Patch.

v0.31.4 (2006-01-27, 22:10 GMT)
+ Bug 1385381: incorrect code in MapSettings.java
+ Bug 1385829: Firing Phase player disconnected from server
+ Implemented bridges.
+ Bug bridge/affa collapse problem
+ Bug tanks reluctant to use bridges
+ Bug collapsing structure left non mechs hanging in the air
+ Bug falling into water now destroys most non mechs. (collapse)
+ Updated BMRr_Features_List.txt wrt bridges and gun emplacements
+ Various bridge related fixes
+ Bug naval units were able to cross land by moving along roads.
+ Implemented torso-mounted cockpits for HMP files.
+ Corrected Torso-mounted cockpit loading from MTF files.
+ Added Great Turtle GTF-1 (3055U) to mechs.zip.
+ Fixed several torso-mounted cockpit and hardened armor bugs.
+ Bug 1388465: blk lvl 1 mechs load without engines.
+ Bug 1374005: mech with small cockpit has error if sensors crit is moved.
+ Continue system criticals refactoring (gyro, cockpit).
+ Clarified "default autoeject off" client setting.
+ Patch 1376849: Bot equipment usage: RAC unjam, part 2.
+ Patch 1380002: Smaller NPE error message for MechFileParser.java.
+ Patch 1391035, RFE 1169259: Auto "abandon"
+ Bug 1395708: MM locks up when using the Prototype weapons
+ Expand log file date/time stamping to also affect entitystatus.txt.
+ Better level 3 internal structure/armor parsing support.
+ Bug 1398100:BV doesn't account for reinforced/composite IS or hardened armor.
+ Bug 1398101: Cost wrong for most meks.
+ Bug 1275383: searchlight destruction line break missing
+ Bug 1398266: Offboard artillery error
+ More cost bugs fixed.
+ Bug 1396149: VTOLs with maneuvering ace make all lateral moves for 2 mp
+ Bug 1399841: NPE when autoejecting a dead pilot
+ Improved display of bridges on minimap
+ Bug 1405463: mechanical jump boosters should not allow facing change
+ Bug 1400099: Breaking Ice while walking backwards causes a problem
+ Changed DENSITY to CITYDENSITY in xml terrain for mekwars compatibility.
+ Bug 1406703: Clientsettings window doesn't show up.
+ Bug 1389742: Destroyed Heatsinks still working
+ Bug 1291856: mech display and minimap windows can be placed offscreen
+ Bug 1306264: improved jump jets dont load from HMP files
+ HMV loader support for fluff text
+ Bug HMV loader had wrong name for vehicle flamer so it didnt load
+ Bug LRM infantry have 3MP according to MaxTech but unitfile had 2MP
+ Bug 1410113: CT cockpit mechs are still destroyed when head is destroyed
+ Stop drawing white facing arrows for infantry.
+ Bug IS Vehicle flamer ammo didnt load from HMP files
+ Bug: Supercharger weight was rounded incorrectly.
+ Mech objects can now be output as mtf files.

v0.31.3 (2005-12-20, 16:30 GMT)
+ Bug 1357018: Added trim() to port string for parsing port number.
+ Bug 1328640: Damage from engine explosions now can cause PSRs.
+ Bug 1362909: jumping over/into water impossible  
+ Bug 1326177: Leg Breached during DFA
+ Patch 1364222: Bot uses /defeat when humans use /victory
+ Patch 1364223: Chatty Bot
+ set the exits when placing a building using BuildingTemplate, hopefully 
  should stop adjacent single hex buildings displaying as multi-hex but
  following the rules for single hex (2 PSRs for moving)
+ Cliffs option in the RMG - looks for runs of hexes with higher terrain on
  one side and lower terrain on the other, and moves it up or down to create
  a cliff a mech can hide behind. 0-100 setting, being % chance to convert
  each suitable run that is found.
+ Bug 1365754: HMV: Mixed Tech vehicles failed to load, 2nd
+ Added optional MapHeight and MapWidth parameters to Scenario files.
+ HMP loader now understands all standard criticals, thank you jabberwockyphl
    for the info.
+ Bug HMP loader regression with bloodhound active probe
+ Bug GameOptionsDialog can't save when used from mekwars
+ Torren's city builder (in progress)
+ Some work on city generator
+ Refined advanced mek search
+ City builder: improve HUB algorithm to work better on large
    maps (e.g. 32x34, =4 mapsheets)
+ City builder: don't build over water, swamps or on mountain
    tops (just looks nicer)
+ City builder: put roads in (HUB type only so far)
+ City builder: build "bridges" in straight lines where a road crosses water
+ City builder: density parameter (1-100) controls number of empty lots
    and multihex buildings
+ Bug: Semi-guided LRMs could not be fired
+ City builder: add roads to METRO and GRID city types, tweaked a bit to
    deal with crossing water
+ City parameters added to random map dialog
+ Bug: random map dialog wasn't initialising theme from map settings
+ Bug: NPE occurred determining if an ejected Mechwarrior was eligable for
    physicals (position was null)
+ Further refinements to advanced mek search
+ Random map dialog documented in readme.txt
+ Randomly generated road uses the city builder method (avoids duplication
    and doesn't mess up a city)
+ atmospheric.tileset added depth 0 water image (it was displaying as
    open ground)
+ classic.tileset removed ice-skinned pavement from the snow theme
    (obsolete now ice is supported, and caused some pavements to display
    as ice in the grass theme)
+ level 3 targeting systems load from HMP and TDB files for level 3 mechs
+ modified GRID city for playability
+ prevent random map dialog being placed off the top of the screen
+ Bug 1373068: Configuring unit does not update mek list.
+ Bug 1369217: Clan mechs with XL engine have too low BV
+ Bug 1372046: disconnection after firephase
+ Fixed Dragon Fire's hands (shouldn't have any) at beerockxs request.
+ Random map dialog can save and load settings from an XML file, which uses
the same tags as mekwars for easy cut'n'paste.
+ Bug 1373918: Possible fix for ArrayIndexOutOfBounds exception in TabPanel.
+ Update to chatty bot patch.
+ Add date of game and memory info to log file.
+ Added "Group View" button to chat lounge.
+ Patch 1371084 / RFE 1360461, support for HMP fluff text (thanks Torren)
+ Bug 1376727: inferno missiles aimed at buildings did not start a fire
+ bug - wrong offset in hmpfile broke level 3 mechs with superchargers
+ RFE 1374974: game option for mechwarriors to carry an infantry rifle
+ RFE 1374969: BA critical hits (MaxTech rule)
+ Maxtech mechanized BA rule
+ Bug 1377368: Group View window now closable via native controls.
+ Bug 1378762: target not in arc error for leg attack
+ Bug 1383851: Verifier calculates Ferro-Fibrous weight incorrectly
+ MaxTech Hardened Armor implementation.
+ Bug 1384772: Vehicle vacuum protection not working properly.
+ Verifier xml file: ceilWeight section was not being read.
+ Verifier: Vehicle control tonnage not calculated correctly.
+ Verifier: Most system weights were being rounded to quarter-ton values,
    instead of proper half-ton values.
+ Verifier: Check for valid engine criticals.
+ Added level 3 engines.

v0.31.2 (2005-11-20, 21:00 GMT)
+ Switchable map tilesets
+ Michael Gratton's Gun Emplacement patch. Thanks!
+ Bug 1296592: Bugs with Heat Sink adjustment
+ Bug 1323062: 2 clubs on one mech not working correctly 
  (now you, and the bot, can choose which to use)
+ New deployment zones: CTR (centre 1/9 of map) and EDG (3 hexes from any
    edge).
+ deep_deployment game option (initial deploys are 1/5 of board size from the 
    edge)
+ reinforcements deploy on edge (CTR or ANY -> EDG, deep -> standard deploy)
+ Bug: Pilots with EI should take damage even when no IS remains in a location.
+ RFL-8D Rifleman had wrong amount of armor (8 instead of 9 points on head)
+ New double-blind "visibility" game option added which determines the
    distance a unit can be seen at.
+ Bug 1285121: DFA cause problems
+ mechanical jump boosters (maxtech equipment)
+ Bug 1339448: Unit customisation message in blind drop
+ Engineer platoon's tools
+ Engineer platoon improved minesweeping ability (Light Minesweeper)
+ Engineer platoon lay explosives ability (Demolition Charge) - but can't set
    them off yet!
+ Supercharger, except for using MASC and supercharger on the same mech is not
    supported yet.
+ Bug: Vibrabomb evading unofficial option always in effect.
+ Code update, no real change: Replace combineVectors with Java 1.2 addAll.
+ Bugfixes to jump booster/supercharger/improved JJ
+ Towed field guns for infantry. Add mech scale weapons and ammo to the
    <Platoon Equipment> section of your blk file
+ unit files for all standard autocannon and gauss I.S. field gunners (based 
    on motorised rifle platoon - I figure the infantry weapons are secondary)
+ remove bad dependency on server code
+ buildings: can jump onto roof and climb onto/off buildings.
  this also works for thin ice.  The climb mode can be switched during movement
  at any time (either climb onto top of things or try to go under/through them)
+ can break through ice from below if you go under ice and enter a depth 1 hex
    or change to climb out midway through movement.
+ updated BMRr feature list.
+ HMP loader critical definitions for supercharger and jump boosters.
+ Bug 1351026: launcher offers incompatible JRE
+ New pics for Brigand, Chimera, Colossus, Cudgel, Hellspawn, Juggernaught, 
    Osiris, Red Shift, Ronin, Sasquatch, Sirocco, and Stiletto
+ Bug 1323242: Unloading infantry does not cost 1 MP.
+ Added "Advanced Search" feature to the Mek Selection screen.
+ buildings: collapse due to overloading checks now working.
+ More field gunners and a field gunner image contributed by hopalong (thanks)
+ buildings: BA and protomechs move through buildings like infantry
+ Bug 1233539: Buildings/Double Blind LOS error
+ Add "Defaults" button to Game Options window.  Note that pressing "Ok" now
    saves your choices automatically.
+ Bug 1350820: Anhur Transport had incorrect weapon loadout.  Thanks to
    Hopalong for the fixed file.
+ Bug 1342988: Clan LB2XAC ammo and ArrowIV ammo not loading from HMV files.
+ Bug 1342982: Long Tom not recognized in hmp/hmv files.

v0.31.1 (2005-10-11, 17:15 GMT+2)
+ coolant pod [without a playable heat/end phase, uses mode switch instead]
    off - won't be used, safe - will be used to avoid a shutdown/ammo roll
    efficient - used if the extra heat dissipation is fully used
    dump - always used (e.g. getting rid of pods in an open torso)
    The first pod found to meet its trigger condition is used, so turn off
    others if you want a specific one used.
+ Infantry can go up and go down when in a building
+ Some framework for valid elevations (useful for buildings, bridges,
    submarines...)
+ Bug 1294150: Gyro and cockpit for level 1/2 HMP 'Mechs now Standard instead
    of Unknown.
+ Bug 1285089: THB Maces now load from HMP files.
+ Sylph movement bug fix, they couldnt fly over a high cliff
+ Impassable terrain type (blocks deployment and movement, but not LOS - use
    elevation for that).  This can represent solid rock, or other hexes that
    are not part of the playing area.
+ Changed level 20 hexes on the ishiyama maps to impassable
+ Added several more weapons to custom BA dialog.
+ Added max # of weapons checks to custom BA dialog.
+ Added recoilless rifles and Clan Micro Pulse Lasers to custom BA dialog.
+ Fixed Custom BA dialog so it re-selects what you just added (if possible)
    instead of going to the first item after adding a piece of equipment.
+ Fire-resistant armor now loads correctly from Custom BA Dialog.
+ Added reset button to custom BA dialog.
+ Custom BA dialog now correctly validates armor slot usage.
+ Added yet more custom BA equipment.
+ Fixed an ammo dumping bug that let people dump without their opponent knowing
+ Bug 1297348: TAG problems
+ Bug 1293264: mech pushed into water stays at elevation 0
+ Patch 1298823: Weaselfink's corrected OfficialUnitsList.txt.
+ Bug 1293793: elevation bug: VTOL wont unload
+ Fixed a bug deploying transports with units already loaded
+ Updated HACKING and docs/gcj.patch to show new directory structure.
+ Implemented ICE engines for mechs. Because noisy, smoky diesel engines are
    good (Note: HMP is currently the only editor to support mech ICE correctly)
+ Bug 1301825: Jumping over Depth 1+ Ice forces PSR
+ Bug 1301882: Ice over water Blocks LOS
+ Bug 1301898: Unit in Ice covered depth 1 hex still treated as submerged
+ Ice covered water can be cleared with submerged weapons too.
+ Bug 1293280: Another NPE using bot + off-board units (weaselflink's patch)
+ Bug 1293051: NPE during bot deployment (weaselflink's patch)
+ /fixelevation command, which recovers game from elevation problems.
+ Null Signature System
+ Added Retroweaver to the build process so we can use some Java 1.5 features
    but still retain Java 1.4 compatability.  See build.xml for details.
+ Bug 1304515: Ammo exploded twice
+ JARs should be binaries
+ Bug 1305134: wrong elevation after displacement
+ Bug: NotSerializableException when artillery shell is in flight.
+ Bug 1297233: company-master description in Custom Unit dialog wrong for when
    a unit with a single C3 Master is to be used as a company master.
+ Dynamic Terrain framework (DynamicTerrainProcessor.java)
+ Geysers and Magma vents (GeyserProcessor.java)
+ Moved fire&smoke end phase logic to dynamic terrain (FireProcessor.java), 
  saving ~450 lines from the monolith that is Server.java
+ Images for Geyser terrain
+ Bug 1305547: EI feedback damage
+ Bug 1305557: Level 3 mechs have wrong heat for standard jump jets
+ Swapped internal&lookup names for improved JJ so they look nicer in systems tab
+ Elevator terrain, usable for the moving walls in Solaris VII colloseum
+ RFE 1307755: Vehicle CASE
+ Bug 1309054: double blind needs updating after terrain changes
+ 4 new Batchall.de-Mechs
+ Bugfix: elevation error preventing charge declaration
+ Bugfix: string index out of bounds exception receiving empty report with
    indent set
+ Bug 1306423: Infantry stealth armor should be valid secondary target.
+ Bug 1305883: Clearing mines with infantry
+ Restore some Java 1.5 code that was removed a while ago now that we
    have Retroweaver support in.
+ Remove Java 1.1 audio support.
+ Advanced option to disable translucency for "hidden" double-blind units.
+ Patch 1316537: repair status for critical slots, used by MekWars.
+ Patch 1254626, RFE 1251249: Lock down "problem" commands to non-observers.
+ RFE 1313849: show in chat when a unit in the lobby gets customized.
+ Bug: Infernos should not be able to ignite clear terrain intentionally.
+ Bug: BV calculation wrong for mixed-tech mech with XL engine from other
    tech type.
+ Bug 1291138, Patch 1320533: some ProtoMechs were wrong.
+ Bug: When Building had CF of 1 and got damage from fire, we set it's CF
    to an illegal value.
+ Bug 1310336: VTOLs set off mines.

v0.31.0 (2005-09-17, 00:35 GMT+2)
+ RFE 1253215: Added Angel ECM.
+ setting an infantry or protomech unit's crew did not copy MexTech pilot
    advantages over.
+ Added Improved Jump Jets.
+ Fixed bug with verifying composite armor.
+ Corrected a couple of unit files.
+ Altered build.xml and build.bat to target and source 1.5 instead of
    1.1 or 1.2.
+ Corrected tech level of several miscellaneous equipment items.
+ Added "available to all" as a tech level for things like single heat
    sinks and regular jump jets.
+ RFE 1242241: Doesn't move to an AMS during firing.
+ Added IJJs to MTF_names.txt.
+ Corrected Nova Cat Jorgensson to verify correctly.
+ Remove old, abandoned weapons refactoring from codebase.
+ Added Bloodhound (MaxTech and THB) to MiscType.
+ Corrected one unit file which carried a THB Bloodhound.
+ Added one-shot Streak LRMs.
+ Patch 1242292: EI implants
+ Added Watchdog Suite
+ RFE 1249703: show searchlight destroyed roll
+ Added partial fix for bug 1260203.
+ Implemented Fa-Shih mine-laying, click the "Lay Mine" button in the
    movement display. For now only conventional mines.
+ Patch 1240693: MegaMek launcher
+ Added ice terrain type (does nothing but look pretty yet)
+ Bug 1260935: after MM launcher patch, client does not start
+ Bug 1260203: Angel ECM now correctly affects streaks.
+ Artillery FLAK.
+ Implemented rules for "frozen solid" ice.
   Map generator now generates this, and uses it in the "freeze" special effect
+ Reverting the wrong fix for the invalid bug 1260935: after MM launcher patch,
   client does not start
+ Patch 1237314: new connection refactoring
+ Rifleman RFL-8D was missing endo steel and 3 tons of armor.
+ Corrected several sheets in unnofficial.zip to fix errors and prepare
    for physical weapon refactor.
+ Refactored physical weapons (hatchets, swords, etc.)
+ Added Tac Handbook Mace
+ Added Solaris 7 Mace and Dual Saw
+ Bug 1263895: Woods and Smoke (Level 2) cumulative
+ Bug 1263672: NPE when shooting at VTOL that has no undestroyed weapon.
+ Patch 1263668: Patch for GamesOptionsDialog to allow frames.
+ Added several 'Mechs from TRO3055U.
+ Adapted new Java 1.5 code to be 1.4 compliant until final descision is made.
+ Added Tactical Handbook versions of Inner Sphere LB-Xs.
+ Added Tactical Handbook versions of Inner Sphere UACs.
+ Clarified Pain Resistance description.
+ Fixed build.bat.
+ Bug 1265984: VTOLs crash into the ground when they shouldn't
+ Bug 1266046: Sideslipping VTOLs change elevation
+ Added flags for more physical weapons for future implementation.
+ Don't throw NPE when OfficialUnitList.txt is missing.
+ Bug 1262741: Torpedoes and the surface navy
+ Bug 1244125: non-fatal exception in WeaponPanel.getSelectedWeaponNum
+ Bug 1265469: infantry damage report confusing
+ Quad hit location tables (level 3 option "quad_hit_location" and level 4
    option "quad_hit_location_plus")
+ Fix indentation for woods clearing in the server report.
+ Bug 1268206: possible to fire jammed RAC, results in client disconnect
+ Bug 1267368: Targetting System Choice Box Enabled in Opponent view
+ Task 117159: Fa-Shih mine-laying, now for Vibrabomb mines, too.
+ removed not-working fix from build.bat
+ Bug 1267328: endless Dialog Boxes when disconnecting Client from a Server
+ Hull down for quads and vehicles.  Fortified terrain can be added in map 
    editor (no engineer platoons yet!).  Somebody please make some better
    artwork though.
+ Added Backhoe (miniature rulebook).
+ Added Chainsaw (miniature rulebook).
+ Added Pile Driver (Solaris VII).
+ Missile weapons show up as conventional mines in the mechdisplay.
+ Fix NPE when targeting woods, caused by hull down option
+ Bug 1274311: Formating on crit message from level 3 heat
+ Bug 1268169: RAC unjamming does not work.
+ Patch 1274963: Minor fix for the Bot and heavy gauss
+ Corrected patch 1241389: patch for bug 1236506. Removed incorrect call of
    TilesetManager.reset() from the gameBoardChanged().
+ Fixed vehicle data for Warrior H7C (Added missing ammo to bring up to correct
  BV of 721).
+ Patch 1275860: patch for bug 1275849
+ RFE 1274555: Hopalong's LAC patch.
+ RFE 1274554: Hopalong's Heavy Flamer patch.
+ RFE 1252860: Added MFUK Plasma Rifle.
+ Added framework for future implementation of alternate gyro and cockpit
    types.
+ Bug 1263380: Mek selection grayed out
+ Patch 1277130: patch for bug 1277125
+ Bug 1276522: Mek that used TAG can't physical attack
+ Compact Gyros Implemented (HMP and MTF files only)
+ XL Gyros Implemented (HMP and MTF files only)
+ Partial implementation of heavy duty gyro, small cockpit, torso-mounted
    cockpit, command console, dual cockpit.
+ Added X-Pulses to MTF_names.
+ Tweak to Mech Verifier output for level 3 gyros/cockpits.
+ Corrected Cougar-X3 MTF in dark_age.zip.
+ Bug 1277017: Made quads lose all four hips on a failed MASC check, pending
    an official ruling.
+ Fully implemented small cockpit.
+ Added kludge to build.bat to get it working again.
+ Bug 1279514: war of 3039 weapons too small  
+ Small cockpit, compact gyro, XL gyro now load from TDB XML files.
+ Made cockpit and gyro display strings properties-driven for l10n.
+ MaxTech vehicle fires
+ Update client's copy of an Entity when it dies, so MekWars can autoreport.
+ Added Armored Cowl (MFUK); TODO: Hits from the side shouldn't ignore cowl.
+ Added recognition for Armored Cowl to HMP and BLK loaders; MEP and TDB remain
+ Armored Cowl should now work as intended
+ Missing loaders for Armored Cowl
+ Forgot to update MTF_names.txt
+ Refactoring of toHit() - pulled all checks for impossible into a single 
    function
+ Bug 1282452: searchlight button stays disabled after cancelling fire  
+ RFE 1249701: Auto SearchLight Option in client.
+ possible fix for bug 1280958 (using searchlight in physical phase prevented 
    the phys attack)
+ RFE 1282579: Add and Track Buildings using mapsettings
+ Thin ice
+ Removed build dependency on collections.jar
+ Added rubble and fortified terrains to RMG, frozen water special effect makes
    thin ice
+ Removed collections.jar
+ Bug 1284368: Fallen mechs sent to the center of the earth.
+ Bug 1284758: short range targeting not working under min range
+ Assault drop
+ Bug 1278753: Artillery heat added twice in display
+ Bug 1287029: initiative bug with 5 protos/infantry per mech
+ RFE 1239960: auto-skip TAG and c3-m with tag
+ Streamlined check for RFE 1239960
+ Initial implementation of custom BA construction dialog.
+ Custom BA equipment list didn't update if tech base was changed.
+ Added ability to add items to custom BA locations separately.
+ Added ability to remove items from custom BA.
+ Torren's active probe patch
+ Bloodhound active probe can detect unarmoured infantry & stealth units, other
    probes can't
+ Torren's GameOptionsDialog patch
+ Added a couple more pieces of equipment to Custom BA Dialog.
+ Bug 1288302: No woods to-hit modifier in sublevel woods
+ Indirect LRM fire using semiguided vs TAGged target has no penalty
+ Level 3 terrain from maxtech (except geyser eruptions)
+ Carpe Mortis' mud & magma tiles
+ Carpe Mortis' sand & tundra tiles
+ Bug 1289255: semiguided lrm ammo can be used as normal ammo  
+ Bug 1286809: Falling In Water Doesn't Work Right

v0.30.0 (2005-08-15 8:00am) STABLE RELEASE!
+ Bug 1241319: Now checks for missing position when unloading infantry.
+ Bug 1234949: Checks for null positions on cluster/swarm logic.
+ Bug 1254924: If a scenario is populated only by bots, the host is now added
    as an observer instead of not getting a client window.
+ New Mechs for Batchall.de, a little later than normal
+ Bug 1255373: protomechs roll for maxtech engine explosion
+ Bug 1255323: Can't find AI readme.txt
+ Bug 1255967: Customize Mech dialog now scrolls horizontally when Rapid Fire
    MG is enabled.
+ Sylph microbombs should not damage flying units in the target hex.
+ Patch 1253824: Cross-Platform MenuBar Accelerator bugfix
+ Patch 1253829: MechSelectorDialog: Disable List during Update
+ Patch 1256335: Added Zoom capability to BoardEditor
+ Bug 1246589: Missing Unique ID in logfile.
+ doSetLocationsExposure does not need to check for pavement, because
    currently, all bridges are on lvl 0 water anyway.
+ Bug 1240408: NPE in bot's deployment when bot has corner deployment zones.
+ Bug 1257498: fire and vacuum options should be mutually exclusive.
+ Bug 1259068: Artemis IV bonus wrong when ECM present
+ Bug 1258607: java.lang.IllegalArgumentException with Buildings RC4
+ Bug 1235347: Water doesn't impede LOS for weaponfire

v0.29.87 (2005-08-08 8:00am) RELEASE CANDITATE 4!
+ Bug 1246893: Swarm-LRM crashes MM
+ Fix some server report newline issues.
+ Possible double-blind exploit fixed.
+ Bug 1240895, Patch 1247970: Changing facing after standing in water while
    running.
+ Bug 1244125, Patch 1247767: non-fatal exception in
    BoardView1#drawArtilleryHexes.
+ Bug 1247741: NPE during exit after hosting a savegame.
+ Newline issue when falling during movement.
+ If a player has more than one unit with the same name, a "#N" gets added
    so that the units can be distinguished.
+ Bug 1241730: Game does not always check for victory.
+ Rename View->Turn Report to View->Round Report and remove redundant
    View->Initiative Report.
+ Bug 1248927: Bot NPE with BA weapons.
+ Bug 1248946: No more asking position on attacks against iNarc pods.
+ Remove unnecessary linebreaks and fix indentation for breach reporting.
+ Bug 1249603: Themes don't work when shruberry.txt is used as hexset.
+ Corrected copyright in startup.sh; use "-z" flag of "test".
+ Fix bugs introduced by "#N" feature above.
+ Batch file is now launched by friendlier looking exe file with icon.
+ Removed text-only heatsink activation/deactivation command.
+ PM says "no indirect LRM while attacker has direct LOS to target".
+ Updated german translation of server reports.
+ Bug 1247625: Don't show "fell down during movment" popup to bot client.

v0.29.86 (2005-07-27 1:25pm) RELEASE CANDIDATE 3!
+ Unloaded units now should always get their elevation set correctly.
+ Translations for server messages
+ Bug 1240512: Missing Consciousness-Check report.
+ Bug 1240618: all clan double sinks showing as lasers
+ Do not automatically fail skid charges.
+ Bug 1240402, Patch 1240555: searchlights & laser heatsinks pt2.
+ Bug 1240635: Ejected Mechwarrior in log file.
+ Bug 1240909: Basilisk 2 should have 10 shots of SRM2 ammo
+ More translations
+ Bug 1241053: Unconscious pilot automatically wakes up on ejection.
+ Lots of server report linebreak/indent fixing.
+ For debug purposes, show all units' elevation in MechDisplay.
+ Pictures for Arbalest, Basilisk, Chrysaor, Fire Scorpion, GDL Scout BA, Orc,
    Stalking Spider.
+ Don't say "Vacuum breach" if a tank dies from water breaching.
+ Bug 1241102: Moonscape maps were buggy (rough was not really rough)
+ Bug 1241081: Bot NPE when deploying and player has offboard arty.
+ Bug 1241182: Flying VTOLs can load infantry that is on the ground.
+ Bug 1241147: Stray white pixel on SW hexside of lunar rough.
+ Bug 1241150: infantry can only move forward.
+ Patch 1241389: patch for bug 1236506
+ Patch 1241331: Minor bot patches.
+ Minor tweak to "move even" report; added "move even" report to ..._de file.
+ Bug 1240663: Clear the turn report when the game resets.
+ Disable 'Select', 'Select & Close' buttons if there is no selected
    Mech in MechSelectorDialog
+ Translations of added report messages
+ Bug 1240465: Old firing arrows not cleared during 2nd game. [D.84]
+ Added Snow Fox pic.
+ Bug 1239630: Weaponfire now clears if you change the number of heat sinks.
+ Bug 1241117: Load button refresh fixed.
+ Bug 1241156: mapgenerator settings dialog is tiny
+ Avoid NPE in canSee function.
+ Bug 1242061: Lot of NPEs when you edit map
+ Bug 1242122: NPE in the MapEditor when you press the ctrl/alt key
+ Bugs 1241986, 1241324: Fixed stacking to hopefully correctly handle elevation
+ Bug 1234778: Themes in Map Editor don't work
+ Bug 1242355: Corrected NPE caused by BoardView1.
+ Bug 1241721: Elevation was not being set correctly when jumping across water.
+ Bug 1240663: Playing a second game messed up reporting system.
+ When a user has auto-scroll on and clicks a hex to select a unit near the
    edge of the map, the unit was not being selected.  Fixed now.
+ Bug 1242303: Attack arrows for charge not removed
+ /localsave did not work when savegames directory was not present.
+ Bug 1235228: Now can load mixed-tech armor type correctly from file.
+ Bug 1242589: Update to above fix "Avoid NPE in casSee function" to provide
    some information to the log.  Also cleaned up some debug lines that were
    bloating the log to an unreasonable size.
+ In double-blind games, the "has been seen" status of a unit was not updating
    until the first unit had moved.  Fixed now.
+ Bug 1242587: Deployment initiative report was missing.
+ Bug 1239617: Water PC now appears to be working again.
+ Bug 1242773: Stop NPE from attempting to club a non-entity target.
+ Swarming swarm/swarm-i missiles should not give "Can't target yourself"
    impossible to-hit.
+ Bug 1243674: Clan Artemis-capable ammo typo.
+ Bug 1243849: DFA damage misreported.
+ Bug 1243929: Artillery and VTOLs
+ Bug 1243929: Check for VTOL was not exhaustive
+ Fix for Bug 1240663 was faulty, this one should work better.
+ Renamed MegaMek.sh to startup.sh to avoid confusion.
+ Sylph microbomb targets should not get -4 (immobile) to-hit modifier.
+ Sylph should get +1 target movement modifier when expending VTOL MP
+ Bug 1243589: sylphs unable to fly in extreme temperatures.
+ Bug 1245339: Units could not be loaded after deployment.
+ "Load" and "Unload" were not always showing up after button press.
+ Bug 1245372: Units deployed on a hill cannot be unloaded.
+ Indications added for VTOL climbs/descents during move phase.
+ Bug 1244577: Errant Pixels on Catapult picture.

v0.29.85 (2005-07-18 1:05pm) RELEASE CANDIDATE 2!
+ Bug 1239985: Fleeing now works again.
+ Fixed some more newline problems in reports.
+ Bug 1240263: Exception when movement ends in water.

v0.29.84 (2005-07-18 8:45am) RELEASE CANDIDATE!
+ The editor-readme.txt was moved to the docs/ subdirectory.
+ Untangled client package from GameOptions class (common package).
+ Bug 1235652: Possible to see opponents predesignated artillery hexes
+ Patch 1235650: Bot tactics: physical attacks and weapons
+ Bug 1235634: Ejected pilots still take damage from heat
+ Bug 1235347: Water now appears to affect LOS correctly.
+ Bug 1235833: remaining Swarm missiles targeting Stealth Mechs.
+ Bug 1235708, Patch 1236081: onboard homing Arrow IV NPE.
+ Button to remove a unit in the deployment phase, in case no valid
    deployment hexes are available.
+ Bug 1236201: Crit Reporting in entitystatus.txt.
+ Remove Java 1.1 hack.
+ Bug 1236319: aimed shots not working.
+ delivering vibrabombs was not working.
+ Update status bar in Indirect Targeting phase
+ Bug 1236387: Elevation shown in movestep for non-VTOLs.
+ Fixed NPE in Server for entity with null position in deployment.
+ Fixed major errors in elevation calculation for units.
+ Added future compatibility for showing elevation for subs.
+ Changed display of Heat Effects in MechView (Prepares for RFE1021681, which
    would otherwise need to duplicate this code).
+ Bug 1236620: VTOLs and buildings
+ Bugfix for bugfix 1236620
+ Bugfix for bugfix for bugfix for 1236620
+ Fix elevationOccupied() for VTOLs, it now is only in Entity and checks for
    MovementType, instead of having a custom one for Tank
+ Finally fixed all entity elevation issues.
+ Don't show danger marker in movesteps when moving a hover or naval unit above
    water.
+ Bug 1236475: revert UTF-8 fix because MS JVM can't handle UTF-8 code.
+ Expanded tabs to spaces in the .java files
+ Patch 1236288: Searchlights, Compact Heat Sinks, Laser Heat Sinks (partially)
+ Bug 1237499: LOS reporting feature has same hex number for start and dest.
+ Bug 1237561: protomek mapset shows negative numbers if armor/IS is gone.
+ Bug 1237956: Bot attempts to unjam destroyed RAC
+ Patch 1231130: CBT Companion BA Support Weapons. See data/mechfiles/readme.txt
+ Make the chat lounge tab font size an advanced option.
+ Bug 1237748: VTOL damage out of sequence.
+ Final complete fix for Swarm and Swarm-I missiles.
+ Players need to choose Artemis Capable munition if they want to get the bonus
    from Artemis IV.
+ Added Sylph pic.
+ Bug 1238916: Falling into water
+ Clan units could not use Semi-Guided LRM Munition even if "ignore clan
    equipment limits" was checked.
+ Bug 1239107: Sylphs unloaded at wrong elevation.
+ Bug 1236620: VTOLs and Buildings, now completely fixed.
+ Bug 1239097: Sylph Micro bombs not working correctly.
+ Bug 1239194, Patch 1239221: iNarc Ammo doesn't load from TDB units.
+ Patch 1238506: David Light Gauss Rifle (Combat Equipment).
+ Bug 1237582: when targeting woods, modifier for target being in woods.
+ In extreme temperatues below -30°, heat display in MechDisplay was wrong.
+ Patch 1239296: Bot works again with battle armor weapons.
+ Bug 1239367: NPE after deployment with offboard units in double blind games.
+ Bug 1239105: Unload now works as first and only step.
+ Stop broadcasting changed heat sink status on general chat.
+ Bug 1234866, Patch 1239594: bot deploys in same hex.
+ Bug 1239798, Patch 1239772: BA SRM/LRM Ammo Fix.
+ The report system has received a major overhaul.  This addresses several
    RFE's, including: 676377, 704795, 770839, 770840, 879802, and 1098720.
+ Added some missing reports.

v0.29.83 (2005-07-10 11:00am)
+ Patch 1231769: flare LRM & illumination artillery.
+ Bug 1231904: Fix for MS JRE.  Vector.set() bad!  Vector.setElementAt() good!
+ Data 1230132: Unit Images for Karnov, Warrior and Yellow Jacket VTOLs, Sea
    Skimmer Hydrofoil and Scimitar Hover Tank.
+ Bug 1000958: Infantry leg and swarm attacks shouldn't be possible to be aimed
+ Prevent Bot/AMS NPE when firing MRM 30 or 40.
+ Bug 1048473: Bot doesn't click done in designate artillery hex phase.
+ Bot now clicks done in Offboard and Targeting when he has a unit with TAG or
    Artillery.
+ Bug 691362: can deploy on top of unseen mechs. This is realized by not
    allowing players to choose overlapping deployment zones while playing
    double blind games.
    If you by some circumstances need overlapping deploying zones (e.g. more
    than 4 players in a DB game, or team games where 2 players start on the
    same side, disable the game option "exclusive_db_deployment".
+ Missing translations and removal of duplicates in *.properties - again!
+ Bug 1231672: Mackie incorrectly listed as level 1
+ Missing TechLevel display in MechSelectionDialog for Mixed Tech units
+ Show heatbuildup/dissipation from extreme temperature in expected heat
    display in MechDisplay
+ Sylphs unloading from VTOLs should be unloaded to the elevation the VTOL was
    flying at.
+ Allow Sylphs to fly over water.
+ In MechView, don't show "unknown" as armor type for BA.
+ Bug 1174455: animated movement not working.
+ LBX Glancing blows should deal damage.
+ Bug 1232365: Incorrect BV: All units with normal autocannons.
+ VTOLs get +1 to-hit only when they used MPs.
+ Show what movementtype VTOLs used in MechDisplay.
+ Show correct movementtype for Sylphs in MechDisplay.
+ Bug 1227724: too many missiles hitting in swarm attack. Also corrected to-Hit
    calculation for swarm missiles that try to target another unit.
+ Make VTOLs lose movement on a 12 on a crit roll, and make the main weapon
    destroyed on a 9 on a crit roll on a side table. Note: These are not
    reported to the serverlog.
+ RFE 1231014: auto-skip out of ammo weapons
+ RFE 1161913: "back up" movement arrow in different color
+ Replaced hacked int for animated movement with a Java object.
+ RFE 1048695: Limit Off-Board Distance
+ Bug 1232815: VTOLs now only set off Thunder-Actives.
+ Bug 1171594: Added check to bot to reduce chance of standing when impossible.
+ Fixed NPE in nextWeapon check from RFE 1231014.
+ Bug 1233036: Altered loader to accept alternate names for "Tank".
+ Fixed several physical NPEs against non-entity targets.
+ Patch 1233142: Bot equipment usage: stealth armor mode switching.
+ Default images for naval units, different default images for different
    vehicle types (tracked, wheeled, hover) and weight classes (heavy/assault)
+ Bug 1232714: All currently-existing MWDA units now canon by the list.
+ Fixed listings for a number of infantry types in the canon list.
+ Data 1223604: updated some lvl3 mechs.
+ Bug 1231990: Fixed exception from null entity position.
+ Bug 1232097: TDB loader now correctly puts in Clan TCs and XLs on IS Mixed
    Chassis.
+ Bug 1115591: Bot now rotates the turret to shoot something behind them.
+ Created a *nix shell script to run MegaMek.  Creates $HOME/.megamek and adds
    a symbolic link to the data directory.  Defaults to looking for JAR files
    in /usr/share/java/ and the data directory in /usr/share/MegaMek/.  These
    defaults can be overridden.  Only tested on a Debian Linux installation.
+ Added MegaMek.sh to "packageCode" Ant target.
+ Fixed bad escape sequence in MegaMek.welcome.message.
+ Bug 959012: Stacking Violation after multiple DFAs
+ Eliminated one of the possible memory leaks
+ Bug 1002223: Target in Rear, and firing arrows
+ Bug 899693: Player names now altered to disallow duplicates.
+ Corrected bug in player name correction relating to ghosts.
+ Bug 1234236: No more Minefields Delivered by LRM
+ Bug 901995: Corrected HMVee loading of OmniVees
+ Implemented HMVee loading of engine types
+ Corrected engine loading of HMV and BLK
+ Corrected Svantovit Streak-SRM unit file
+ Bug 1053297: Multiple minefields not clearing
+ Bug 1234480: Corrected stacking/moving through enemies.
+ Bug 755090: unit missing in deploymemt w/3 infantry per mech move option.
+ Bug 692963: After a missed DFA, the target now chooses same-elevation hexes
   to displace before considering higher-elevation hexes.
+ Bug 1107637: Scenario pre-determined deployment doesn't work.
+ Bug 1001028: Altered MUL save/loader to do vehicle movement and turret locks.
+ Bug 1235224: Applied change to Air Car.
+ Bug 1235225: Applied change to ADV10.
+ Bug 1235226: Applied change to Condor MPT.
+ Bug 1235229: Applied change to Interloper UST.
+ Bug 1235232, 1235233, 1235234, 1235235: Made IS M.A.S.H. trucks Level 3.
+ Bug 1235238: Made Mobile HQ (Kurita) Level 3.
+ Bug 1235240: Applied change to Rommel II(C) (SSRM).
+ Bug 1235242: Applied change to Skimmer.
+ Fixed Java 1.1 incompatibility introduced by fix for bug 1002223.
+ Bug 1002223: Target in Rear, and firing arrows -- Bugfix for bug in bugfix
+ Bug 1235241: Eliminated Pike Support Vehicle from unofficial file.
+ Bug 1235237: Added M.A.S.H. Vehicle (MIT23) to dark_ages file.
+ Bug 1235239: Added Mobile Tactical Command HQ to dark_ages file.
+ RFE 790452: Savegame to a different machine
+ Bug 1235365, Patch 1235369: Don't allow bot to twist torsos 360.
+ A bugfix for a bugfix for a bugfix for 1002223.

v0.29.82 (2005-07-03 11:00am)
+ Patch 1219378: Bot weapon controls, final, correctly working version
+ Patch 1223701: Bot equipment usage: Stealth armor, RAC unjamming
+ Allow Shift+arrowkeys torso twisting in off-board targeting phase, too
+ Bug 1020765: Fixed the game so it doesn't crash if the camos directory
    is missing.
+ Bug 1223820: Fixed HMVFile so it should now load surface and hydrofoil
    ships.
+ Corrected Clan Arrow IVs (didn't need prefix, prefix broke some 'mechs)
+ Bug 1223837: ArrayIndexOutOfBounds exception when verifying naval units.
+ Bug 1223841: Do not allow TAGging during DFA.
+ Prevent NPE when not targeting units, but woods/buildings etc.
+ Bug 1220797: NPE in deployment phase
+ Bug 1223864: VTOL displays mis-named
+ Extracted common functions for several DisplayMapSets into a common file.
+ Bug 1224051: Capitalization matters in names of Triton 2's ER Micro Lasers.
+ Bug 1223867: TAG attack arrows remain on map
+ Bug 1224230: Homing Arrow IV uses wrong attack direction
+ Refactor of elevation from VTOL into Entity, to ensure that only one
    version of getElevation exists and always returns a correct value.
+ Change of expectation of elevation value (vs. zero, vs. floor, vs.
    ceiling) to match in various places it's called.
+ Bug 1224438: Checks for null entity and hex to avoid NPE.
+ Bug 842048: Fix div/0 error.
+ Bug 1224274: Repaired Ferro Fibrous and Endo for TDB loader.
+ Bug 1225301: The Glass Spider doesn't make use of its shiny new sprite.
+ Changed armor display for protomechs; fixed initialisation error -
  - proto.hasMainGun() was always true.
+ Patch 1225186, Bug 1224520: Repeated NPEs on loading images
+ Bug 1020921: (Bot) End of Game screen passing too quickly
+ Bug 1225642: Fixed possibility of infinite recursion in bot deployment.
+ Bug 1224504: Artillery attacks no longer freeze MS JVM.
+ Bug 1225945: Fixed jump elevation limit check.
+ Bug 1219996: Fixed elevation checks for physical attacks.
+ Bug 1225949: Player Setup menu after defeat at the hands of a Bot. 
+ First steps towards automatic cost calculation.
+ Added costs for most weapons.
+ Added costs for remaining non-BA, non-infantry weapons.
+ Fix references to data/camo, data/widget, data/mex to data/images/camo,
    data/images/widget, data/images/units.
+ Move MegaMekSettings.XML to mmconf/clientsettings.xml, move gameoptions.xml
    and bot.properties to the mmconf folder.
+ Bug 1224458: Targeting computer mixup on mixed-tech HMP files fixed.
+ Bug 1226159: Heavy Machine Gun bug fixed for TDB mech loader.
+ Minor refactoring of the usage the data/widgets/* files.
+ cost stuff; a few helper functions, a (I hope? can't test) calculation for
    biped mechs.
+ Minor update to EquipmentType's helper function for armor point multipliers.
+ Bug 1227724: too many missiles hitting in swarm attack.
+ Small improvement of the generation the manifest.mf in the build.xml.
+ Bug 1223722: TAG ignores torso twist.
+ Bug 1223955, Patch 1226590: MaxTech partial cover part 2.
+ Error in cost calculation for biped Mechs (not all arm actuators were 
    accounted for).
+ Cost for Ammunition.
+ Created "savegames" directory.  Added "very paranoid autosave" feature.
+ Bug 1226724: Corrected BV
+ Bug 1226725: Corrected BV
+ Bug 1226726: Corrected BV
+ Bug 1226727: Corrected BV
+ Bug 1226728: Corrected BV
+ Bug 1226729: Corrected BV
+ more cost stuff.  Biped mech BV is semi-correct (in some cases, needs more
    testing) and all costs (0 for everything but biped mechs) are displayed in
    mech selector.
+ Bug 1227183: Corrected vehicle files and update BLK loaders.
+ Corrected build.xml to allow using Ant 1.6.2
+ Added assertion in Mounted#setMode.
+ Added check for Entity existance before drawing it as moving unit.
+ Streamlined & debugged Biped mech cost (Still wrong in many cases, especially
    IS Level 2 and Clan)
+ Cost for Quad mechs (not calculating perfectly, too).
+ Allow sorting the units in MechSelectorDialog by cost.
+ Cost for BAs and Infantry (BMRr & MTR only).
+ Show cost in Chatlounge.
+ Bug 1226732: Read Me for the mechfiles out of date.
+ Cost for Vehicles (Approximation only, there is some needed data missing)
+ Bug 1224507: "Use maps from subdirectories" option doesn't work properly
+ Bug 1225495: cannot scroll to upper map-edge
+ Patch 1229086: MaxTech Partial Cover, only give vertical cover when the
    cover is adjacent to unit.
+ Fixed tank cost calculation, also bug with clan CASE (and cost)
+ RFE 1121035: Quads get their own ArmorPanel.
+ Bug 1229455: Configure mech dialog shows enemy units in blind drops.
+ Patch 1229229: Option to show mapsheet borders on the map.
+ Don't crash when firing swarm missiles to clear woods.
+ Bug 1229874: Exception when drawing minefields.
+ Bug 1215899: Wreckage for crashed VTOLs now appears in the right place.
+ Fixed NPE when VTOLs sideslip off the map.
+ Bug 1229232: Another HMP machine gun issue fixed.
+ Bug 1226731: BV corrected.
+ Bug 1226730: BV corrected.
+ Bug 1226726: Equpment added.
+ Mek selector dialog: Add options for what should be displayed in list.  Also
    improve sizing and initial location.
+ Unit cache now remembers cost properly.
+ Bug 1042069: Now checks for units in vacuum like extreme temperatures.
+ Bug 1224433: Sylph now appears to move correctly!
+ Major mod to VTOL movement type (addition of VTOL_WALK and VTOL_RUN).
+ Minor feature - skip blank button panels on MovementDisplay.
+ Bug 1224335: VTOL default wreck now shows.
+ Commented out line in Tank#getCost that output the tank's name.
+ Make sure cvsdev-package and jar tasks produce identical MegaMek.jar files.
+ Don't need properties directory in megamek-code-*.jar files.
+ Partial refactor of munition type checks.
+ Patch 1230249, Bugs 1224113, 1224451: Arrow IV homing targets mapsheet.
   The server tries to share out homing missiles fairly among TAGs fired
   at targets on the same mapsheet. 
   TAG has a "mode" setting, allowing that TAG shot to take 1,2,3 or 4 shares
   of the incoming missiles. This allows the player some control over target
   priority (e.g. send 3 missiles at the Atlas and 1 at the Marksman).
   If there are more incoming missiles than the sum of the priorities, it
   starts over (so no need to mess with mode
   setting at all if you just want an even split).
   The "Rulebreaker" option "a4homing_target_area" uses 8 hex radius from the
   target hex instead of mapsheets for eligible targets.
+ TAG should not be able to target infantry.
+ Arrow IV homing misses still do 5 damage when they miss but the TAG hit.
+ Patch 1230251: IS Copperhead ammo for Sniper and Long Tom.
+ Bug 1228911: AmmoType and friends refactored to use a long flag for
    munition types.
+ Force ammo type check when checking against munition types in almost all
    places throughout the code.
+ Bug 1224336: /reset didn't clear out artillery attacks.
+ Patch 1229924, Bugs 1229105, 1228454: Another MT Partial Cover Bug.
+ Bug 1230607: C3 Masters should be able to TAG.
+ Bug 1042069: Allow Fusion Vehicles that have Vacuum Protection to survive in
    vacuum. To add Vacuum Protection to a unit, give it an equipment named
    "Vacuum Protection".
+ Bug 1174457: after /reset minefield's wouldn't work.
+ more cost fixing goodness.
+ Bug 1194504: Added "done" marker to right-click and pop-up window on
    BoardView1, to make it easier to determine if something has moved.
+ Allow autoeject setting in Scenario files.
+ Minor change to IEntityMovementType for future work on submarines.
+ AmmoType refactoring broke LBX ACs.
+ Code for parsing autoeject setting wasn't compatible with pre-1.5 Java
+ Bug 1224232: Now correctly penalises BV for TAG and homing rounds.
+ Created new /logs directory and moved appropriate files there.  Also
    renamed MegaMek.log to megameklog.txt for ease of use.
+ Bug 1230913: Old techbase bugfix for HMPRead not committed until now.
+ Added OfficialUnitList.txt--massaged version of an official unit list, 
    with name of each official unit, who uses it, type, date of manufacture.
    Should make for easy official unit checking/time period restriction/etc.
+ Patch 1231268: AC incendiary and tracer ammo.
+ Bug 1231362: Verification of custom TDB meks not working
+ Fixed build.xml to create the logdir if neccessary
+ Build.bat should be working again.
+ Obsolete TODO in EntityListFile.java was only valid when we created an EXE;
    produce XML files in UTF-8 format.
+ Added TODOs to handle slotless equipment and tank crits.
+ "Canon units only" option added--doesn't work 100% of the time, bunches of
    our unit names (like all infantry) are wrong, according to my master list.

v0.29.81 (2005-06-19 3:45pm)
+ Bug 1219175: Can't access client settings with MS JRE
+ Bug 1219313: "configure unit" not working for mechs with MGs
+ Several fixes for the Microsoft JVM, including bug 1219222,
    bug 1219175(sorting re-enabled), bug 1219401, and a re-enabling
    of scenarios.
+ Change button text on mek selector so preview has more room.
+ Patch 1219378, RFE 1216109: Bot weapon controls
+ Underwater ammo dumps are legal, says the PM.
+ Bug 1214278: Customize mech window now sizes correctly.
+ Patch 1217913, RFE 1013642: UI for artillery targets and auto-hit-hexes
+ Bug 1219868: Removed duplicate Kesterl VTOL.
+ Patch 1219841: MaxTech partial cover.
+ RFE 1100565: Darken the map for night battle
+ Picture for Bloodhound
+ Bug 1219814: VTOL wreck image missing.
+ Added Ninja-To, Solitaire, Huntsman Prime pic
+ Added Endo-Steel and Ferro-Fibrous prototype from War of 3039 book.
+ Pics for Anhur and Donar VTOls.
+ Bug 1219924: Corrected verifier for loading units based on option.
+ Bug 1219991: Updates elevation buttons on moves.
+ Minor correction to Endo Steel Prototype implementation.
+ Change of Structure type and name to match current Armor implementation.
+ Addition of Composite and Reinforced Structures, loadable from HMP/MTF files.
+ Bug 1219501, 1219502, 1219503: Added ability for VTOLs in BLK form to be read
   as level 1 regardless of year, and fixed four VTOLs.
+ Bug 1219922: Let VTOLs pass over other units as long as they're high enough.
+ Bug 1219997: Players should not be able to turn off their opponents' mech's
   heatsinks.
+ Bug 1219886: Mantis VTOL should not have BAP/ECM.
+ Missing translation for VTOL movement buttons & menu entries
+ Bug 1220332: VTOL sideslipping not working correctly.
+ Show VTOL current elevation in MechDisplay.
+ Make VTOL flight elevation relative to surface of hexes, not floor
   This causes less confusion when flying above water hexes.
+ Bug 1220129: HMVee now should load VTOLs.
+ Correct TechConstants to allow pretty much any equipment of known tech level 
   if the unit's level 3 (un-breaks mixed tech units).
+ Bug 1219499: Tweak to bot movement code to eliminate stacking violations.
+ Bug 1217504: Vibro-claw damage bonus added to leg and swarm attacks.
+ Bug 1220825: it should not be possible to target non-wood hexes to try to
   clear them.
+ Fixed most of the mistakes in BV calculation for VTOLs. Some VTOLs are still
  wrong.
+ Mantis Light Attack VTOL has ECM and BAP: (see
  http://www.classicbattletech.com/cbt_errata_TR3060.html)
+ Patch 1220922: Bot equipment usage: TSM
+ Initial implementation of surface naval vessels and hydrofoils
+ Added flak rules for LB-X Cluster vs. VTOLs.
+ Fixed NPE for map editor where BoardView1 referrenced a null clientgui.
+ Added lift equipment to unit verifier for VTOLs, Hydrofoils, Submarines.
+ Fixed NPE for bots in Compute where a weapon didn't have a current firing 
   mode.
+ Bug 1215885: landing vtol issues
+ Bug 1215877: landing vtol issues
+ Updated build.xml in anticipation of moving *.properties to their own dir.
+ Bug 1222249: Clan LVL3 RACs don't load from TDB files.
+ Bug 1222152: Can't customize artillery ammo.
+ Do not allow clan units to choose Anti-TSM or Listen-Kill ammo
   when the "clan ignores equipment limits" option is not checked.
+ Bug 1215898: VTOLs have wrong engine type
+ Bug 1221655: Fix stacking check to take account of target hex, not starting
   hex, for moving/deploying unit.
+ Bug 1222251: Mobile Long Tom now correctly labelled level 2 (though it still 
   doesn't verify for other reasons).
+ Added the rest of the torpedo weapons.
+ Corrected torpedo ranges in WeaponType and added logic to force
   underwater-only weapons to not fire above water.
+ Allow One-Shot LRMs to be fired indirectly.
+ Bug 1222251: Altered Mobile Long Tom to only have standard ammo in the
   vehicle file.
+ Bug 1222907: Fixed Flak to work against anything using VTOL movement, but 
    only if it's above the ceiling of the hex.
+ Bug 1222886: L3 Mech Plasma Rifle no longer reading as infantry weapon
+ Allow players to choose to load Fa Shih squads *inside* APCs.
+ Fa Shih squads now clamp to the outside by default.
+ Bug 1222782: Indirect torpedos no longer fly nor teleport to go over land.
+ Bug 1222945: fixed major hack in DFA code causing array bounds exception.
+ Bug 1215905: rotor destruction doesn't kill a VTOL.
+ Fixed flak bug.
+ Allow the many non-torpedo weapons with a short range of zero to attack.
+ Patch 1223382, RFE 899953: TAG, homing Arrow IV and semiguided LRM.
+ Bug 1217299: TAC on destroyed location didn't transfer
+ Bug 1222839: Modified ammo mutators to allow verification of IS units
    when loading from file or unit list.
+ Bug 1223603: 3 batchall.de mechs bugged; preliminary solution pending repair
  of 2 of the 3 HMP files.
  
v0.29.80 (2005-06-12 4:30pm)
+ Corrected the i18n of the locale option in the CommonSettingsDialog.
+ Edits to a number of units to correct Mixed-Tech to level 3 from level 2
+ Added Acid-head warheads.  Also put in beginnings of more efficient armor
    type detection (non-exhaustive-search).
+ Bug 1215234: Spelling error in game options (This time for real)
+ Bug 1208625: infernos should be allowed to target any hex
+ Bug 1215866: vtols should be in vtol tab.
+ a VTOL's movepath sprite now displays its elevation.
+ Added light and heavy ferro-fibrous armor (Level 3).
+ Fixed compile error in Server.java
+ Added some corrections to HMPFile to load level 3 equipment.
+ Fixed problems with changing elevation levels (VTOL)
+ Bug 1216094: VTOLs can't back up over different level terrain
+ Bug 1215893: VTOLs have problems with water hexes
+ Bug 1216098: VTOL PSR nag screen
+ Bug 1215897: VTOL sideslip crash fall issue
+ Updated grass theme
+ Small cleanup of the IBoard interface
+ Bug 1216069: Mantis VTOL shows the same image as Mantis mech
+ Added default images for VTOLs and BattleArmor
+ Bug 1216071: Make "Add Unit" dialog remember tech level choice again.
+ Small cleanup/refactoring of the Entity and related classes/interfaces
+ Show armor type for Tanks in the Unit selector dialog.
+ Data 1216343: new default VTOL picture.
+ Bug 1216564: mechview armortype display wrong
+ NPE on loading images with VTOLs
+ Syntax Error in MtfFile: replace cannot be called for Strings, only Chars.
+ Corrected error with tech level verification on some one-shot weapons.
+ Correct standard armor detection for units (hopefully without breaking 
    versions before 1.5 this time)
+ Removed debugging code left over from an earlier update
+ Corrected ammo selection error stopping Clan units from getting alternate 
    LRM and SRM ammo.
+ Bug 1217038: Put in a check to only make a charge impossible if there's no
    interim STEP_GET_UP.
+ Altered BLK tank and 'Mech loaders to allow more specific definition of unit
    level beyond year.
+ Altered Self-Propelled Sniper and its ammo carrier from unnofficial.zip to
    make them load correctly as level 2 units.
+ Bug 1216076: Corrected Compute.stackingViolation to correctly take unit
    height and elevation into account.
+ Corrected Compute.stackingViolation to actually enforce the four-unit limit.
+ Bug 1215880: Change Elevation buttons now updated when clearAllMoves called.
+ Bug 1215881: MovementDisplay added as a KeyListener to MovementDisplay's 
    child buttons.
+ Fixed NPE in CustomMechDialog to do with targetting system selection.
+ Corrected engine type in VTOL data files from air.zip
+ Bug 1207706: Vibro-Claws come singly or in pairs, so show this in displays.
+ New pictures for Corona, Golem, Hellfire, Spirit, Beowulf, Conjurer, Cronus,
    Grand Crusader, Lightray, Mandrill, Yu Huang, Emperor, Glass Spider,
    Gunslinger, No-Dachi, Predator, Sha Yu, Tai-Sho, Thresher.
    Fixed pic for Shadowcat variants.
+ Bug 1217503: Vibro-Claws can only target Infantry
+ Dev Forum: Behaviour of Add Unit dialog changed, doesn't close after
    selection
+ No-Dachi was misnamed.
+ Added Sylph data file and change to BLKBattleArmorFile to make it load.  Not
    necessarily fully featured yet.
+ Bug 1216081: Only VTOL-able infantry may unload when you're above ground
    level.
+ Updated Snow and Grass theme.
+ The constants for the compass directions moved from Entity.
+ Prototype LB-10X AC not loading
+ MechSelector changed to 3-Button layout: Select (keeps the dialog open), 
    Select & close, Close.
+ Bug 1218551: Removed road bonus for VTOLs.
+ Bug 1219010: Streak-LRMs that miss shouldn't be able to start a fire, like
    Streak-SRMs.
+ Bug 1216083: VTOLs and Fires
+ Bug 1014263: Split weapons not working correctly
+ Bug 1219182: Garbled "Type" filter in MS JRE
+ Bug 1219222: Next/previous buttons don't work in MS JRE
+ Add movement color and delay settings to client settings (advanced).
+ Bug 1219181: NPE when firing at mech that is DFAing.


v0.29.79 (2005-06-08 8:00am)
+ i18n of the Equipment
+ Mule kicks for Quads
+ Bug 1180526: bot not clicking done when player unloads BA from omni
+ Unit verifier now lists what file each failed unit came from.
+ Bug 1208611: LRMs default to indirect mode and can't be changed to direct
+ Bug 1209357: Movement after unloading
+ ejected pilots should not be able to pick up other ejected pilots.
+ Task 106037: Swarm and Swarm-I LRM submunition
+ RFE 1007856, 903107: patch sent by Shane Kearns:
     Use RMG in the "New Board" dialog of the Map Editor, allow RMG maps to use
     themes, and lots of other RMG enhancements. See map-enhancements.txt
+ Infantry should not die when loaded in vehicles in extreme temperature
+ ejected pilots loaded in troop carriers should not be considered picked up
+ i18n of the launcher
+ Removed changes from client/messages_de.properties, they completely messed up
     the GUI.
+ Bug 1207269: lobby shows pilot advantage when weapon specialist: none and
     using one of the translations.
+ Patch 1209460: Level 3 'Mechs, Protected by Option
+ Bug 1209501: Exception when kicking while mulekick turned off
+ Added level 3 parsing support (but no level 3 equipment yet)
+ Preliminary steps taken to convert stand-alone unit verifier into built-in
     feature.  Previous megamek.test.entities package moved to
     megamek.common.verifier and TestAllEntities renamed to EntityVerifier.
     Other small changes made to bring it up to date.
+ Bug 1210956: Gnome missing its advanced SRM2.
+ Translation of Equipmentmessages
+ Removed duplicate lines from *.properties
+ Missing translations for client
+ Some more missing translations
+ Bug 1211456: Game#entities and Game#entityIds are not in synch
+ Patch 1211062: Bot deployment - needs double blind fix
+ Fix build.xml so that .properties files are included in the jar.
+ Unit verifier is now built-in.  Meks and vehicles are currently supported.
+ Show number of active heat sinks in Mechdisplay/Extras tab
+ Bug 1210993: Made RMG dialog scrollable
+ Heat effect display for heat >= 13 and < 17 showed +3 to fire instead +2.
+ Bug 1211535: couldn't use Tac. Genius if opponent already had.
+ Bug 1188638: Multiple current unit marker on minimap
+ Bug 1182138: PM says no underwater ammo dumps.
+ RFE 1057368: Change number of active heat sinks via button on Mechdisplay->
    Extras tab.
+ Moved Client GUI specific methods 'isSelected', 'setSelected' from class 
    Entity to class ClientGUI.
+ Patch 1212216, RFE 1123632: Streak LRMS
+ Dialog to change number of active heat sinks changed to use a slider.
+ Patch 1212351: Clan ER Pulse Lasers.
+ Patch 1212346: Unit verifier output in MegaMek.log when a unit is rejected.
+ Patch 1212743: IS X-Pulse Lasers.
+ Bug 1212867: Don't allow normal weapons to make Arrow-IV specific attacks.
+ Fixed layout problem with MechDisplay
+ Patch 1212964: Equipment tech levels
+ Bug 1163096, Patch 1213195: maximum Size of Maps (partial fix)
+ Patch 1213244: Laser AMS (Clan and IS, IS versions from MaxTech
    and Tactical Handbook) and minor AMS refactoring.
+ Patch 1213260: Unit Tech Level/Equipment Tech Level Verification
+ Updated MTF_names.txt for new level 3 equipment
+ Added GUI for chatlounge tab setting.
+ RFE 1081676: Ejected pilots auto-flee
+ Patch 1213780: Clan RACs (MechForce UK)
+ RFE 1057378: Prev/Next on Configure Units window
+ Prev/Next unit didn't refresh displayed data
+ Patch 1214273: Duplicate Variable Fix
+ Default locale set to english, locales now restricted to ones we support.
+ Chatbox size now adjustable
+ Added "advanced" tab to the client settings window.
+ Patch 1194414: fix memory leak
+ Cleanup of WeaponType Level 3 weapons
+ Bug 1213599: Procyon should have ER Small Lasers.
+ RFE 1048698: Make Off-Board Distance a Slider (A Slider Dialog, actually)
+ Bug 1214884: Swarm adds heat / uses ammo for each additional target
+ VTOLs added.  They should be complete, but watch out for bugs.  Use at your
    own risk.
+ 901959: Change in map-selection interface (sort of)
+ VTOL: Cleanup of code; VTOL-Files changed from type "TANK" to type "VTOL";
  UnitSelector changed (Does not quite work yet - use "All Types" to select 
    VTOLs).
+ VTOL: Show VTOLs as stars on the minimap
+ VTOL: Show FLight Level after unit name
+ VTOL: VTOLs can use flank speed when flying over water
+ Added framework for alternate targetting systems, protected by an option, and
    several level 3 systems (short-range, long-range, anti-air).
+ Bug 1215234: Spelling error in game options

v0.29.78 (2005-05-25 8:00am)
+ Bug 1202811: Game class is used directly instead of IGame
+ Bug 1203746: Settings for the LOS tool
+ Bug 1180419, Patch 1203291 Multiple Thunders stack over 20 points of damage
+ Bug 1145599, Patch 1203818: Bot always uses MASC until it fails
+ Bug 1201323, Data 1203226: Demolisher (Arrow IV) should have 38 turret armor
+ Added the assertion facility
+ Added the assertion for the deployment of the Bot's units
+ Fixed [DOS|U*x]-[DOS|U*x] cvs conversion problems for board files
+ Fixed the copyright for the megamek/client/GUIPreferences.java
+ Bug 1204346: Screwed up HS in BJ-2
+ Bug 1204544: "View Unit" in lobby does not work with german l10n
+ Default value of the 'friendly_fire' game option was changed to 'off'
+ Bug 1205157: ASRM-5 on Golems has incorrect range.
+ Bug 1185343: NPE in WeaponAttackAction.
+ Implemented the Prototype weapons from the War of 3039 sourcebooks,
    missile munition (listen-kill, anti-TSM) can be chosen as usual for custom
    ammo, The prototype Gauss Rifle, LB-10X, Ultra AC/5, ER-Large and Medium
    Pulse laser need to be edited in the mechfile. They each take one more crit
    than the normal versions of the weapon, and the equipment name in the mech-
    file needs to be appended by " Prototype", e.g. for a Gauss Rifle, instead
    of "IS Gauss Rifle", you write "IS Gauss Rifle Prototype".
    For MTF files, append "Prototype" without a space in front of it.
+ Thunder Vibrabomb damage should _not_ be in 5 point clusters.
+ Added some network debug code to client
+ Don't allow a player's opponent to set his opponent's Mechs' autoeject status
+ Bug 1207130: when ejecting a mech, sprite gets updated too late
+ Bug 1205317: MGs in rapid fire ignore ammo depletion
+ Added Swamp support to the random map generator.
+ Bug 1205396: I can not move (et al.) into a building with a mech.
+ Added image for VTOLs

v0.29.77 (2005-05-17 8:00am)
+ Bug 1198746: Basilisk 2 SRM2 ammo missing
+ Bug 1195283: sprites do not update correctly in game
+ Bug 1193520: attack sprites disappear after clicking done
+ Bug 1195279: deleting a unit in the lobby works only halfway
+ Bug 1199594: Hex class is used directly instead of IHex
+ Clarified faction name restrictions in Example.mms.
+ Additional translations (Game options)
+ Consider MaxTech heat scale for heat diagrams
+ Bug 1199491: deploying minefields doesn't work
+ Bug 1197622: Internationalization breaks dialog
+ Fix size in german localized mech selection dialog
+ Bug 1200799: punch message box has wrong text
+ Bug 1200288: /seeall during double blind
+ Bug 1200323: Ammo doesn't detonate from heat under certain conditions
+ Changed the Procyon's movement and BV per the Ask the Writer forum
    http://forums.classicbattletech.com/index.php/topic,20243.0.html
+ Don't add 30 heat when empty inferno ammo slot is hit.
+ Patch 1200105, Bug 1028373: Bot Takes Impossible Shots
+ Bug 1198377, Data 1200079: corrected Chevalier (Speed)
+ Data 1197033: updated mechfiles readme.txt
+ Changed BJ-2 in to DHS per official errata
+ Bug 1184320: new connections reset open game options
+ Bug 1197081: Unconscious pilots should not be able to avoid damage after fall

v0.29.76 (2005-05-09 8:00am)
+ Patch 1194720, RFE 1050894: Alternate Artillery Scatter Option
+ Bug 1195502: Continuing Golem ASRM5 problem
+ New picture for Kodiak
+ Bi-Monthly update on Batchall.de-Mechs
+ MaxTech Expanded Heat Scale and Avoiding Shutdown rule.
+ Internationalization: German translation for client
+ Some translations broke unit selection dialog, changed back to English
+ Data 1197659: New Combat Equipment Protomechs.

v0.29.75 (2005-05-03 8:15am)
+ Added -port parameter to set the port a dedicated server will be listening 
  to. Only valid if next parameter after -dedicated (and savegame name, if 
  there).
  See http://sourceforge.net/forum/forum.php?thread_id=1267994&forum_id=154580.
+ Bug 1189805: Golem ASRM5 doing 5 damage per missile that hits, instead of 2.
+ Patch 1187324: Settings refactoring. The previous implementation was 
    marked with symbolic tag 'before-preferences'
+ Removed dependence on AWT from class Entity and descendants.
+ Added Locust IIC 2, 3, 5, Piranha, Ha Otoko, Howler, Corvis pics.
+ Bug 1092078: Invalid Engine Crit Reporting (Maxtech Engine Explosions)
+ Removed dependence on AWT from classes Board, Hex, Player.
+ RFE 1024483: Chat lounge entity list now sorts by team and player.
+ Expanded tabs to spaces in the .java files
+ First step in gui/logic separation direction. The previous implementation
    was marked with symbolic tag 'before-guilogic-separation'
+ Bug 1191818: Java 1.1 compatability fix for client settings dialog.
+ Client options window was too large.
+ Various Java 1.1 compatability fixes.
+ Bug 1192795: Mek display shows auto-eject again.
+ Show unit's current BV (recalculated for damage) in the MekDisplay.
+ Data 1193401: Show appropriate pictures for Combat Equipment BAs.
+ Fix bug with display of BV on MekDisplay.

v0.29.74 (2005-04-25 8:15am)
+ Unconscious pilots could avoid damage when falling.
+ Units that can 'dodge' but not make any physical attacks
    now get a turn to declare their dodge maneuver.
+ Bug 1185216: setting game options not working.
+ Bug 1185258: pic problems.
+ Bug 1185495: Aerie BA should have only 1 armor.
+ Bug 1185682: Settings loading doesn't skip comments
+ Bug 1185492: Kobold TAG BA should have Light Tag only for Trooper 1.
+ Implemented storing/reading the user defined locale for ResourceBundles in
    MegaMek.cfg.
+ Bug 1185331: Golem Advanced SRM5 should have 2 shots, not 1.
+ Added option to disallow ejected pilots picking up/capturing other ejected
    pilots.
+ MaxTech engine explosions now kill the exploded Mek's pilot.
+ Bug 1188644: Brushing off iNarc pod crashes MegaMek.
+ Bug 1188591: Fixed Grenadier, Hauberk and Advanced Clan Armor BVs

v0.29.73 (2005-04-18 8:00am)
+ Bug 1176985: Nighthawk BA should have stealth.
+ Added Aerie BA.
+ Added pictures for Fire Falcon, Crossbow, Grendel, Hankyu, Hellion, Huntsman,
    Kingfisher, Linebacker, Nightgyr, Nova Cat, Phantom, Pouncer, Savage 
    Coyote, Shadowcat, Stooping Hawk, Turkina variants, Jupiter 1/2 and Lobo.
+ Added pics for Shamash, Shoden and Svantovit tanks.
+ Added pics for Icestorm, Maxim Heavy Hover Transport, Tyr, Odin and Dire Wolf
    Hohiro.
+ Data 1177157: added new battle armor squads as "combat_equipment.zip".
+ Data 1176308: added *most* new BA equipment.
+ Patch 1178079: Options refactoring, thanks Mev!
+ Operation under the MS JVM broke again - fixed now.
+ Timber Wolf Pryde, Incubus, Locust IIC 4 pics.
+ Bug 1053305, Patch 1172220: Artillery not damaging buildings.
+ Ordering fix for patch 1178079.
+ Added pics for Ares, Asshur, Athena, Badger, Centaur, Enyo, Harpy, Heimdall,
    Hydra, Indra, Ku, Morrigu, Satyr, Siren, Zorya.
+ Patch 1181482: String literals in Ruler#setText()
+ Patch 1181497: extract START_LOCATION_NAMES into interface
+ Patch 1182015: strings "externalization"
+ Patch 1182480: strings externalization-2 and related changes
+ Bug 1181830: "Any unit that doesn't act is a spotter" option still nags.
+ Changed behaviour for LBX cluster glancing blows, now the number of pellets
    is halved, effectively halving damage, and not the damage of each pellet
    halved to 0 (because of rounding down).
  
v0.29.72 (2005-04-02 3:15pm)
+ Data 1171465: Use the "lunar" theme in moonscapes boards.
+ Patch 1171880, Bug 1091243: after /reseting a game with minefields,
    can't start new game.
+ Patch 1172207, Bug 1057403: dead pilots taking damage.
+ RFE 1070596: adjust default facing in deployment phase for starting position.
+ RFE 994367: show heat generated for each weapon in unit selection dialog.
+ RFE 1018797: Automatic Spotter game option, so any units that did not fire
    can optionally spot automatically.
+ RFE 933288: Allow Backspace to "unfire" the last fired weapon in the Firing
    Display.
+ Bug 1121134: leg lost due to building collapse didn't cause immediate PSR.
+ Patch 1172957, Bug 1018871: gravity PSR when losing movement points in 
    movement phase.
+ Bug 1116020: made customize unit dialog scrollable, for mechs with lots of
    ammo.
+ Bug 1119505: can't customize long tom units when lobby_ammo_dump is on.
+ Patch 1173557, Bug 1173548: Client#die causes NPE when Settings.keepServerlog
     != true
+ Added Adder, Bane, Battle Cobra, Black Lanner, Blood Asp, Cougar, Crimson 
     Langur, Executioner, Hellbringer, Ice Ferret, Kit Fox, Mad Dog, Mist Lynx,
     Nova H, Stormcrow, Timberwolf, Viper variant pics.
+ Bug 1023852: duplicate entries in gamelog.txt when playing against bot.
+ Patch 1174580, Bug 1174465: crew dies during movement, after that, unecessary
     PSRs.
+ Bug 1152126: More mixed-tech codes added to HMP parser and HMPread.
+ Bug 1152127: HMPread fix for mixed-tech chassis name.

v0.29.71 (2005-03-27 9:30am)
+ RFE 1167547: Differentiating between club/hatchet attacks.
+ Patch 1168935: Extract AIM_MODE_* constants to interface.
+ LRM one-shot weapons should be able to fire indirectly
+ Patch 1169668, Bug 1115621: Falling debris: wrong amount applied.
+ Data 1165321: added grass, lunar, and mars themes.
+ Close gamelog when the Client dies

v0.29.70 (2005-03-20 4:00pm)
+ Bug 1163060: Warhawk variant images not showing.
+ Bug 1098838: unconscious mechs always make a PSR.
+ Bug 1157814: Freeze when 2 mechs with dodge skill next to each other.
+ Bug 1123395: NPE when unit dies in scenario initial damage.
+ Bug 1165423: When the "showunitid" option is set, variant mech images
    do not show.
+ Only display "+" in movementsteps if the unit actually got a road movement 
    bonus.

v0.29.69 (2005-03-14 7:45am)
+ Data 1157247: New pictures for Burrock, Great Wyrm, Highlander IIC, Scylla.
+ Bug 1156215: jammed RACs can fire
+ Patch 1158743, Bug 1154050: Infantry takes PSR after taking 20 dmg
+ Added new pics for Direwolf, Firemoth, Gargoyle, Nova, Sunmoner and Warhawk
    variants.
+ Don't allow missed charges to displace the attacker off the map.
+ Changed the Battle Armor BVs to match the ones from HMBA
+ Bug 1160780: Offboard Deployment and Double Blind NPE
+ When pushing a target off-board, the pushing Mech did not move to the
    position the pushed target previously had.
+ Bug 1047453: extreme gravity PSRs should be made at the end of the movement 
    phase.

v0.29.68 (2005-03-06 4:45pm)
+ Bug 1153269 "configure unit" not remembering burst fire mg setup.
+ MGs in burst fire mode didn't use ammo when missing.
+ Bug 1145944, Patch 1156358: "client options" windows larger than screen size
+ Bi-Monthly update on Batchall.de-Mechs
+ Patch 1156501: move setting dialog sizes to a common base class.
+ Bug 1157598: Spelling Error: Substracted instead of Subtracted

v0.29.67 (2005-02-27 9:40am)
+ Added an interface, so external programs can be notified when the client is
    closed
+ Bug 1145584: Black Python image filename misspelled.
+ Bug 1145891: Bot doesn't know that protomechs can't charge, or that clan 
    units can't charge with the no_clan_physical option set.
+ Bug 1146225: Don't check SRM infantry for Narc-capable ammo.
+ RFE 1150066: Remember MiniReport window position and size.
+ Bug 1115574: Gravity doesn't change BV.
+ Bug 1120451: cannot use RMG when /data/boards directory is empty
+ Ontos, Rommel, Skulker, and Sturmfeur wrecks had non-transparent backgrounds
+ RFE 1151428: improved RAC jam report text.
+ RFE 1022888, Patch 1023187: MaxTech Machine Gun rapid fire mode.
+ Bug 1115637: Multi-select in board selection dialog works sanely
+ New picture for Goblin Medium Tank (Kurita).
+ more Night Combat stuff, still not complete.
+ Bug 1152127: HMPRead 1.0: Chassis name
+ Data 1152289: New pics for Arcas, Bowman and Canis.
+ LRM indirect fire did not use the best spotter, but the last one to be
    declared.

v0.29.66 (2005-02-21 7:45am)
+ Data 1100263: HMPRead Mixed Tech RAC Codes
+ Data 1122339: New pics for Huntsman (Nobiri-Nin), Black Python, Mist Lynx,
    Thunder Stallion.
+ Patch 1122308: Entity id displays as -1 sometimes.
+ Bug 927687: Underwater firing problem
+ Added new image for the Kruger Combat Car, and attempt to fix its BLK file
+ Interloper Urban Scout Tank BLK file was overweight.
+ Disabling heatsinks should not take effect until the next turn.
+ Bug 1066354: Ejected MW represented with wrong graphic & color.
+ Don't make leg actuator hit PSRs when breaching a Torso
+ Bug 1115590: MMS: Initial vee crits not working correctly
+ Implemented iNarc Nemesis Pods.
+ Added Narc capable ammunition, to take advantage of Narc, you now have to set
    your missile launchers to load Narc capable munition.
+ Added game option to set how many infantry/ProtoMech units move per 'Mech
+ Bug 1126196: Tanks with 0 MPs get no road bonus.
+ New images for Myrmidon and Brutus courtesy of Vertigo
+ Swarming battle armor units don't drown in level 2 (or deeper).
+ Bug 1120511: remove game turn for swarmers that drown.

v0.29.65 (2005-02-14 7:45am)
+ Bug 749240: The APM forum says +1 MP road bonus is *after* calculating flank.
+ Bug 1115577: Correctly identify the first step (again, *sigh*).
+ Don't show stuff like "Archer ARC-5S (Dread Moores) gains -12 heat,
    sinks -12 heat and is now at 0 heat." in games with low temperature.
+ Data 1117943: Updated image for the Avatar unit.
+ Haubrek battle armor should be called Hauberk battle armor
+ Bug 1101518: if a tank dies to a crit, additional crits are not resolved.
+ Bug 1060000: Pilot losing consciousness should live through the ejection
+ Bug 1100983: Grand Titan and Black Watch pictures not working.
+ Bug 1112541: PSR reporting when autoejecting in wrong place.
+ RFE 734061: implemented iNarc, except for Nemesis Pods.
+ Bug 1118804: Measure distance from previous step, not starting position.
+ Bug 1120487: ATM alternate ammo and MaxTech extreme range
+ New images for the Interloper, Mauler, and Po, courtesy of ploppy
+ Fixed a few artifacts in Patton and Heavy Hover APC images
+ New images for Scorpion (Laser), LRM Carrier (Laser), and AC2 Carrier
+ Don't report captured MechWarriors that died as captured in end of game
    report.
+ Bug 1115608: Skidding into swamp or rubble, PSR missing.
+ Bug 1110692: underwater physical damage should be half, round up.
+ Bug 1099628: Twist with arrow keys on mapedge not working in firing phase

v0.29.64 (2005-02-06 9:30am)
+ RFE 1112483: CTL+R shortcut added to Turn Report menu command
+ Data 1060895: Added new wreck images.
+ Data 1096465: Updated images for Templar and Templar Tancred.
+ Data 1108229: Added images for Arctic Wolf, Goshawk/Vapor Eagle, 
        Mad Cat MK II, Maelstorm, O-Bakemono, Stooping Hawk, and Crossbow.
+ Bug 1112073: Don't count Rocket Launchers in calculating Max Heat.
+ Bug 1009227, Patch 1115911: bot hangs in Physical Phase.
+ Bug 1115581: Cannot dump Heavy or Light Gauss ammo in the lobby.
+ Bug 1115611: Skidding&swamp: displaced into wrong hex
+ Bug 1105683: Mackie 6S removed from unofficial.zip
+ Don't allow zero-hex jumps.
+ Display the "you haven't moved" warning when the entire move is invalid.
+ Change the "Moved" button to "Done" when the entire move is invalid.
+ RFE 1115642: Updated Example.mms to show how to declare teams in scenarios.
+ Patch 1111750, RFE 1110930: Ignore trailing whitespace in MMS files.
+ Patch 1115293: Gives meaningful names to all the threads in the game.

v0.29.63 (2005-01-30 2:00pm)
+ Bug 1107959: ejected pilot moves same turn
+ Bug 1089323: Atillery Freezes Game if destroyed/fled
+ Provide a non-HACKish way of getting destroyed/fled arty units.
+ Bug 1109829: DFA's ignore all terrain modifiers, including PC for water.
+ Data 1108467: Added Lawyers, Guns, and Money.
+ Bug 1110014: Units *can* jump over enemies, and **can't** run through them.

v0.29.62 (2005-01-23 2:30pm)
+ Additional Batchall.de-Mechs
+ Bug 1044814, 1013474: restructured how end-of-move steps are calculated to
        allow players to move Meks through any number of friendly Meks;
        also fixes infantry jumping over river.
+ RFE 1107326: list beginning and ending IS for units in entitystatus.txt.
+ Added stats.pl to *-cvs-* and *-media-* release files.

v0.29.61 (2005-01-17 8:00am)
+ Bug 1099792: Glancing blows with missiles for no damage
+ Bug 951000, Patch 1102698: Add lots of synchronization to prevent NPEs.
+ RFE 1100986: Allow mechset files to include other mechset files.

v0.29.60 (2005-01-10 7:30am)
+ Bug 1066865: Offboard Artillery tanks causing game to freeze
+ Bug 1093900: Glancing Blows always crit
+ RFE 1093906: Glancing Blows Message
+ Data 1096547: New pics for Black Watch, Naga, Gurkha, Cougar, Daedalus,
    Hunchback IIC, Hellbringer, Grizzly, Mantis, Koto, Longshot, Matador,
    Stone Rhino, Pillager, Spartan, Grand Titan, Legacy
+ Don't show oberserves in the "NARCed by" window
+ Bug 1061872: crash from firgingarrows in 3way doubleblind
+ Defective Mechfile replaced in batchall.de.zip
+ Bug 1095132: Skid-charge should roll to-hit according to the latest BMRr
    errata
+ Added "set_arty_player_homeedge" option, if set, all of the players' 
    artillery units will have their homeedge set to the deployment edge
    of the player, NW and NE are North, SW and SE are South.
+ Bug 1093079: accidental fall from above
+ Bug 1097537: flooded ammo can be fired
+ Added "no_premove_vibra" option, if set, vibrabombs that would damage a 'Mech
    that has not yet moved do not damage it.
+ Added pics for Verfolger and Rabid Coyote
+ Bug 1097815: Meks that are charging or DFAing don't get a dodge maneuver.
+ Bug 1098287: offboard units don't get the benefits of C3.
+ Bug 1072137: don't crash if the bot can't find a physical attack.

v0.29.59 (2005-01-02 3:00pm)
+ Bug 762436, 839980: Domino Effect not able to displace off the board
+ RFE 755636: Added Option to allow ammo dumping in the lobby
+ Bug 1091979: Infantry won't unload from Tanks
+ Bug 912127: when a Mek is standing up from prone on pavement, its
    "free facing change" should *not* cause a Skid PSR.
+ Bug 987956: on failure to get up, firing mod for walking/running missing
+ Bug 1091239: Vehicle Targeting Computer cannot be set to Aimed Shots
+ Unconcious and shutdown units should not be able to pick up ejected pilots
+ Bug 1090577: Do not pick up pilots that died in the end phase
+ Bug 1092677: Explosion damage avoided by CASE still counts for PSRs.
+ Bug 790693: the new BMRr errata says that the "Running with Gyro or Hip crit
   PSR" should be made after the move, not before
+ Bug 1093082: according to the new BMRr errata, jumping in high gravity should
   cause a PSR, with damage to the legs if the PSR is failed
+ Bug 1093084: Infantry movement errata. Infantry can now walk and run,
   and we need to keep track of the movementtype because now infantry movement
   does count for spotting
+ Bug 1093536: missed DFA with target on the board edge crashes megamek
+ Bug 1018871: gravity PSR when losing movement points in movement phase
+ Bug 1093083: falling in water, BMRr errata
+ Removed check_leg_breaches option, it was clarified on the Ask the PM board 
   that legbreaches should be checked when a mech stands in lvl1 water
+ Bug 1094473: thunder vibrabomb mines should deal damage in 5 point packs

v0.29.58 (2004-12-26 9:00pm)
+ Added some missing level 2 mixed-tech equipment to the HMP parser.
+ Patch 1087661: Show BV when real_blind_drop option is enabled
+ Bug 1090777: Vehicles not handled correctly at extreme G's
+ Bug 1090370: impossible to eject/abandon from immobile vehicles
+ Bug 1090781: vehicle breached in vacuum not destroyed
+ Bug 1057834: Weapons report & auto-eject (confusing order of events)
+ Bug 1088365: Mek Pilots Ejected during Movement don't immediately show up
+ Bug 1083617: Ejected Pilot does not die in vaccuum
+ Bug 1061712: No PSR for destroyed frontleg on quad mech
+ Quads now get their front legs breached as well when standing in lvl1 water
    with no armor on their legs, when the "breach legs in lvl1 water" option
    is checked.
+ Added Mechs for Batchall.de (German Clan Battletech Community).
+ Corrected a spelling mistake in conjunction with extreme G's.
+ Bug 1040858: breaching a leg results only in one PSR, should do more
+ Bug 1021324: Hull breached on the beach
+ Bug 1069709: Display Bug with Auto Eject and Pilot Skills
+ Possible fix for Bug 1066354: Ejected MW represented with wrong graphic & 
    color
+ Bug 1069925: minimap not shown in artillery auto hithex selection phase
+ Bug 841393: remove lower arm actuators on Blackjack BJ-1
+ Remove right arm hand actuator from Wasp 1A, add left arm hand actuator to
    Crab CRB-20, to agree with official HMP mechfiles.
+ RFE 1089881: MW that dies in Ejection isn't reported to Campaigns
+ RFE 1013771, Task 106040: Level 2 Swamp rules
+ RFE 1052815, 1038344: Mech ID in log file: differentiate between units of 
    the same type in one hex and in the logfile, to enable this, check the 
    client option "Show each unit's unique Id next to its name."
+ Bug 1084790: Destroyed Mek pushed off field, so kill wasn't credited
+ Bug 1071434: When a unit loses a leg in the movementphase before it
    has moved (vibrabomb, or skid-charge), it could move as if it had
    not lost that leg
+ Corrected description of MaxTech Missile Hit Penalty rule -- it now states,
  as it should always have, that reducing the roll below 2 reduces the number
  of missiles to 1.
+ RFE 1022884, Patch 1061868: MaxTech Glancing Blows rule. Hits that roll
  exactly the required to-hit-number do less damage.
+ Data 1083453: Pictures for Akuma and Bloodkite
+ Data 870515: MTF Equipment List
+ Bug 1089323: entity may be dead when resolving arty attack; don't check it

v0.29.57 (2004-12-19 11:15am)
+ Client window does not grab focus if it belongs to a bot.
+ Game option: Night Battle (Partly implementated: Modifier is there, but
  searchlights are incomplete).
+ Patch 1002093: Change meaning of "{Inf|Protos} Move Last".
+ Handle a side without Meks and Tanks in "{Inf|Protos} Move Last".
+ Renamed all "last turn" variables to "even turn" variables.
  
v0.29.56 (2004-12-05 11:00am)
+ Patch 1067681: Set Autoejected MW to dead when killed.
+ Bug 1065147: Handle null targets better in CAA#toHit and Compute#toHitDFA.
+ Patch 1065371: Show status of auto-eject in General tab of Unit Display.
+ RFE 1058008: Players now have a setting to disable auto-eject by default.
+ Bug 1070257: Duplicate pilot ejecting
+ Patch 1069530: Save autoeject status when saving a unit list
+ Data 1062852, 1057426: Pics for Tundra Wolf and Kingfisher
+ Bug 1067144: Pilot ejecting into minefield unscathed
+ Bug 1066147: Damage from PPC Inhibitor is *not* like an ammo explosion.
+ Bug 1066370: The phrase "minumum range" should be spelled "minimum range".
+ Bug 1061059: A unit can only eject its pilot once.
+ Bug 1057844: Pilots stop taking conciousness roll damage after they eject.
+ Bug 1058352: Game can end once all enemy pilots are captured.
+ Patch 1062102: MaxTech Rule: Damage to charging units
+ Track captured units in victory report and entitystatus.txt file.

v0.29.55 (2004-11-07 11:00pm)
+ Bug 1057995: Correctly handle configuring auto-ejection.
+ Bug 1058638: The PSR message should be "landing off the board".
+ Bug 1058627: Units on bridges shouldn't drown.
+ Can't thrash at null **or** non-infantry targets.
+ Bug 1060733: An ejected Mek pilot should have a BV of 0 (or should it?).
+ Bug 1050887: Artillery crashes MS JRE

v0.29.54 (2004-10-30 3:15pm)
+ Data 1047918: Image for Sunder Omnimech
+ Bug 1036351: scrolling bug fixed for real
+ Bug 1048960: attack sprites were not being reused
+ Bug 1049929: /reset crashes MS JRE
+ Bug 1050887: Artillery crashes MS JRE
+ Tweaked offboard postions (the middle of xx01 and xx17 is xx09, *not* xx08).
+ Bug 1051647: Mechs that get their CT destroyed by artillery should not be
   salvagable
+ Bug 1052073: BattleArmor Fire Protection
+ Bug 1052069: Bot dies
+ RFE 727927: turning off heat sinks
+ Bug 1052947: Special Arrow IV munitions doing damage
+ RFE 751400: Tracking Pilots after ejection. Ejection rules from page 79, BMRr
   are now implemented, except for the picking up of ejected mechwarriors.
+ Bug 1025518: Loss of Heat Sink bug
+ Picture for Scorpion Light Tank (LRM)
+ Implemented picking-up of ejected MechWarriors, MegaMek will choose which 
   units picks up an ejected MechWarrior, giving preference to those that are 
   controlled by the same player
+ Bug 1013571: Selected Mech not highlighted in physical phase
+ Bug 912094: Per the new Hardcover BMRr, a loss of movement points should not
   cancel a charge, eventhough the number of MPs might not be sufficient
   anymore, see page 42.
+ Bug 1042849: Wheeled & tracked vehicles won't displace into water

v0.29.53 (2004-10-17 3:00pm)
+ Bug 1044431: Quad 'Mechs should fire only to the front arc (except
   for rear mounted weapons)
+ Bug 1043230: Tooltip doesn't show T-Active or T-Inferno info
+ Bug 1039781: TCs and immobile targets
+ Bug 1044357: MS JRE doesn't support Vector#add
+ Add date/time stamp to "END OF GAME" message.
+ Bug 1047085: allow delayed deployment with 'any' as starting direction
+ Bug 1046545: Client hangs with PPC inhibitor disengaging and missile mod.
+ RFE 580405: Artillery. Off-board artillery support added, when configuring a
    unit that has an artillery weapon, you can select to deploy it off-board,
    select the map-edge behind which it should be positioned, and select the
    distance from the board.
+ Bug 1047592: Configure Unit dialogue broken
+ Bug 1047450: heat and leg damage movement point modifiers
    should be applied before gravity modifiers
+ Bug 1036351: scroll problems
+ Native HMP parser now supports mixed tech.  Also, hmpread and the native
    parser now use the same code base.  An updated version of hmpread has
    been created (see files->utilities section of SF).  Thanks go out
    to Ian Hamilton for all his help with this.
+ Off-Board artillery changes: allow Coords with negative values, eliminate an
    unneeded data member in Entity, and add some input checks.
+ Only select auto-hit hexes if the player has artillery.
+ Allow 30 boards in the Y direction (to handle southern off-board units).

v0.29.52 (2004-01-10 8:15pm)
+ Bug 1039773: the club needs to be restored after transmission.
+ Patch 1040096: PPC Field Inhibitor Disengaging (MaxTech Rule)
+ Implemented designated artillery targets, any artillery targeting
    any of these up to 5 hexes per player automatically hits.
+ Bug 1040426: Artemis bonus to non-standard missile ammo
+ Bug 1040547: Arctic Fox B & C have incorrect heatsinks
+ Bug 1039779: Immobile tanks that are not unconscious should be able unjam
    RACs.
+ Bug 1032713: breached legs act as if leg is destroyed
+ Bug 1032711: jumping into water w/ open leg breaches it, psr is missing
+ Bug 1031057: unable to configure own unit when using real blind drop
+ Bug 1006181: Duplicate info in tooltip
+ Bug 1041003: Torso breached, but ammo still usable
+ Bug 983376: Artillery targets shown too early
+ Bug 1042059: Infantry should take 2x damage in vacuum
+ Bug 1042096: Battlearmor should not check for hull breaching
+ Bug 1042131: Falling damage not modified for gravity
+ Bug 1042169: Incorrect jumping PSR at low gravity
+ Bug 1042185: Battlearmor MP not reduced for extreme temperatures
+ Bug 1042152: Charges & DFAs bypass PSR at low gravity

v0.29.51 (2004-10-03 8:15am)
+ Bug 1028638: a quad 'Mechs front legs are as restrictive as its rear legs
+ Bug 1029620: Mackie mechfile should be in mechs.zip, not unofficial.zip
    Pike Support Vehicle (RAC) datafile should be in vehicles.zip,
    not in unofficial.zip
+ Bug 1035223: Vector#clear does not work with MS JRE
+ Bug 1035780: fixed Summoer and Hellbringer image transparency
+ Bug 1035224: wrong Longbow variant pic
+ Bug 1037687: Narc bonus applied when using special ammo
+ Bug 1036814: Fragmentation/flechette ammo does standard damage
+ Bug 1019103: NPE when Mech has more than 6 pilot advantages,
    we now support up to 24 pilot advantages per mech (should we ever code that
    many)
+ Bug 1018001: PSR cause not listed when PRS is an automatic failure
+ Patch 1039150: misspelled "Chicago".

v0.29.50 (2004-09-26 1:15pm)
+ Bug 1031414: location exposure should be checked after each fall
+ Bug 1032040: clear artillery spotters only when firing at different hex
+ Bug 914976: Dead Pilots Shown as surviving
+ Bug 1033003: Mechs who's CT gets destroyed by artillery saturation fire
    should have their pilot killed
+ Bug 1028638: split weapon slot allocation bug in [Mtf|Tdb|Hmp]File.java
+ Bug 779673: Bug with breaches and physicals. This Bug occured because 
    originally, physical attacks did not happen at the same time. Now they
    do, and thus 2 opposing pushes actually cancel each other.
+ Bug 1027253: NPE while pushing off the map.
+ RFE 904853: adapt Target selector for multiple units in one hex from physical
    attacks phase to Weapons attack phase
+ RFE 887439: Secret tonnage setting on Thunder-Vibrabombs
+ Bug 912094: a charge should be canceled when the target falls before it is
    resolved or if the attacker loses all its movement points. Also, if a
    charge's target is destroyed, the chargin unit stays in the hex it occupied
    in the movement phase.
+ Bug 1033520: torso twist on edge of board not working, you can now torso-
    /turrettwist on the board edge by holding the shift key and then using the
    arrow keys.

v0.29.49 (2004-09-20 7:45am)
+ RFE 1022892, Patch 1023640: Maxtech Missile Hit Penalties, MaxTech revised 
    page 23.
+ Bug 1026657: Flank MP not recalculated in extreme temperatures
+ Bug 942946: PSRs for 20+ damage in Off-Board Attack phase was missing
+ Bug 915460: Pilots should not stop taking damage when Mek dies to ammo 
    explosion
+ Bug 875317: Protomechs should not be able to be charged.
+ Bug 1028154: Calculation of weight of jumpjets was false
+ New pictures for Direwolf/Daishi Prime and Widowmaker, Fire Moth/Dasher,
    Gargoyle/Man O' War, Grendel, Hatamoto-Chi, Hellbringer/Loki, Ice Ferret/
    Fenris, Linebacker, Mad Dog/Vulture, Rifleman IIC, Shootist, Summoner/Thor,
    Timberwolf/Mad Cat, Vanquisher and Viper/Dragonfly
+ Bug 1026079, Patch 1029379: Skidding should generate heat, but doesn't.
+ Bug 1029604: only add a single Inferno round to a hex when a Thunder-Inferno
    minefield is triggered.
+ Patch 1028632: Mech and Vehicle verification code added.  Currently run
    as an external command.  Thanks to Reinhard Vicinus for this patch!

v0.29.48 (2004-09-06 2:45pm)
+ RFE 1018683: have unit list expand to fill available space.
+ Bug 1001924: Freeze when displacement does not work correctly,
    thanks weaselflink
+ Accidental fall from above now working.
+ Data 1019241: Fixed Wasp antennas.
+ Added the rest of the one-shot weapons.
+ Chat Lounge now uses tabs (controlled with "chatloungetabs" in MegaMek.cfg).
+ Batch file updated again.  It now performs correctly when given command line
    options like "-dedicated".  Also fixed problems the MS JVM was having with
    some of the new features.  Finally, the default memory size for the Sun
    JVM was rasied from 64 to 128MB.
+ Bug 1018169: Incorrect loading of TDB mixed-tech double heat sinks fixed.
+ Vacuum hull integrity rules implemented, see page 85 BMRr
+ Bug 1018791: Hover charge against mech in depth 1 water, wrong hit table
+ Add undocumented "feature": megamek.client.ClientGUI.hideScrollBars setting.
+ Fixed Settings#get(String, String) where defaults weren't applying correctly.
+ RFE 1022891, Patch 1023125: Altered Energy Weapons Damage, MaxTech revised
    page 22.
+ RFE 999917, Patch 1019888: Drastic Blind Drop option added

v0.29.47 (2004-08-29 7:45pm)
+ Bug 1015776: Display bug with the jump MP of burdened Battle Armor.
+ Bug 988798: Mechs with dodge ability auto-dodge when appropriate.
+ Bug 999146: Server NPE on client disconnect fixed.
+ Bug 996032: Exception in Customize Mech Dialog fixed.  Thanks weaselflink!
+ Patch 1016082, 1015958: Four new unofficial pilot advantages,
    Gunnery/Laser: Pilot gets a -1 to-hit bonus on all energy-based weapons 
    (Laser, PPC, and Flamer)
    Gunnery/Missile: Pilot gets a -1 to-hit bonus on all missile weapons 
    (LRM, SRM, MRM, RL and ATM)
    Gunnery/Ballistic: Pilot gets a -1 to-hit bonus on all ballistic weapons
    (MGs, any ACs, Gaussrifles)
    Iron Man: A pilot with this skill receives only 1 pilot hit from ammunition
    explosions.
    Thanks schoelling!
+ RFE 543601: Added scroll bars to Board view (in the game and in the editor).
+ Bug 1017100: Mini turn report updates by default
+ Bug 1017200, RFE 993094: turn report now updated after a unit falls during
    the Movement phase
+ RFE 765114: Client Setting to dump chat and turn reports into a file.
    Also, a max file limit for the client-side file.
+ New Game Option to prevent autosave "spamming"
+ Applied corrections to Map Set 7 maps sent in by Endreffy Janos.
+ BMRr page 94 - Meks standing in Level 1 water don't check for breaches.
+ Bug 1013498: breach checks while moving can't use Entity.getPosition().
+ Patch 1018114, RFE 992346: display current heat effects in Extras panel.
+ Patch 1018575, RFE 1013588: place a dot on MiniMap icon for selected unit.

v0.29.46 (2004-08-23 9:00pm)
+ Switch to numpad arrows for scrolling
+ Re-added option to use right-click near the edge of the map scrolling
    also in the firing phase.
+ Bug 897421: Bot no longer gets stuck when you use Tactical Genius against it.
+ Bug 906536: Empty slots in middle of location no longer confuses mech parser.
+ Bug 797345: MegaMek now reads stealth armor from HMP files.
+ Bug 954921: MegaMek now reads machine gun ammo from HMP files properly.
+ Bug 1013043: File/Game/Save menu item now working
+ RFE 941455: New Game Option to save at every phase
+ Bug 1013144: Wrecks now showing after a re-connect
+ Bug 1013461: Stacking violation movement crash fixed.
+ Data 1009659: Added the scenarios and scenario-related boards.
+ Data 731105,749939,1001437: Added Solaris maps to a "solaris" subdirectory.
+ Data 1005435: Added submitted maps (buildings in a sub-directory).
+ Bug 1001027, Patch 1013211: Deploy multiple units in hex (thanks weaselflink)

v0.29.45 (2004-08-16 8:00am)
+ Bug 1001685: all the scroll options are now individually configurable
+ Patch 1007651: Speed up loading.  Thanks weaselflink!
+ Patch 1001719 and some more coding: Vibrabomb-IV, FASCAM and Inferno-IV
    Arrow IV submunitions now implemented.
+ Entities criticalled during scenario setup have null positions.

v0.29.44 (2004-08-08 9:30pm)
+ Bug 1003021: Could not clear burning woods.
+ Bug 1003688: Bot wasn't ignoring loaded units (patch from weaselflink).
+ Bug 1002304: tooltips hide when phase changes
+ Board Editor "Save as Image" now supports MS VM and has wait dialog.
+ Save Unit List now adds .mul to filename if necessary.
+ Bug 1005554: only add a single Inferno round to a hex when an Entity is hit.

v0.29.43 (2004-08-01 9:15pm)
+ Extra light woods hex in Citytech board.
+ RFE 959014 working again.
+ Dedicated server now loads game options from the xml file.
+ Patch 997507: Reworked how scrolling works, including a Drag-and-Drop right-
    click scroll option, like it is used in lots of other games. The default 
    scrolling is unchanged, except that now right-click default scrolling works
    also in the firing phase, this was made possible because now we don't get 
    a 'Target Hex' context menu after scrolling with the right mouse button,
    which also made the 'always scroll using right click' option obsolete.
    Shift scrolling works the same as before, but it can't be used exclusively
    anymore. To use the new Drag-and-Drop right-click scrolling option,
    activate the corresponding option (this also disabled Arrow-Key and 
    Shift-Key scrolling), and see that you can scroll by holding the right
    mouse button and moving the Mouse.
+ Bug 998164: Mechs with destroyed gyro can no longer turn more than one 
    hexside
+ Reinstated "always scroll using right click" option, because the scrolling 
    reworking didn't quite work as intended.
+ Data 969297: corrected ammo load of "Ammo Carrier (SP Sniper).
+ Bug 999784: never de-reference a null GameTurn.
+ Bug 1000869: Unloading of stranded units sometimes crashing client.
+ Bug 1001067: Unconscious units no longer have LOS to other units.
+ Don't show heat on general tab for vehicles or protos.
+ Show vehicle type on general tab.
+ Omit team from general tab if it is "No Team".
+ Included updates to boards from Endreffy Janos.
+ Bug 1001237: Accidental Ignition of woods when trying to clear woods did not
    work correctly.
+ Bug 1000932: synchronize MovementDisplay#updateProneButtons()
+ RFE 1001439: use the board name for the default name of the image file.
+ Moved the player selection dropdown in the "Select Mech" dialog.
+ Updated build.bat to use Ostermiller.jar and PngEncoder.jar.

v0.29.42 (2004-07-25 10:45pm)
+ RFE 948700: "A players Infantry/Protomechs move after that players other
        units" game option added.
+ Bug 994182: customize mechdialog allows ammochoice for lvl1 mechs
+ New game options for keeping Vehicles and/or Protomechs safe from Infernos.
+ Omit jumping movement from units that don't jump in Mech Viewer.
+ Bug 992675,974358,877943: characterize Protomech armor to the AI bot
+ Bug 994206: not all targets are Entities
+ Data 986741: images for SHD-5M, PXH-3D, PXH-3K, PHX-3M 
+ New image for the Goblin LRM -- made sure it has 2xLRM10s
+ RFE 695093, Bug 875300: Protos now have their physical attack.
+ Added "Save as Image" ability to the board editor.
+ Allow each roll to be tracked and each die to be reported.
+ Bug 996870: Made TargetRoll$Modifier implement Serializable.
+ Updates to support FLOSS Java hackers.
+ Bug 820500: When a hull breach happens, show which mech got breached,
    not only the location that got breached.
+ Bug 827083: Mech with breached IS XL engine should be destroyed by engine
    destruction

v0.29.41 (2004-07-18 5:30pm)
+ Bug 985884: Attempt #2 at fixing this bug.
+ Track Kills for use in MegamekNET and in the end-of-game report.
+ Bug 991967: Magshot Gauss Rifles should not be able to start fires.
+ Bug 992597: -5 and below hexes with rubble no longer corrupted
+ Bug 974157: Splash screen now closes for the Bot
+ Task 101916: Mech Display font sizes now adjustable in cfg file.
+ Bug 993326: Esc key actually cancels attacks properly now.

v0.29.40 (2004-07-11 6:15pm)
+ Bug 985884: Possible fix for this NPE bug.
+ Bug 953501: Attempted fix for the "memory leak".
+ RFE 988158: Add more armor info to entitystatus.txt.
+ More lessons learned from GCJ.

v0.29.39 (2004-07-04 8:30pm)
+ Bug 982019: Fix for Hauptmann HA1-OA and Templar Grayson and Tancred pics.
+ RFE 899893: Use old Marauder IIC image
+ Patch 979497: lvl3 Diagramming LOS rule from MaxTech, thanks hentaizonga
+ Bug 830715: Breach locations when Mechs are displaced into water
+ Bug 954272: Mines shouldn't work underwater
+ Bug 878766: Mines should trigger only when entering hex
+ Bug 944326: remaining ammunition shown in MechDisplay is wrong when
    Mech has ammo for weapons that only differ in size, eg. LRM 20 and LRM 5.
+ Bug 845271, 876771, 917814: The offscreen buffer wasn't resizing with window.
+ MechDisplay.SystemPanel#getSelectedEquipment() didn't handle empty slots.
+ Bug 984459: Vehicle extra road movement does not cause Extreme Gravity PSR
    anymore
+ Updates to work with GCJ.

v0.29.38 (2004-06-28 2:15pm)
+ RFE 941437: Show a "*" in the tooltip if the crew has special advantages
+ Window focus grabbing now a Client Option
+ RFE 941437: Pilot advantages now show in mechW. Also show pilot skills.
	Also changed the "*" into an "<n advs>" tag, like in the lobby
+ Bug 974798: Mechs in Water now get Jump MP adjusted for gravity.	
+ Bug 915168: Legless protos can no longer jump and turn more than one hexside
+ Use StringBuffer.append() instead of a bunch of String + operators.
+ RFE 941437: Oopsie -- mis-placed the "(n used)" line on the mechW
+ Bug 975512: extreme gravity PSR when using minimum movement rule
+ Data 917302: new Vedette, Goblin, Scorpion, and Skulker images
+ Bug 975949: Mechs can start the game with enabled Stealth Armor
+ Bug 975949: When targeting a stealthed Mech, you can only target it,
    not anything else (BMRr, pg. 147)
    Stealthed Mechs can't be secondary targets (BMRr, pg. 147)
+ Data 979738: added Mech pictures that are exactly centered
+ Data 958365: added Gargoyle and Hankyu pics
+ Data 958659: added Orion IIC, Templar, Templar Tancred, Thunderhawk, 
    Direwolf A, Salamander, redone Thunder pics


v0.29.37 (2004-06-14 8:15am)
+ Patch 946202: Optional Rule: Woods Burn Down, thanks AlbinoSqrl
+ some more bugfixing in high/low gravity rules
+ Bug 966960: Specialty Ammo with Mixed Tech works now
+ Bug 968198: BLK files have different ammo names from MTF files.
+ Bug 911899: TEMPORARY solution - treat smoke artillery ammo as normal ammo.
+ Bug 967231: Can now deploy inf in APCs etc with "Inf deploy last"
	game-option set
+ Bug 970608: low/high gravity & MASC or TSM now works correctly	
+ Use an Enumeration rather than Vector#elementAt() whenever possible.
+ Bug 967231: Oops! Had made it possible to load enemy inf :)
+ Patch 962593: added jaxom_renard's MaxTech Extreme Range patch.
+ When a side torso is destroyed, and the adjacent arm is not yet destroyed,
    it should be blown off and available as a club. (p. 35, BMRr)

v0.29.36 (2004-06-06, 10:30pm)
+ Bug 957390: a bot miscue from the last checkin
+ Bug 838318: Stealth was still working when mech shutdown.
+ Data 949800 and 949801: Cyclops CP-11-C3 and some mixed tech mech fixes.
+ Use StringBuffer.append() instead of String + String.
+ Task 99235: Fire/smoke processing faster now.
+ Patch 946255: added limbs entries to shrubbery theme
+ RFE 959014: Double-blind "Am I revealed?" indications.
+ Bug 954476: Double-blind deployment working again.
+ Bug 948061: Tactical Genius pilot ability fixed.
+ Bug 960006: vehicles can go to 0MP with "move system damaged" crits
+ Bug 954269: A few mechset.txt errors fixed thanks to coralbeach
+ Bug 963241: Units that die in the Movement phase are shown as such in
	clients
+ Bug 963307: Mechs with 6 Pilot hits are marked doomed
+ Bug 859571: A swarming Inf no longer causes a "/skip" error if it's the
	last unit the player has left
+ Patch 959200:	optional lvl2 rule high/low gravity
+ Updated BMRr Feature List.txt
+ Bug 957197: Sturmfeur pic was backwards
+ further refinement to high/low gravity code (thanks Suvarov)
+ RFE 580405: added Long Tom, Sniper, and Thumper.  Still a bit to go.
+ Updated readme-German.txt and fixed some typos in readme.txt
+ Removed a lot of unnecessary imports
+ RFE 826274: game option to stop Hover vehicles charging
+ access static fields only in a static way
+ damage dealt directly to legs IS due to extreme gravity should transfer
    to armor of next location, not IS

v0.29.35 (2004-05-20, 2pm)
+ Time to start tracking memory usage in the log file.  Where is it all going?
+ Use Java APIs to format numbers.
        P.S. set "memorydumpon" to "true" in CFG
        P.P.S. java.lang.Runtime#maxMemory() is a JDK v1.4.x API
+ Bug 946149: moved and fixed TestDice
+ Bug 951457: added back the call to bing
+ Bug 950386: added the ability to edit bot units
+ Bugs 941075, 790783, 800960: were either fixed or are no longer relevant
+ First wave of changes to help shore up bot code.
+ Escape out '"' in playername in config file. Should probably be used for
	other config elements.
+ Bug 953660: Fixed error in Drawing Board and Mech Engineer parsers.
+ Bug 955257: Fixed the wrong index in Compute.getBattleArmorHits
+ Patch 946255: new (working) images
+ Bug 954757: "Flip Arms" menu now flips arms instead of torso-twists
+ Patch 954053: optional lvl2 rule extreme temperatures courtesy of BeeRockxs
+ Patch 946521, Bug 838318: ECM was still working when mech shutdown.
	Courtesy of BeeRockxs

v0.29.34 (2004-05-11, 10:30pm)
+ Bug 945047, Patch 946170: Lvl3-rules smoke now stack with terrain right.
	Thanks AlbinoSquirrel!
+ Patch 946255, RFE 734354: beerockxs' patch to show blown off limbs
+ Bug 950086: initialize EquipmentTypes before use.
+ Bug 950435: UnitOverview now "floats on top" of the battlefield
+ Data 911874: a MiniMap colours file to match the default hexset
+ Bug 940016: CommonSettingsDialog now has a scroll pane
+ Bug 949292: Drawing Board and Mech Engineer parse errors fixed.
+ Bug 951005: fix NotSerializableException with TargetRolls

v0.29.33 (2004-05-02, 7:00pm)
+ Bug 937996: Fix NPE when starting a scenario against the bot
+ Bug 937431: fix race condition.
+ Artillery bugfixes and neatening of code; spotters implemented. Battle-ready?
+ Bug 937752: correct the pathfinder moves for Jump and DFA.
+ Artillery actions can't count on entities lasting until the shot lands.
+ Patch 920175: Added albinosqrl's level 3 smoke/fire rules.  Speed
        optimizations still to come.
+ Bug 929309: Woods clearing reports cleaned up.
+ Bug 939860: print error message (don't throw) if owner can't be found.
+ Bug 937734: a player connecting after the init phase no longer NPEs later
+ Bug 931003: spelling fix in TestBot.java
+ Bug 911777: Artillery attacks now resolve on correct side table.
+ Brought ChatterBox2.java up-to-date with recent commits
+ Corrected some more stray references to client.bv
+ Refinement to the earlier fix for Bug 937734
+ Bug 940811: MM menu still visible fixed
+ Bug 938300: Bot is now able to stand
+ Added random minefield support for the bot.
+ Bug 940937: when applying damage, add destruction reports to damage report
+ Mech loading delay reduced, startup is now quicker.
+ Start to fix bugs with running under SableVM and Kaffe.
+ Java 1.1 compatibility fixes.
+ Bug 944134: seperated query and new map events
+ Bug 937752: final fix. dfa and charge should now be fully compatible with 
    the pathfinder.
+ Bug 944331: Fixed getNextMoves so that you can immediately change directions.
+ Changed ChatLounge to control bots.
+ Bug 940019: Fixed ConcurrentModificationException (but this will need to be 
    looked at more)
+ Added minor multi-lingual support for the main help file. 
+ Bug 940015: put support for Settings.explicitScrollOnly back in
+ Bug 946395: CTL+U shortcut works again on Unit Overview menu
+ Fixed typo in ammo slot for Phoenix Hawk IIC 4
+ RFE 859679, Bug 941362: Additional mixed tech support added.
        Mech loading log cleaned up.  Refactor of EquipmentType class.
        Existing mixed tech unit files edited to work with new format.
        Failed equipment check added.

v0.29.32 (2004-04-18 10:00pm)
+ Bug 933545: Mech stacking violation bug fixed.
+ Bug 933550: Prone mechs can eject again.
+ Patch 932742: All hexes highlighted when "ANY" deployment option selected
+ Patch 932734: "Host Saved Game" now limits filelist to *.sav on Linux
+ Patch 932367: Cursors now sit "underneath" other info
+ Bug 785820: Breached equipment affects movement
+ Minimap now indicates when a hex has both smoke and fire in it.
+ Bug 891496: Mechs loosing a leg while trying to stand up don't get to try
	again
+ RFE 934547: MiniMap now shows Drop Zone
+ Bug 935510: don't allow to replace the game options with a null.
+ Bug 933474: Refactored code from the bot to MovePath to refine the A* path
    finder.
+ Refactored lots of other code.
+ Players can set the time for the pathfinder to "think".
+ Bug 936861: LOS dialog no longer locks up MM client
+ Patch 927127, RFE 711582: Allow players to zoom in and out on the board.
+ RFE 936863: ConfirmDialog can now have the Yes or No button focused
+ RFE 867650: More obvious help for a newbie
+ Indirect Artillery Fire.  INCOMPLETE and EXPERIMENTAL.  USE AT YOUR OWN RISK.
+ Removed extraneous bug-testing System.out prints.  Woops.
+ RFE 923247: Bot and Map Editor now have "stop nagging me" options
+ RFE 937330: HelpDialog no longer eating empty lines (nicer formating for
	the readmes)
+ Bug 934527: "Board" menu no longer enabled in Client. Also tidied up some
	other menu items.
+ RFE 933543: Right/middle-click scrolling in fire phase restored as option.
+ Bug 932393: Once the pilot is dead, stop showing "PILOT DEAD" messages.
+ Patch 933200: Allow scenario authors to specify specific damage.
+ Changed build.xml to leave classes/ behind to stop annoying CVS errors.
+ Reordered phase numbers.
+ Minor refactoring of artillery code.

v 0.29.31 (2004-04-11 9:00pm)
+ Heat prognosticator on weapons tab now takes standing in fire into account.
+ Bug 913240: clear deployment on every phase change.  This needs a cleanup.
+ Patch 915479: incorporated ecthellion's A* pathfinder.  Temporarily disabled.
+ Bug 929255: Class cast exception fixed.
+ The "bing" server message sound now works in Java 1.1 VMs.
+ RFE 810539: Performance improvement 1: map autoscroll can now be disabled
+ Bug 930545: Level 3 Maxtech leg damage rule fixed.
+ New improved batch file for Windows users.
+ Bug 929167: Running/Jumping with damage fix.
+ Bug 859683: 0 MP tanks are not *necessarily* "immobile"

v 0.29.30 (2004-03-29 7:30am)
+ Bug 922776: Salamander BAs can explicitly raise Mek heat (BMRr, page 65).
+ Minimap now remembers its size.
+ General settings now available. General settings can be overriden by system
        defaults or at runtime.  Values set at runtime are saved.

v 0.29.29 (2004-03-21 4:35pm)
+ Bug 802115: Failed MASC now marks mech as "done".
+ Bug 915164: Cust. Mech button disabled for other players mechs in blind drop.
+ RFE 916248: Right-clicking no longer scrolls the board.
+ RFE 916953: Board can now be scrolled by holding down the shift key
        while moving the mouse.
+ Java 1.1 bug with Arrow IV implementation fixed.
+ Attempt to fix sometimes botched logo that occurs on MS JVM.
+ If an ignition report is needed, then don't return without one.
+ Bug 912143: fix infinite loop in getFirstDeployableEntityNum.

v 0.29.28 (2004-03-14 3:30pm)
+ Bug 911899: TEMPORARY solution - treat special Arrow IV ammo as normal ammo.
+ Bug 911954: BA flamers shouldn't cause heat.
+ Bug 912262: Don't cause infinite loops on a disconnection.
+ Java 1.1 compatibility bug affecting proto customization fixed.
+ Made minimap more responsive to clicking.
+ Ant clean no longer deletes *any* zip files, just megamek-*.zip ones
+ Custom Stealth Mechs with no ECM would load, but then crash the game.
+ Patch 909272: different symbols on MiniMap for different unit types.
+ RFE 915158: Infantry/Protomechs should not be forced to fire last.
+ Bug 811987: Level 3 PSR rules tweak.
+ Data 914815: updated readme.txt and readme
+ Bug 802867: Game save bug finally quashed.
+ Patch 914025: use different minimap icons for different unit types.

v 0.29.27 (2004-03-07 9:35pm)
+ Bug 897585: Initiative phase bug fixed.
+ Bug 760628: Clear PSRs for any entity after it falls
	(no PSRs from crits sustained falling down).
+ Bug 898870: nagForPSR and nagForNoAction were cross-tied
+ RFE 889959: configuration file for the MiniMap
+ Bug 898207: players should have to enter in a non-blank, non-whitespace name
+ Bug 899181: unconcious and shut down meks can't find clubs.
+ Better width calculation for Game Options dialog.
+ Infantry move last, deploy last, and move multi game options now
        include Protomechs as well.
+ Made above fix for bug 760628 Java 1.1 compatible.
+ RFE 898795: MiniMap now shows whether units have acted already or not
+ Bug 895352: Entitystatus.txt more complete now.
+ Bug 899802: don't send skip messages after the last turn.
+ Bug 900185: any move that leaves the board shouldn't be considered
+ Bug 898576: HmvFile had the wrong values for rocket launchers.
+ Bug 900512: swap ID and type in ThrashAttackAction and AbstractAttackAction
+ Bug 898218 and 900906: HMVee is packing the bits in very tight.
+ RFE 733070: write "END OF GAME to MegaMek.log when game is reset
+ RFE 567481: have the server reset the game when the last player leaves
+ Bug 901362: any pending PSRs should cleared when a Mek stands from prone
+ Handle TroopTransport in HmvFile.
+ RFE 703357: Implemented AP Pods (still need OS missile racks).
+ Have the nagForNoAction screen include the "Do not bother me again" checkbox.
+ Fixed bug with "no move" animation.
+ Blind Drop now lists unit type (inf/proto/veh/mech)
+ Protomech sprites now torso twist just like mechs.
+ Unit sprite now has "loaded infantry" indication.
+ Slight tweak to Systems tab Mode box
+ MegaMek.bat now more user friendly.  Defaults to Sun JVM if possible.
+ Artillery implemented.  Right now, just onboard direct fire with Arrow IVs,
    nothing else, no special ammo.
+ RFE 898792: MiniMap now shows declared fire
+ Fixed a typo in the apidoc target in build.xml
+ Protomechs shouldn't suffer lvl 3 engine explosions.
+ Bug 877038: Indirect fire spotter movement is described as such
+ Tabs on Mech Display window made more sensitive to mouse clicking.
+ Bug 781250: MASC bug rises from the grave to attack quad mechs, buried again.
+ Made NARC missile beacon indidcation more obvious in extras tab.
+ Bug 905261: missing minimapcolours no longer NPEs. Also, better exception
    handling in Client#initializeDialogs()
+ New "SINKHOLE" MiniMap colour/setting
+ Patch 870086: mechW now stays open when the same player moves several units
+ Bug 908952: MiniMap no longer NPEs when the target is not a Entity 
    (woods etc)
+ Oops... Above fix meant return fire on the MiniMap was only in one colour
+ Customize Mech dialog no longer enables ammo choices that aren't yours.
+ Bug 900531: Customize Mech had problems with Clan Mek and Proto MG ammo.
+ Data 897783: New/additional images for Cerberus, Hauptmann, and Sagittaire.
+ Bug 909049: Fixed a bug with charging (Could not reach target with movement)
+ Bug 911587: My "Better NPE handling" messed up BoardEditor :(
+ Separate "Inf Move Last" and "Protos Move Last" into separate options.
+ Bug 849132: shouldn't be able to dump ammo during Deployment Phase
+ Protomechs now declare fire in Points (configured in Chat Lounge).
+ Bug 875913: "stranded" infantry can dismount at the beginning of movement
+ Bug 781660: corrected team initiative problem
+ Bug 804786, 875101: stop deallocating panels; switch between them instead
+ Use a single button row, not a panel to the left of the chat lounge.
+ Various updates to the chat lounge to make it more obvious to a new player.

v 0.29.26 (2004-02-14 2:15pm)
+ Updated "BMRr Feature List.txt" to show recent progress.
+ Bug 893185: Protomechs get to roll to regain conciousness.
+ Bug 848517: Anti-mek infantry can only swarm enemy units.
+ Added level 3 "Tactical Genius" pilot advantage.
+ RFE 729854: Battle Value calculation for damaged units more accurate.
+ RFE 678287: dedicated server can now load saved games
+ Bug 893423: Don't use AMS ammo that is being dumped.
+ Bug 887207: Ensure that the wr.amsShotDown vector is not null.
+ Bug 798849: Illegal moves now grayed out when MASC in use.
+ Fixed bug: Multiple pilot advantages now save/load from .mul files.
+ Added level 3 "Weapon Specialist" pilot advantage.
+ Bug 875008: Don't try to display null wreck images.
+ Clan mechs now auto-dodge when available if "No Clan Physicals" opt. in use.
+ Added static (decode|encode)Transporters to Entity.
+ Moved a bunch of Entity#set* methods into public access.
+ Bug 895717: check for previous count value before adding equipment.
+ Bug 799798: bot shouldn't try to torso twist; the server shouldn't let it.

v 0.29.25 (2004-02-08 10:00pm)
+ Data 887963: added images for Berserker, Lao Hu, and Naginata; updated
        images for Bushwacker, Fafnir, and Uziel
+ Data 887869: added all changes that coralbeach submitted (images by Vertigo)
+ Added test to confirm correctness of BoardEncoder.java.
+ Added marker in MechDisplay's weapon panel to note fired OS weapons.
+ Moved adding BattleArmorHandles from MechFileParser to Mech#setOmni(boolean)
+ Bug 879363: Firefly FFL-7A-WDR (in unofficial.zip) was missing a DHS.
+ Shrank the Protomech public interface.
+ Patch 870394: Added a KeyListener to the CommonMenuBar
+ Bug 833588: Randall sez, "Only kick Infantry in the same hex"
+ Ignore .log files in the data/mechfiles folder
+ RFE 810540: added client settings for board hex popup and tooltip delay
+ RFE 697418: New client option for confirming "done".
+ Bug 864751: Java 1.1 issues.
+ Fixed Java 1.1 bug with adding craters (thanks to Florian)
+ Added option to disallow clan meks from using physical attacks.
+ Load game, scenario, and unit list dialogs filter by extension on Windows
+ Line number debug info added to stacktraces for all the bugfixers out there
+ Added text to MegaMek.bat to guide users when wjview isn't there.
+ McWizard's C3 update to calculateBattleValue allows a TODO to close.
+ Expanded Tank's public interface to allow XML serialization.

v 0.29.24 (2004-01-31 12:45pm)
+ V minor change (a bit more readable) to suvarov's fix for my AMS null vector
+ Bug 879938: Fixed. More Java 1.1 compatability issues.
+ Rewrote RL/OS code for friendliness; while other OS missile racks aren't
     supported yet, the code is ready to take them.
+ Bug 849862: Heat Calculator no longer cropped.
+ Bug 868218: Fixed bug in backwards lateral shifts
+ Bug 885742, 885825: correctly handle null or "No Camo" categories
+ Feature 886721: "Infantry deploy last" option added
+ The Drawing Board mech file parser now recognizes rocket launchers
+ Added an ammo type for Rocket Launchers.
+ Bug 875324: create special munitions for *all* clan SRM and LRM sizes
+ Forgot to add T_ROCKET_LAUNCHER to the nCluster = 5 if test.

v 0.29.23 (2004-01-25 9:45pm)
+ Bug 828741: jumping bypasses fire, but not on the first step. Also optimised
     the logic in that section as well.
+ Handle "near miss" for Protomechs better.
+ Bug 776006: >1 AMS reporting
+ Changed mechset.txt to accommodate lower-case "guillotine.gif".
+ Bug 878087: Left clicking no longer targets friendly units.
+ Added calculateBattleValue(boolean assumeLinkedC3) to Entity so MMNet can
     calc C3 easier.
+ Bug 874179: Moving through hexes with friendly units no longer a problem
+ Read images from directories or ZIP files; separate them into categories.
+ Data 777032, 778903, 779051, 786208, 786400, 786787, 787080, 788382, 788439, 
        792441, 855114: Released all submitted camos as separate files.
+ Bug 883975: When there is no AMS, set the WeaponResult#amsShotDown to int[0].
+ Damage the Protomech pilot when a section is destroyed.
+ Bug 875298: Protos shouldn't charge or DFA
+ Implementation of Rocket Launchers!!!  This does *not* cover OS missle racks.

v 0.29.22 (2004-01-17 2:25pm)
+ In ChatLounge.java, s/Mech/Unit/ in buttons and dialogs.
+ From coralbeach: split unofficial and Dark Age (TM) units in "data/mechfiles"
+ Bug 857284, Data 861076: Fixed Road Runner (and 10 and 15 ton Meks).
+ Data 872169, 872875: Added new mech images from majortom88.
+ Used splash screen submitted by freakboy2571.
+ Bug 874582: Shouldn't be able to back up across an elevation change.
+ Bug 869821: fixed transparency on challenger.gif
+ Torso crits have no effect 1/3 of the time.  Handle 'Proto crew hits.
+ Bug 869807: "Armor-Piercing" should be hyphenated as well.
+ Data 875342: added the new Protomech images
+ Data 867632: added the new unofficial mechs and images
+ Bug 877221: the word is spelled "grenade", not "gernade"

v 0.29.21 (2004-01-10 11:45am)
+ Patch 867652: cleaned up megamek-icon.gif
+ Patch 868927: Hide MechDisplay at end of turn
+ Patch 867864: only twist turrets if crew conscious
+ Patch 867883: put unit shortName into MechDisplay title
+ Bug 865498, Patch 866472: infantry first-step amnesty corrected
+ Bug 869818: IS Frag missles are level 2 technology.
+ Bug 869815: Reverse the "Clan ammo limits" boolean value.
+ Made OK button have focus when the LOS dialog opens (a different way)
+ Bug 869878 (, 872136?): EquipmentTypes *must* have mepName and blkName.
+ Bug 869816: check for no proto ammo in non-proto units was buggy.
              Proto SRMs and SSRMs need the proto flag too!
+ Patch 869079: Added HmvFile.java... Now MegaMek can read HMVee files!!!
+ Bug 869807, Patch 870075: hyphenated thunder-augmented and armor-piercing
+ Patch 868676: Fix the NPE mentioned in one of the ammo patches.
+ Patch 867630: updated README files
+ Full ProtoMech implementation.  Probably bugridden, but feature complete.
+ Bug 831347, Patch 874446: Head explosions shouldn't devestate Meks.

v 0.29.20 (2004-01-02 10:40pm)
+ Bug 797649, Patch 862927: Stop accepting arbitrary block delimiters.
+ Patch 851394: initial ProtoMech implementation.  NOT BATTLE READY!!!
+ Fix bugs in encoding Buildings.  Don't compress XML in PacketTool.
+ Patch 863376: added Thunder-Augmented LRM ammo type.
+ Patch 864088: added Fragmentation missiles.
+ Fix bug with turning using running movement after walking backwards
+ Patch 864818: added new ammo types
+ Bug 837828, Patch 865451: Double-blind entities aren't necessarily dead.
+ RFE 867570: DOS line-endings in .bat files
+ Bug 849863: Updated mechset.txt, changed existing images, and added Hatamoto.
+ Bug 856217: Updated document (a bit... suggestions welcome).
+ Bug 859805: Integrated more mechset.txt fixes.

v 0.29.19 (2003-12-16, 10:55pm)
+ Bug 849222: Need to check for clubbing in Server#canPhysicalTarget.
+ Fix the FiringDisplay NPE that McWizard mentioned in bug # 849441.
+ Incorporated the Ostermiller utility library (need Base64 for PacketEncoder).
+ Initial implementation of the PacketTool.  It only sends XML-encoded Boards.
+ Bug 775759: CHECK_FALSE overrides other autos in target rolls
+ Bug 855550, Patch 855623: don't allow shutdown or unconcious units to flee.
+ Bug 854422: Notify user when AMS shoots down a Narc pod
+ Patch 819982, RFE 748896: add option to allow tanks to "eject".
+ Patch 846789, RFE 777616: report roll for igniting hex.

v 0.29.18 (2003-11-26, 7:30am)
+ Bug 843723, Patch 842834: fix race condition with "Done" button
+ Data 841109: applied Hopalong's updated mechfiles and mex set.
+ Bug 841393: Blackjack BJ-1 should have lower arm actuator
+ Bug 825836: Gurkas and Firestarter FS9-OE should have swords.
+ Bug 834117, Patch 844447: set the game of loaded units.
+ Include movement type in MUL files.
+ Data 739343: Timber Wolf A & D should not have lower arm actuators.
+ Bug 842086: Check game.getPlayer(connId) for null.  A lot.
+ Bug 755993: Reduce stack trace to log message when error closing connection.
+ Possible source of Bug 826463: MechMapSet *requires* construction inside 
  ArmorPanel#addNotify()!!!

v 0.29.17 (2003-11-12, 8:30pm)
+ Patch 832885: use alternate LOS tool.
+ Marked data/sounds/call.wav as a binary file.
+ Bug 833851 -PARTIAL FIX-
  Catch all Throwables when trying to get the "bing" sound.
+ Setting "memorydumpon" will track memory usage during a game in MegaMek.log.
+ Bug 829228: applied floio's patch
+ Bug 790019: use minimum sizes for alert, choice and multi-choice dialogs.
+ Bug 834364: Board.java changes for Map Generator use collections.jar classes.
+ Bug 834457: MicroSoft JRE can't use PNG files.  Sad, really.
+ Bug 837237, Patch 838203: you can define "rear of leg/arm" hit locations!
+ The Board#reverseHex variable is only used during map generation.
+ Data 835352: Corrections to Tallassia 1, 3, 6 & 7
+ Bug 836156: If entity has a null owner, compare ownerId values.

v 0.29.16 (10-29-03, 8am)
- Bug 744962: For some reason, the entity still thinks the pilot is not dead.
+ Still more attempts to solve bug 825739.
+ Bug 826463: Stop the loop until we can fix InputMethod's state.
+ Removed java 1.1 incompatible method.
+ Removed change mode from the M key.
+ Shows wreck after ammo explosion.
+ Removed the new chat box.
+ Added vehicle images by bh-21.
+ RFE 828165, partial 608588 and 544504: "bing" when chat arrives.
+ Data 805836: updated mechset.txt to use V_* images for clan variants.
+ Data 827910: updated scenario_readme.txt
+ Data 829347: added legionnaire.gif and fixed rakshasa.gif
+ Patch 819976 : Random map generator with some GUI work.

v 0.29.15 (10-19-03, 9:30pm)
+ Fa Shih units have superior mine-clearing capabilities.
+ Added movement menu.
+ Added physical attack menu.
+ Modified MegaMek.bat to be more friendly for Sun JRE.
+ Some menu work.
+ Bug 825739: Attempt to squash InputContext exception in Client#die().
+ Added confirm dialog for ammo dumping
+ Ammo dumping now reported in the final report of the round
+ Bug 824473: Retain building damage from saved games and restarts.
+ Bugs 798306, 822293, 825064: Restore Entity & Owner in Entity#setGame.
+ RFE 783395: Add a "Cancel" button to the Movement Display's menu.
+ RFE 787056: Set the default Mech Display window width to 235.
+ Sort the available boards by name.
+ There should be no megamek.client classes in megamek.common or megamek.server
+ RFE 744493: Have an "IS All" tech level option.
+ RFE 734912: Change "NARCed by" to "Affected By".
+ RFE 720869: Show (turret) "Locked" where "Prone" is shown.
+ RFE 712315: Update fuel tank explosion text.
+ Fixed an NPE in Game#removeEntity(int, int).
+ Partial bug 826249: Typed chat message is deleted only on escape.
+ Displays wrecks after Mechs and vehicles. Images in data/mex/wrecks/.
  Optional in Client Settings.
+ Bugs 787045, 810017: Fix ammo in Tyr Infantry Support Tank.
+ Bug 780999: Streak message should be "failed to lock", not "missed".
+ Bug 753507: Append the victory report to the server log.
+ Bug 744962: Dead (or doomed) pilots are never concious and auto fail PSRs.
+ Bug 744623: Report when the pilot bakes to death, and destroy the Mek.
+ Bug 826410: The PHASE_LOUNGE change clears all entities, so send it first.

v 0.29.14 (10-13-03, 5pm)
+ Fixed NPE in menu bar.
+ Moved to-do list out of history.txt and into its own file
+ Data 809664: Added Brandfuchs Mech images.
+ Data 806313: Added Ploppys Mech images.
+ Bug 821063: Fixed BV of some precision AC ammo
+ In-game unit list/selector/overview.
+ Larger, bold font in chat.
+ Patch 819951: MaxTech Crunchy Hip Rule by Alexander Schlling.
+ Moved phase action buttons around
+ Made "Turn Report" menu item work
+ Removed little one-letter buttons in favor of menu and hotkeys

v 0.29.13 (10-05-03, 11pm)
+ RFE 814576: Show PlayerColor when Camo is missing.
+ Added common client settings dialog.
+ Game Options works from the menu.
+ New chat box.

v 0.29.12 (09-28-03, 10:30pm)
+ Shows movement step by step, optional in MegaMek.cfg.
+ Bug fix for the above.
+ Bug 802741: "check false" should *not* be added as a modifier.
+ Use the build.xml from thebohemian.
+ RFE 807590: Distinguish "fled" from "pushed offboard" and "ejected".
+ Bug 803965: Changed option label from I.S. Equipment Limits to Ammo & Equip..
+ When a transporter ejects, unload all passengers.
PARTIAL IMPLEMENTATION:
+ RFE 555499, 702795, 726478, 783395: Added a menu bar.
+ Data 808992: added tallasia maps from German box set
+ Added Deploy-menu.
+ Sorts camolist
+ Added common settings dialog.

v 0.29.11 (09-15-03, 3pm)
+ All movement resets result in the "walk" gear being selected
+ Back space removes the last movement step.
+ Fixed NPE with quad lateral shifts

v 0.29.10 (09-08-03, 2pm)
+ Bug 799275: Gauss ammo defensive BV correctly calculated.--LDE
+ Fixed problem with turning and backwards movement
+ Added /defeat command to acknowledge /victory command.
+ Fixed bug with Mech preview image.
+ RFE 799511: defined images for Enforcer III and Grand Dragon
+ Data 796980: added Hauptmann image by brandfuchs
+ Patch 794111 MaxTech Target Movement Modifiers by Alexander Schlling.
+ Bug 787486, 789749: LOS bug over water, also fixed bug with smoke on water.

v 0.29.9 (08-31-03, 10pm)
+ Fixed bug 781250 and cleaned up MASC code a bit
+ RFE 795292: Added "data/hexes/shrubbery.txt" for "maptileset" in MegaMek.cfg
+ Finally located a copy of the source for TinyXML.
+ Bug 774533: Added isRepairable() to indicate that a unit can be rebuit.
+ Bug 762509: Can't run or jump when unjamming a RAC.
+ Found and fixed an NPE when hit "done" in movement phase.
+ MSJDK compatibility changes(Vector issues). No net change.
+ Mech preview image in Select Mech... dialog and Mech Quick View dialog.
+ Bug 796081: updated "BMRr Feature List.txt" to indicate how to face off-board
+ Fixed repeating "Player X disconnected" problem
+ Bug 794377: fixed main menu not reappearing when client disconnected
+ Data 796410: Added Uziel.gif (submitted by brandfuchs).
+ Fixed MSJDK compatibility issues
+ Continue movement state refactoring (some PSR warnings broken, watch out)
+ RFE 706481: recognize units with two C3Master computers.
+ Bug 686063: Count the members of the C3 network and alert the user.
+ Bug 791578: C3 range: use Entity#isActive() not Entity#isSelectableThisTurn()
+ Added the minimap to the map editor. Also, made minimap more efficient by 
  disabling its drawing if it's hidden (it can slow down the game on large maps)
+ Bug 797819: Pre-loaded infantry can now be deployed when using "Infantry move
  after meks" option.
+ Bug 795729: inactive units may not eject, spot for IDF, or dump ammo
+ Fixed bug with Artemis IV hanging the server
+ Bug 782037: fixed problem with movement paths and re-selecting units
  
v 0.29.8 (08-24-03, 8pm)
+ Bug 786735: Vibrabombs now works correctly.
+ Added minefield option under Game Options.
+ Splash screen image code now uses natural image size
+ Vehicles now use red secondary arrow to indicate turret direction
+ Fixed bug where locked turrets wouldn't show a direction
+ Bug 780962: tree clubs work again
+ Bug 760256: mechs dumping ammo try to reload weapons using that ammo
+ RFE 675994: "I.S. Equipment Limits" option allows TL2 ammo in TL1 units
+ RFE 762234: Support "Mixed" tech base in MTF files
+ New wood images.
+ RFE 730456: "Load Unit List..." now appends.
+ RFE 730457: Added a "Delete All" to compensate.
+ Bug 735499: Delay RNG start until beginning to host.
+ Updated BMRr Feature List.
+ RFE 700190: unconscious units count for initiative (option disables)
+ Bug 793574: TDB uses the "Missile" spelling, not "Missle".
+ Bug 783641: Unloaded infantry are deployed.
+ Removed opportunity for unconscious units to move or attack
+ Restored old woods images (I love them so)

v 0.29.7 (08-08-03, 6pm)
+ Data 779006: Added BH-21's resized mech images
+ Minefields(no command-detonated, but Thunders). LOS setting button back.
+ Bug 782105: Can't make physical attacks while spotting
+ Bug 775122: Map editor load button now never disabled
+ Bug 777415: No Artemis IV bonus while using IDF

v 0.29.6 (08-03-03, 7pm)
+ Merge of underwater patch undid the Inferno SRM2 fix.
+ Bug 776023: Made "Warhammer IIC" the model for all clan whammys.
+ Bug 755993: fixed NPE when closing a non-initialized connection
+ Changed main menu behavior (Client is now responsible for its own Frame)
+ Added aimed shots for targeting computers and against immobile targets.
+ Added explosive NARC pods.
+ Bug 775122: fixed NPE which broke map editor load button
+ Saved game load dialog starts in base directory
+ Bug 775472: wait for new hex images (like smoke) to load before drawing
+ Bug 779344: Entity.ARMOR_DOOMED made human-readable in display
+ Added a LOS tool setting dialog.
+ Added delayed deployment code
+ Patch 781242: Applied BobTheDull's patch, fixing a few water issues
+ Movement code refactoring step 1: MovementState object made
+ Removed the LOS tool from the board editor.

v 0.29.5 (07-27-03, 9pm)
+ Bug 759032: fixed NPE in MovementDisplay
+ Bug 774767: attacks at 0 range prohibited again for non-infantry
+ Patch 770478: Added nalleolsson's LOS/Range tool.
+ Data 775715: Added carpe_mortis' image.
+ Data 775886, 775888, 775891: Added rancherion's images.
+ RFE 775704, Data 775984: Added starcaptaintorc's images.
+ Bug 776084: target partial cover now counts in indirect fire
+ Patch 726073: Applied bobthdull's updated patch for underwater rules
+ Bug 776522: Meks missing a leg should have a run MP of 1, not 2.
+ Bug 755001: Passengers with ECM should still affect enemy electronics.

v 0.29.4 (07-20-03, 7pm)
+ Added all new files from xylaan (no net change).
+ Bug 773000: Tank hit locations
+ Bug 773001: Tank locations on armor diagram
+ Added files for 'camo' schemes from nalleolsson (no code changes)
+ Patch 768978: Allow selection of camo schemes instead of colors. Camo schemes
  take precedence but default to 'No Camo'. Patch originally submitted by 
  nalleolsson (Bjrn Olsson). Tweaks and additional code by kipsta.
+ Bug 769106: Fixed bug that was messing up "go prone to dislodge swarmers."
+ Data 762795: Added BH-21's Avatar image.
+ Data 764066: Added BH-21's updated images.
+ Data 769828: Swapped Perseus' & Yeoman's images.
+ Bug 764704: Inferno SRM-2's can still target woods for ignition.
+ More cleanup work on "go prone to dislodge swarmers" code. (no net change)
+ Bug 772328: the spotter flag now resets every round
+ Bug 772328: no benefit from C3 when using indirect fire
+ Bug 774509: fixed infinite loop in camo selection on linux

v 0.29.3 (06-14-03, 9pm)
+ Did some to-hit code refactoring (no net change).
+ Added indirect fire mode to LRMs (spotters must use spot button)
+ Indirect fire rules made optional

v 0.29.2 (06-07-03, 12am)
+ Task L3 Advantages: Added core code for L3 (MaxTech) pilot advantages. To 
  enable these you must enable the MaxTech pilot advantages Game Option. This 
  will make a scrollable box visible in the customize mech dialog. Advantages
  finished are: Dodge Maneuver, Maneuvering Ace, Melee Specialist and 
  Pain Resistance
+ Task L3 Engine Explosions: Engine explosions, per MaxTech (BTH12 after 2 or 
  more engine crits in a round), are done.
+ Task L3 Scenario Improvements: Added ability to define pilot advantages for a
  scenario. See new Example.mms
+ File Added: data/scenarios/Example.mms to explain all scenario posibilities
+ Task L3 Weight Class Mods: MaxTech 20+ damage per round weight class mods 
  added. Assaults are -2 to BTH, whereas lights are +1. Mediums and heavies are
  in between. When turned on, also enables cumulative damage tracking. Roll is
  now +1 for EVERY 20 damage taken in a round instead of just for the first 20. 
  It's still only 1 pilot roll for the damage. Therefore, 20-39 damage is +1, 
  40-59 is +2, etc...
+ Feature 734125+: Added "are you sure" check for movement that requires
  piloting skill rolls.
+ Bug 763169: Dropping prone now has chance to dislodge swarmers.
+ Bug 756126 (possible): Only needed hex images loaded during board load
+ Found and fixed bug in L3 weight mod damage rolls. Was forcing 2 pilot rolls.
+ Added ability to save game options. On the Game options dialog is a save 
  button which will write the current state of the game options to the
  gameoptions.xml file. This file is read at start up if you are hosting a game
  and will automatically set your desired 'default' options.
+ Task L3 Firing while down: MaxTech firing while down rule: can fire if you 
  still have one arm but are at a +1 to hit with all weapons and can not
  fire weapons in that arm.
+ Task L3 Opposed weight mods for physicals: PSR BTH when being kicked or 
  pushed is modified by weight class difference. Modifier is 1 for every 
  weight class difference. Add the difference to the PSR BTH if the attacker
  is heavier, subtract if the attacker is lighter.
+ Extracted multiple version of status bar code to one StatusBarPhaseDisplay 
  class and changed all phase display subclasses to extend this. This allows 
  changes to the status bar to happen in one and only one place.
+ Added save/load of advantages for unit list
+ Bug 767439: Made CT of engine boomed mechs marked as destroyed

v 0.29.1 (06-27-03, 11am)
+ Bug 760509: apply case-insensitive comparisons to default images, too.

v 0.29.0 (06-25-03, 12am)
+ Data 754926: Added kurt_kajal's bridge images.
+ Bug 755006, Data 755442: Desertmountain boards should have rough, not rubble.
+ Data 754488: Applied graphics submitted by McWizard.
+ Bug 756028: Java library problem, used work around.
+ Feature 736136: Locations on tanks and mechs that have zero armor (or zero
  internal) are now dark grey instead of red.
+ Bug 757449: don't swarm if the target was destroyed by weapons fire.
+ Bug 757383: Mechs with MASC have correct BV again.
+ Skidding mechs only use MASC movement when player intended it.
+ Mech preview shows proper movement again for MASC equiped mechs.
+ Bug 756054: partial fix: bot shouldn't throw exception when it gets swarmed.
+ Bug 754730: Mek can't dump ammo and jump; also, can't shoot w/ dumping ammo.
+ Bug 757794: Give a doomed or destroyed pilot 6 hits for MegaMek.NET.
+ Bug 754614: A tank that dies by critical should have dead crew.
+ Bug 755991: Fix reported NPE during disconnections
+ Bug 759464: No longer allow mechs to use Battle Armor LRM 5 ammo.
+ Changed syntax of MegaMek.bat to avoid errors on older Windows versions.
+ Bug 759858: Use case-insensitve comparisons to find an image for a unit.

v 0.29 release candidate 1 (06-16-03, 11pm)
+ Bug 748959: fixed bug with moved units not updating
+ chat box may scroll to bottom properly on Linux (thanks Bluebird)
+ Only the xml file needed now to use The Drawing Board mechs.
+ Fixed 25 misnamed mech files (mostly capitalization errors)
+ Updated data/mex/mechset.txt to handle missed names.
+ Bug 751181: Code bot to handle null pointers.  Bot still doesn't handle BAs.
+ Bug 710309: bot now seems to be able to cope with fallen mechs 
+ Bug 733536: Disable the "Load Board" button until tileset manager loads imgs.
+ Bug 705877: Use the highest "dead" level for a unit.
+ Data 754118: added revised readme-German.txt.
+ Bug 754610: Revert fix for bug 702735.
+ Bug 720322: Apply defensive systems, targ comp, and C3 BV logic to Tanks.
+ Added "Unit Loading Failures" dialog.
+ Added ability for scenario system to support multiple people on one team using 'Team_<name>=#' attribute
+ Bug 755088: Tanks should initialize their body section.  Tank ammo slots
              are loaded strictly by order encountered in their location.
              N.B. this means that you can't delete ammo slots from a Tank's
              MUL entry, or things get all screwy.

v 0.28.22 (06-08-03, 9:30pm)
+ Bug 745922: jumping into water washes off infernos properly
+ Applied Wirianto Djunaidi's 2003-05-30 updates.
+ Bug 721574: several changes to GAAttack and GALance to avoid lockup problem.
+ Data 744969: added shockmilk's boards
+ Bug 746671: misses accidentally start fires again
+ Bug 703115: charging units move into dest hex even if defender is destroyed
+ fixed nonfatal bug initializing mech selector on Mac OSX
+ Bug 705806: the bot doesn't outright crash when fighting battle armor
+ Bug 748959: possible fix for moved units not updating
+ fix for SpecificEntityTurns being granted
+ Applied patch #748127 to the main menu buttons in MegaMek.java
+ Bug 741112: mention destroyed locations in the MUL and then reset the flag.
+ Bug 750573: removed incorrect modifier to standing up in development versions
+ Bug 750323: when player switches ammo, update the targeting information.
+ Bug 748648: Stop assuming external passenger I.S. is positive.
+ Make ammo selections work in *all* phases.
+ Bug 738011: Misses with Inferno rounds should still ignite the target's hex.
+ Misses can't ignite fires or damage buidings if AMS shoots all missiles down.
+ Bug 748627: Reorder PHASE_END case in Server.prepareForPhase.
+ Added the scenario-readme.txt file submitted by Lee "T-Bolt" Smith.
+ Bug 716034: a themed hex in a board should match any unthemed hex in a hexset
+ Bug 702735: a Mek or Tank in a hex with pavement, road, or bridge (at the
      same elevation as the Mek or Tank) checks for skids if it turns and runs

v 0.28.21 (06-01-03, 10pm)
+ Bug 743355, Data 742085: applied updated infantry.zip from Hopalong.
+ Bug 712311: use only lower case letters in the image file names.
+ Bug 743256: don't use Vector#add, use Vector#addElement.
+ Feature 730413: Mech preview now shows vehicle traction type.

v 0.28.19 (05-25-03, 12am)
+ Mech readout window in lobby closes with "x" in corner too
+ proper "waiting to..." message in physical attack phase
+ server sends all IP addys on multi-homed hosts to connecting players
+ Bug 632803: falling into water only counts levels to surface for damage
+ centralized all out-of-game entity storage
+ Bug 741214: clients sent all entities, living & dead, during victory phase
+ Prettier confirmation dialogs
+ Feature 722106: Automatic MASC engagement
+ No longer possible to change the mode of destroyed equipment
+ "test-msjdk" target in ant build.xml works again
+ bug 710329: secondary target modifier now appears properly during fire phase
+ firing player sees his attack arrows as attacks are made
+ Bug 740276: reverted fix for bug 732188
+ buildings need all three parameters (building, bldg_elev, and bldg_cf)
+ Bug 737441: torso twists resolved before AMS is assigned
+ Patch 730635: updated mechdisplay

v 0.28.18 (05-18-03, 11:35pm)
+ Bug 732188: Poor terrain matches shouldn't throw out the base image.
+ Bug 732044: Use more intelligent hit locations on skids.
+ Bug 725946: Handle falls during skids.
+ Bug 725075: Handle infantry that is killed in same phase that it swarms.
+ Bug 730729: No more extra movement when getting up with walk MP of 1.
+ Updated get up and go prone graphics (and fixed problem with getting up
     arrow not displaying).
+ Bug 736534: Fixed Scenario Loading to use new initiative code.
+ Fixed bug preventing Systems Mode dropdown from showing current choice.
+ Bug 739057: Fixed MASC rolls after first turn. 
+ Bug 737972: 3 Infantry per 1 Mech should work now.
+ Made small layout/format changes to the mech display's systems tab.

v 0.28.17 (05-11-03, 1pm)
+ bug 731676: allow skipping a player w/ no entities to move
+ Bug 731933 fixed, mostly.
+ Bug 732001: Infantry weapons should not be IS-only.
+ Bug 732327: Don't allow deployment into prohibited terrain.
+ bug 717273: possible fix for "dead mech makes physical attack"
+ bug 730075: fixed crash during DFA against destroyed target
+ similar fixes to charge against destroyed target
+ Bug 729877: save games load without error again
+ Bug 729795: fixed bug with split weapons not counting for physical attacks
+ Mech selector, mech display, minimap windows close normally (X in corner)
+ Bug 693885: Ignite choice not displayed if fire option turned off
+ Bug 724533: Displaced DFA'd units can't displace their own attacker
+ Added swords
+ Reordered "data/hexes/defaulthexset.txt" to better support rooftop fluff.

v 0.28.16 (05-03-03, 4pm)
+ RNG type changable in game options
+ RNG type changes print message to the logs
+ "Loading mechs..." dialog added.
+ Feature 652625: Applied xylaan's Team Initiative patch (728677).
+ Bug 709873: Applied xylaan's RAC heat BV patch (729332).
+ Bug 728998: Changed internal name for IS AP Pods.
+ It should no longer be necessary to delete mechcache.txt (Bug 691364)
+ Mech selector now has "All" option for weight and type.
+ bug 712051: ECM now correctly prevents narc & artemis iv bonus
+ Bug 724556: Fixed Multiple MASC failure checks 
+ Feature 698967: Added /seeall command to let an observer see in double blind
+ MegaMek.exe is now MegaMek.bat (the functionality has remained unchanged)
+ Bug 728603: bad developer, put a "not" where it didn't belong... no donut.
+ Feature 729851: Updated code for MW : DA squads.
+ Bug 731720: fixed data/mex/mechset.txt for Atlas AS7-S.
+ Data 729975, Feature 723876: added hopalong's Clan platoons.
+ 717973: Pilot death is delayed until end of phase
+ 695374: Vehic weapon jams should work correctly now

v 0.28.15 (04-27-03, 7:30pm)
+ Added BAP, TAG, and AP Pods just to calc BV correctly, rules not implemented.
+ Target buildings for ignition.
+ 723043: Stop casting a Tank to a Mech to show C3 BV affects.
+ 724350: Updated mechset.txt for the new Infantry names.
+ 724351: Running away with someone else's Battle Armor squad shouldn't crash.
+ Add check for existing fires to Server#tryIgniteHex().
+ Renamed Server#burn() to Server#ignite(), to match Inferno naming convention.
+ Only shots that miss Entities accidentally ignite fires.
+ Tooltip for weapons fire should use text value.
+ "/skip" command should handle NULL entities.
+ RFE 658785: config file now has a setting to not auto-confirm weapons fire 
+ 725772: possible fix for NPE in C3Sprite#drawOnto
+ Added support for mechs created with The Drawing Board.
+ 586306: Added FASA maps.
+ 724966: Added corrected maps.
+ 726265: Added Dirk Wilhelm's "Blind Drop" patch.
+ Added Wirianto's formatting update.
+ 702704: Added Wirianto's fix that prevents fires from crashing the game.
+ Weapons fire inside multi-hex buildings now works.
+ 720663: Multi-hex bldgs were getting added multiple times because I'm moronic
+ 724780: Rebind Board's data after loadGame() (bldgByCoords was null).
+ Pressing enter will dismiss the host game/connect/configure mech windows.

v 0.28.14 (04-19-03, 4:45pm)
+ Eliminated unused local variables thanks to (forgot to write down name).
+ Infantry should be moving last again when the option is selected.
+ MovementData.Step.clearAllFlags() should be working now.
+ Added more building images from kurt_kajal.
+ 721548 & 721991: don't blow up when everybody dies.
+ 706086: Included Blazindizzy's images.
+ 723157: Skimmer file updated.
+ Allow a player to configure a log to track Mek Hit Location rolls.
+ clients are now aware of who wins or loses in the victory phase
+ 711573: charges always hit full/kick table for mech/vehicle attackers
+ added eject movement action (not full ejection rules yet)
+ moved a few movement buttons around

v 0.28.13 (04-12-03, 5:30pm)
+ Players aren't allowed to target infantry with Inferno rounds.
+ Physical attacks can now use Targetable interface.
+ Initial implementation of buildings.  You can't burn them or climb on them,
        they have no basements, and multi-hex combat doesn't work correctly.
+ 705262: The EXE can't seem to handle UTF-8 output.  We'll restore UTF-8 when
  we can figure out the root cause of the problem.
+ 716051: Allow boards to disable auto-exiting roads into pavement hexes.
+ 711714: Added swamp hexes.
+ 712049: Added "snow" theme hexset.
+ 715999: Battle Value with linked c3 shown in mech viewer for c3 mechs.
+ 716548: The club in a ClubAttackAction is transient, so it must be re-bound.

v 0.28.12 (04-05-03, 1pm)
+ Stealth Armor should affect the BV calculation.
+ The +2 skid modifier is *in addition to* the movement modifiers.
+ 709127 and 712227: Incorporated changes into vehicles.zip; note that I
  believe that several vehicles listed in the 3050+ TROs were in service in
  3025 (e.g. the Heavy APCs, the Light SRM Carrier, and the Zhukov Heavy Tank).
+ added "fluff" terrain type with no intended game effect
+ hex theme settable from the map editor
+ ".board" extention checked for in map editor
+ exits terrain parameter counts for base images too
+ applied Oscarmm's patch adding heat tracking to the firing display
+ The way the BMRr handles Mek Stealth Armor has been superceded.
+ New images for Rubble hexes.
+ Applied Oscarmm's Light Engine BV patch.
+ Applied oscarmm's "Unit Type" filter patch (711891).
+ Applied oscarmm's MechView patch (715044).
+ Added kurt_kajal's "fluff" hex graphix (711714).
+ Added hopalong's infantry files (712083).
+ Reverted BattleArmor short names back to the default generation procedure.
+ 712054: Only Longinus and Purifier are "burdened" by their ammo.
+ applied Oscarmm's patch to hide the minimap  during report phases (712339)

v 0.28.11 (03-29-03, 7:30pm)
+ 708743: minimap now initialized correctly even if "disabled"
+ winning player or team tracked during normal or force victories
+ Added vehicle flamers--LDE
+ Flamers can now clear woods (per BMR's less stringent clearing)--LDE
+ Infantry can no longer clear woods (per BMR's more stringent clearing)--LDE
+ Flamers (except platoon infantry flamers) now have 
  "Damage" and "Heat" modes (flamer option now default on)--LDE
+ 708441: Merged changes into "data/mechfiles/vehicles.zip"
+ Added new images for Highlander and Bushwacker.
+ BattleArmor troopers can still receive hits in the phase that they are killed
+ Players shouldn't be allowed to declare infantry to clear woods, some weapons
  to ignite fires, or use flamers to raise the heat of infantry or tanks.
+ 708217: Meks with active stealth can't be on C3 networks.
+ 708661: actions reset when switching units using the right click menu
+ cleaned up some unfinished code (argh)

v 0.28.10 (03-22-02, 2pm)
+ updated build.xml, build.bat for TinyXML.jar
+ attacks now clear correctly again if there is no physical attack phase
+ 668491: pop-up "view" menu item works any time
+ unit display position, size saved to MegaMek.cfg
+ "D", "M" buttons toggle unit display, minimap
+ 662477 and 664446 and 705062: applied data item 705355 and patch 705169
+ The new file, vehicles.zip, includes and supercedes the files,
  vehicles3025.zip and vehicles3058.zip.
+ 702762: applied submitted file
+ 705358: read TroopSpace as a Double, and drop fractions.
+ Handle chassis-only vehicles correctly in the XML unit file parser.
+ Internal structure for tanks should round all fractions up.
+ prefer attacker partial cover slightly in split LOS situations
+ 704999: actuator hits on other leg count with one hip hit
+ 702760: going prone in water can wash off inferno gel
+ 706738: If there are many choices, display them in a ScrollPane.
+ Hetzer should have a 4/6 move, not a 5/8.
+ 706682: Stop processing movement in the server after removing the entity.
+ 700148: Using cluster ammo prevents the use of a targeting computer.

v 0.28.9 (03-15-03, 5pm)
+ Added XML parsing to MegaMek.
+ Changed MUL files to an XML format.
+ client now is more aware of charge-type attacks, and displays them
+ fix NPE in movement when determining prone status
+ heavy woods made somewhat distinct on minimap
+ 701259 and 701649: used the updated vehicles3025.zip file.
+ 701999 and 702237: used the updated vehicles3058.zip file.
+ 702590: the AMS (and NARC launcher) system had incorrect name in ZIP file.
+ 700644: unload transported units when they're destroyed.
+ 671513: added all images (even bad ones) and updated mechset.txt.

v 0.28.8 (03-07-03, 7:20pm)
+ Added ability to go prone
+ Added movement path sprites for getting up and dropping prone
+ 694497: ability to view turn report in popup window during other phases
+ 690845: server options can be set in scenario games
+ 630298: can use shift+arrow keys to torso twist
+ client keeps better track of recieved attacks
+ 692607: crits transfer from loc with non-hittable crits, like endo steel
+ added zipp32's attack arrow patch
+ Applied latest version of oscarmm's Mech Viewer patch.
+ Typo in Client#loadListFile method.
+ 696097: When removing turns, keep the client's turn lists in synch.
+ server no longer can assign duplicate entity or player ids
+ 694893: When calculating stacking violations for unloading, the transport
          may not have reached the destination hex yet.
+ 699057: possible fix for deployment hexes highlighted during the game
+ fixed vehicles going prone
+ Added an "Extras" panel to the Mech Display.
+ 660040: Added a "NARCed by" field to the Extras panel.
+ 678434: Moved the transport fields to the Extras panel.
+ 698398: Dead pilots are *dead*, not *unconcious*.

v 0.28.7 (02-28-03, 9:00 pm)
+ Roads exit into Pavement hexes.
+ Updates to cityruins.txt; are the road exits still right?
+ echo version, java info to console log on startup
+ log might finally contain correct ip address
+ Tank BV formula corrected.--LDE
+ Turrets no longer displayed on turretless tanks.--LDE
+ Implemented road bonuses to movement.  Includes moving through terrain.
+ Skids now use BMRr rules (and not CityTech) for hex that starts the skid.
+ cache IdealHexes for Compute.intervening()
+ fixed null exception in boardview
+ replaced old bot LOS evaluation
+ unit list file save & load now includes & obeys a file path
+ fixed divide by zero in Coords.radian()
+ fixed bot feeding negative values to randomInt
+ Applied Michael Newcomb's HmpFile patch (after fixing several bugs).
+ 691583: Mimetic armor has a +0 movement modifier when it moves 3 hexes.
+ 693011: need to replace "chassis" matches with "exact" for vehicles.
+ Applied latest version of oscarmm's Mech Viewer patch.
+ 692963: on DFA misses, the defender moves to the highest valid hex
+ RFE 694587: right-click menu allows you to select a unit for use
+ 629707: fixed HGR psrs' cumulative-ness (cumulativity?)
+ 694174: possible fix for null exception in toHitThrash
+ new "save any time" technology (/save)

v 0.28.6 (02-22-03, 12:00 am)
+ Allow tanks and infantry in the preview pane.
+ 683267: correctly allocate spaces for Endo Steel and Ferro-Fibrous.
+ Allow scenarios to define a rotated board.
+ all selectable entity determination controlled by GameTurn
+ 682166 LMG and HMG racksize == weapon damage; add half-ton ammo
+ 679250 Change BA NARC racksize to prevent listing in ammo selector.
+ Striker Light Tank (level 1 & 2, and LRM variant) shouldn't show Mek gif.
+ rough byte count kept per connection (use /who)
+ externalId field added to entities (for mm.net use)
+ 687825: fix crash going back to lobby from a scenario
+ first initiative phase not lost when using a scenario or loading a savegame
+ autosave takes place at beginning of initiative, not end phase
+ 675633: NullPointerException squashed
+ disconnected players must be manually skipped (with new /skip command)
+ added zipp32's minimap overhaul patch
+ 679061 Don't allow Battle Armor Ammo on Tanks or Meks.
+ 688389 BMRr states that you can't change ammo loads on infantry (Inferno
         SRM platoons have their own unit file).
+ 681414 renamed various systems to match David McCulloch's names.
+ Added Kage battle armor squads.
+ Added submitted unit image files.
+ option for teams to share vision (in double-blind) added
+ 688179: a few double-blind exceptions squashed
+ 688701: can't target youself for a physical (or other) attack
+ 687695: the bot doesn't crash on its first move any more
+ bot no longer tries invalid deployments

v 0.28.5 (02-15-03, 1:38pm) 
+ GameTurn now controls which entities are selectable
+ invalid turns rejected at server (may fix turn skipping)
+ should not be able to retry if unit died during get-up attempt
+ attacks sent from the server in a batch instead of individually
+ 681971: graveyard, etc. emptied on reset
+ client does not try to send ready signal when confused
+ applied Oscar's mech preview patch
+ 682833: disconnected players handled better under new turn code

v 0.28.4 (02-07-03, 11:46pm)
+ player & entity "ready" changed to "done" to be more clear
+ no more player "done" transmitted in phases with turns
+ entity "done" implicit instead of seperately transmitted
+ "devestated" = "devastated"
+ 666610: updated AMS reporting
+ no more NullPointerExceptions in UpdateRACButton
+ show label for Unjam RAC button all the time
+ Fix bug in MovementDisplay that prevents Charges and DFAs from working.
+ 672181: DFAing units do not violate stacking during movement
+ 678789: starting position in scenarios made case-insensitive
+ 678789: wind direction set properly (randomly) in scenarios
+ players may enter the game as an observer
+ message indicates initial game data transmission
+ Allow players to save and load lists of units in chat lounge.
+ Allow players to save lists of units (includes damage) at end-of-game.
+ 678795: Possible fix -- can't test
+ Don't allocate AMS for non-entity targets.
+ Clearing and Igniting hexes have separate logic
+ 643816: Clear/Ignite implementation brought into line with canon
+ Only woods hexes can be targeted
+ 663535: Targeted smoky hexes don't get their own smoke bonus
+ Dedicated servers load password/port settings from .cfg file correctly
+ updated mech files, thanks Hopalong
+ replaced battlearmor images in CVS with binary ones

v 0.28.3 (02-01-03, 12:13am)
+ Allow clients to define unique entity IDs.
+ Track and report the difference between units that have Fled, still 
  salvageable, and utterly Devastated.
+ Upgraded scenarios to use deployment
+ Implemented random initial damage in scenarios
+ added 2 new scenarios to distribution
+ converted targets to Targetable interface
+ switch hex-targeting to right-click menu

v 0.28.2 (01-22-03, 3pm)
+ added patch 658064: Unit status report generator update
+ battle armor & infantry also displayed in report
+ Implemented "Swarm Mek" attacks.
+ Implemented "Stop Swarm" attacks (i.e. 'actions taken during firing phase').
+ Implemented "Brush Off" physical attacks.
+ Implemented "Thrash" physical attacks (Mek attacking Inf while Prone).
+ Allowed Prone Meks to Punch Tanks in their hex (if both arms available).
+ The Unit status report generator should format BA & Inf locations in report.
+ 674198: SSRM Misses Setting Fires Again
+ Applied ensign's Inferno patch.
+ Fixed bug in determining "most destructive" ammo slot in explodeAmmo.
+ Added inferno-equipped IS SRM infantry platoons.
+ Added Clan Salamander Elemental point.
+ Added ammo loadout selection to the lounge
+ Added Precision AC ammo

v 0.28.1 (01-20-03, 7:19pm)
+ COMPATABILITY BREAKER: allow Charges and DFAs to target *any* enemy in hex.
+ 643582: Allow vehicles to transport infantry.
+ Update skidding to better match the BMRr.
+ Better support for targeting units in the attacker's hex.
+ Anti-Mek Leg Attacks (Swarm Mek is not implemented).
+ BattleArmor initial implementation (many special rules not implemented).
+ 638815: Allow players to rotate maps 180 degrees.
+ Fixed error in many IS MTF files (possible bug in Mek editor).
+ Added BattleArmor stealth, mimetic camoflage, and single-hex ECM.
+ 669169: Allow turns after first step while stacking with the enemy.
+ Applied the ATM patch written by ensign@users.sourceforge.net.
+ 660585: Implemented Mek Stealth Armor.
+ JDK 1.1 compatibilty restored(?)
+ Switching ATM ammo should change range display.
+ Add "Purple" to list of player colors.

v 0.28.0 (01-10-03, 3:50pm)
+ 662333: ams doesn't fire on non-locked streaks
+ 662333: ams can't use more ammo than it has
+ added a bunch of new level 2 i.s. mech pics, thanks to Cyric
+ fixed (mysterious) crash on loading in OSX
+ charge damage correct again
+ heat phase only displays mechs
+ 664819: multiple get-up tries should not add to heat multiple times
+ 664939: friendly c3 units need LOS to to the target to affect a shot
+ dfa on dead target message changed

v 0.27.14 (01-03-03, 9pm)
+ ammo exploding from heat can't explode twice
+ 657606: dead meks can't engage in physical attacks
+ added codes for IS TargComps
+ redirecting output to logfile for easier review
+ 654324: temp fix for mis-sized targcomps
+ infantry BV adjusted for gunnery skill
+ AMS fires even on missing salvos
+ AMS can shoot down more missiles than it has ammo
+ gauss rifles count as explosive ammo for BV calculations
+ ultra ACs and streak SRMs affect BV correctly
+ 660514: Clan AMS has 24 shots
+ fixed a few equipment name problems when loading MEP files
+ handle mechs that don't have the full amount of engine heat sinks correctly
+ hatchets, AMS, tcomp, TSM, MASC, RACs affect BV correctly
+ unconcious pilots perorm, but fail at DFAs
+ 657511: Bot no longer freezes when it kicks a Tank (or Infantry).
+ 657635: Can't reproduce error.  Added logging of pilot baking to death.
+ Stop logging when an Entity ID is translated into a Coords object.
+ 623853: bot now completely recalculates movement when falling mid-move
+ bot should not move the wrong mech when directed

v 0.27.13 (12-29-02, 5pm)
+ 652291: Mechs can "stomp" (kick) vehicles in their hex.
+ 657119: streak SRMs fire again
+ Infantry don't take double damage in Rough or Rubble.
+ 649338: SRM and Laser jump infantry have jump MP of 2, *not* 3.
+ added mechset entries for warhawk and dire wolf pictures

v 0.27.12 (12-20-02, 4:30pm)
+ 652106: possible fix for linux flickering in lobby
+ 652105: board pop-up menu appears on linux (and mac too, maybe)
+ added dialog about where to find help with the board editor
+ 561342: ammo decreased before damage is assigned
+ AMS owner, not launcher owner, gets AMS heat
+ during DFA, with prone attacker, dead target, attacker takes falling damage
+ 618373: DFA 3+ levels down can no longer result in automatic fall
+ 653880: mep names added for recently-added equipment
+ 654328: artemis iv and narc are no longer cumulative

v 0.27.11 (12-13-02, 8:10pm)
+ killing a C3 network master no longer crashes the client
+ 649950: doFlamingDeath isn't checked in the end/heat phase
+ C3 factored in BV
+ Narc implemented
+ ArtemisIV implemented
+ fixed bug in pilot skill-setting with c3 mechs
+ ECM implemented
+ fixed Artemis BV mod
+ 618298: lobby screen fits on 800x600
+ partially added TargComps (ToHit mod, but no aimed shots)
+ lobby lists re-enabled (disabled lists are hard to read)
+ crash in board loading fixed
+ 649303: charging movement distance for weapon hit fixed
+ a few mech pics fixed
+ water partial cover added to physical attacks 
    (is this correct?  it's certainly dumb)
+ 647272: smoke rises above the surface of water

v 0.27.10 (12-06-02, 11:25pm)
+ new naming system for mechset.txt, allowing omnimechs, etc
+ 648138 fixed C3 showing up on mechs that shouldn't have it 
+ 646609 intentional fires set at correct level
+ added movement display colors to config file
+ bot deploys itself
+ 648967: fixed typos in mechset.txt
+ updated vehicles to use new naming system
+ scenarios now use full unit name (and can use vehicles, omnis, etc)

v 0.27.9 (12-01-02, 12:19pm)
+ 642892: charging units don't move into the target's hex until resolution
+ Clearing fire now correctly clears flip arms.--LDE
+ Movement path colors now more colorblind friendly.--LDE
+ fix crash with C3i units
+ small or ER small lasers, also SRM-2s can't start fires; MGs can
+ 639398: bot is moving again

v 0.27.8 (11-22-02, 11:41pm)
+ applied HentaiZonga's patch for C3, RAC unjamming and targetting hexes
+ 639358: jumping over fire hexes does not raise mech heat
+ 636311: infantry are destroyed by fire too
+ 636311: fire kills vehicles & infantry under the correct circumstances
+ Conciousness rolls start at "3", not "2".
+ Multiple infantry updates.

v 0.27.7 (11-15-02, 11:30pm)
+ Applied skids patch to CVS tree.
+ Successive consciousness checks should be made from low rolls to high.
+ fixed lockup when fire tries to spread beyond the edge of the map
+ smoke and woods in the same hex no longer both apply modifiers to LOS
+ setting fires made optional (on by default)
+ 639202: streak SRMs missing should not have a chance to start fires

v 0.27.6 (11-08-02, 6pm)
+ Added Kai's fire patch (only working for missed shots, presently)
+ 633352: fixed NullPointerException when deploying during double blind
+ 632830: fixed typo causing small south deployment zone
+ inf_move_multi no longer messes up deployment phase
+ deployment phase works properly after /reset or victory
+ deployment phase not used when a scenario is loaded
+ 635209: prone mechs should not make piloting skill checks to avoid falling
+ out-of-range shots shouldn't cause fires when they miss
+ 630144: fixed glitch with bot beginning movement phase

v 0.27.5 (11-01-02, 10:30pm)
+ Add non-canon options to balance Infantry impact on the init phase.
+ Add error-checking to Entity#elevation().
+ Workaround for 630144: Bot "Beginning of Turn" Race Condition
+ added TigerWraith's patch, changing the mech selector slightly
+ Added a Deployment Phase
+ 630294: AMS actually decrements hits again
+ 630921: Can't manipulate someone else's unit
+ MASC turns itself off every round
+ 629707: HGR PSR modifier based on attacker, not target, weight

v 0.27.4 (10-27-02, 12:12pm)
+ 625838: only infantry shoot in the same hex
+ 625838: non-inf MGs do *dice* of damage to infantry
+ 625838: flamer infantry can do heat instead of damage too
+ 621346: mechs that "stomp" infantry in same hex have +3 to-hit mod
+ 621350: immobilized hovercraft sink in water
+ Ammo dumping implemented
+ HeavyGaussRifles added
+ LRM-equipped infantry added (as IS Lvl 2, 3050)
+ RACs implemented, but no unjamming
+ chunk of resolveWeaponAttack cleaned up. . hopefully easier to read
+ fixed a few double blind bugs
+ changed "Location empty" critical message to be more informative

v 0.27.3 (10-18-02, 4pm)
+ Abstracted equipment mode system
+ AMS can be turned off
+ fixed crash with bot and non-mech units
+ 622376: infantry can jump over water
+ MASC added
+ interface for switching equipment modes added
+ 622305: fixed crash with AMS
+ 622514: changed "missles", etc. to "missile(s)"
+ messed around with LOS; hopefully more readable code, bugs fixed
+ 536077: split crits supported (in mtf files only so far)
+ TSM added
+ 624368: LBX AC's use shots, not missiles.
+ fixed a slight bug with the new LOS changes and woods
+ 612729: units should no longer be displaced into prohibited hexes
+ 623853: bot should try getting up again if first attempt fails

v 0.27.2 (10-11-02, 5pm)
+ added right-click popup menu to board display
+ stacking rules (vehicles & infantry) partially implemented
+ 613612: units continue to take damage the same phase after they are destroyed
+ fixed a stacking bug
+ AMS implemented.  It can't be turned off yet
+ infantry have variable damage, not always missile damage
+ AMS only fires on attacks in arc

v 0.27.1 (10-04-02, 2:30pm)
+ implemented autosaving every turn and loading from saved games
+ bots can now attach to players in mid-game
+ Suvarov454's infantry patch applied
+ switched attack line drawing from keeping a buffered image to on-the-fly
+ added capability to send a single changed hex from server to client
+ fixed a crash under windows JVM with infantry

v 0.27.0 (09-27-02, 3:00pm)
+ 574898: bots don't instantly logout with double-blind
+ 612248: bots work tolerably with vehicles
+ 612429: turretless vehicles have their secondary facing set correctly
+ 613606: locked turrets should no longer cause a crash
+ fix allowing clan heavy and light MG ammo (thx to suvarov454)
+ 614883: option allowing drive/engine hits to not 'immobilize' a vehicle
+ 615400: mechs are not allowed to flip arms when prone

v 0.26.14 (09-14-02, 9:30pm)
+ 609840: immobilized vehicles can't complete their charges
+ 609356: vehicles do not make piloting skill rolls to avoid falling
+ 609201: fixed crash when a charging vehicle is destroyed by weapons fire
+ 568291: typo in determining charge elevation levels (thx to suvarov454)
+ 610307: ammo changes are properly applied while resolving weapons fire
+ 565005: latecomers see the report if joining during a report phase
+ damage taken during a fall modifies later get-up attempts
+ added no-tac and floating-tac game options for mechs (thx John Rowat)
+ 612180: vehicles use their slightly different damage arcs
+ 610616: immobile vehicle crits don't apply the to-hit mod in the same phase

v 0.26.13 (09-13-02, 11pm)
+ 607207: getting up and failing now correctly uses movement points
+ 607207: no get-up retries should a mech become disabled during an attempt
+ movement points already used during current turn displayed
+ 607206: jammed turrets no longer reset to face front
+ added lbx cluster ammo mtf designations for clan mechs
+ 603151: arms flip to front every round to be consistant
+ 607461: hovercraft always move along the surface of the water
+ 601063: vehicles are no longer placed in prohibited hexes
+ mech on mech charges were using incorrect hit location table
+ 608156: broken scenario support fixed
+ fixed crash bug with DFA misses
+ 592466: impossible PSRs now say "impossible", not Integer.MAX_VALUE
+ 607206: fixed crash bug with vehicles charging a mech
+ 608627: spurious tank death messages removed
+ 608767: hovercraft no longer recieve fire mods for being in water
+ 608767: prevented several more ways for a turret to rotate while locked
+ 608767: stunned vehicle crews don't roll for wakeup
+ disabled vehicles are counted as immobile for bth purposes
+ 608581: no more critical hits on CASE

v 0.26.12 (09-07-02, 11am)
+ fixed crashbug when no ammo was available to a weapon
+ mech selector now additionally looks inside .zip files
+ fixed crash bug with new ammo selector under MS Java
+ made physical code more flexible for vehicles
+ fixed mechcache load bug with zipfile entries
+ non-mechs never make PSRs that could result in falls
+ vehicle side-firing arcs setup
+ vehicles don't break the ammo-selector anymore
+ vehicle critical hits and special hits implemented
+ mechs that have fallen during movement can try to stand up

v 0.26.11 (08-30-02, 10pm)
+ 598824: a few more hovercraft movement fixes
+ physical attacks by dead or disabled mechs prevented
+ blk format now supports both mtf and mep equipment designations
+ can now select which ton of ammo to use on each shot
+ added fake mtf codes to distinguish lbx cluster ammo in mtf files
+ "fire mode" button allows switching between single and double ultra AC modes

v 0.26.10 (08-16-02, 10pm)
+ big horkin' vehicle patch.  Ground vehicles are mostly implemented
+ hovercrafts behave correctly on water
+ vehicles don't roll PSR after 20 damage
+ 592462: mechcache correctly reflects deleted mechfiles
+ vehicles don't roll PSR after being kicked
+ hovers move correctly over water
+ fixed bug in scenarioloader's map loading


v 0.26.9 (08-09-2002, 11:30pm)
+ detailed end-of-game unit status exported to a text file
+ scenarios now use new bot
+ formatting fixed in push-off-board notice
+ 583692: duplicate physical attacks prevented
+ 532080: jumping into water provokes a PSR
+ mech selector defaults to 3025
+ fixed movement to-hit penalty when a mech gets up and doesn't otherwise move
+ 567940: hatchets (not clubs) can now "swing" into arm arcs
+ torso twisting now affects club & hatchet arcs
+ 568526: when resizing weapon display, weapon list resizes too
+ 566267: fix to prevent minimap resize lockups
+ 577408: double movement due to lag prevented
+ 581000: if victory is on, it is triggered when there are no mechs left
+ one player on no team and one player on a team no longer causes team victory
+ 591886: fixed a bug causing physical attacks to be skipped

v 0.26.8 (07-26-02, 2:30pm)
+ Can now host a game from a user-editable scenario file
+ surviving and dead mechs listed in victory screen

v 0.26.7 (07-19-02, 9pm)
+ fix to check number of engine hits when a side torso is destroyed
+ option to allow mechs to be (directly) pushed off-board and out of the game
+ mech summary loading cache
+ small fix to avoid hang with network games

v 0.26.6 (07-12-02, 6:14pm)
+ clan gauss rifles explode too
+ light gauss rifles use distinct ammo, explode for less damage
+ optional victory phase
+ 535042: next target button now able to target stacked mechs
+ LOS on the line between hexes now picks 1 hex favoring the defender
+ misc AI tweaks, fix of the tt while prone
+ fix a bug that hangs the client window with mm.net

v 0.26.5 (07-05-02, 6:42pm)
+ 575448: critical hits on ammo make explosions again
+ 577153: Tooltip now clears itself on report screens and is readable on the right edge--LDE
+ 568523: Tooltip can now show multiple units' fire declarations (and other stuff) at the same time--LDE

v 0.26.4 (06-28-02, 4pm)
+ minor bot tweaks
+ 574145: gauss rifle explosion makes all critical slots count as "hit"
+ 573409: torso jump jets should work in depth 1 water
+ redid gauss explosions--all slots not destroyed, but no double explosions
+ 570487: prevent crash when an unseen (double-blind) mech dies or attacks
+ a little more safety when loading mech files
+ non-cluster LBX ammo now actually fits in LBX autocannons
+ MRMs deal damage now
+ fixed mechselector position for mcwizard

v 0.26.3 (06-21-02, 9pm)
+ bot improvements--hawkprime
+ support for (only) new version of HMPRead--spiker
+ added quad backward lateral shifts--LDE
+ 561339: switching between reverse and forward movement now resets defensive modifier--LDE
+ all mech loading routines slightly more robust
+ omnimech names handled better

v 0.26.2 (06-14-02, 5pm)
+ actually applied level 2 patch to Server.java
+ added quad lateral shifts
+ 564632: fixed typo allowing leg weapons to be fired while prone
+ 565004: now enforcing jump along shortest path rule
+ added CASE equipment
+ added fields for entity year, tech level, omni
+ MEP weapon loading works (a little) better
+ 567973: fixed small bug (Clan DHS were 1 crit, now 2)
+ 568363: movement in depth 3+ water possible again
+ fixed a different bug with minimum movement and water
+ added new bot code by Steven Hawkins <skh_mail@yahoo.com>
+ CASE now applies to BV calculation
+ XL engines factor into BV
+ seperated LBX/Ultra/AC ammo; seperated Clan/IS ammo
+ changed heat sink handling, especially double & integral

v 0.26.1 (06-07-02, 5pm)
+ added stainedglass's minimap and mech selector patches, slightly modified
+ removed river terrain type
+ 562804: DFA against destroyed target now has similar results to successful DFA
+ try to prevent annoying ConcurrentModificationExceptions during drawing
+ can't push/charge/dfa a mech already involved in one of these attacks
+ type letters to search thru list in MechSelector
+ minimap attributes saved in config file
+ spiker's level 2 patch applied (v. preliminary)
+ stainedglass's double blind patch applied
+ added large mountain boards (thx john u)
+ fixed typo not allowing retreat from southern border

v 0.26.0 (06-03-02, 12pm)
+ the words "level" & "depth" no longer display on top of each other on a hex
+ some more fixes to boards, added mountainlake

v 0.25.7 (05-30-02, 6pm)
+ properly disable flee button
+ 540326: mech elevation while mid-DFA calculated correctly
+ added color red; some tweaks to other colors
+ map tileset now included in MegaMek.cfg
+ corrected typo regarding underwater heat sinks
+ maps added in new format, some new maps (roads just cosmetic)
+ switched mechs to blk format

v 0.25.6 (05-23-02, 8:30pm)
+ 554568: fixed false secondary target modifier on first shot
+ improved recently introduced oddities with friendly fire impacting movement and bots--LDE
+ minor fixess to unlikely crit transfers--LDE
+ 555039: Extra PSRs for leg destruction corrected--LDE
+ 556214: Fixed bug allowing gyro'd quads to stand--LDE
+ Fixed bug involving ammo switching tons--LDE
+ 554933: Fixed bug preventing fire when LOS passes outside the board--LDE
+ VERSION, TIMESTAMP fields no longer final
+ non-standalone client no longer calls System.exit
+ killed some flicker associated with torso twists
+ 557858: front arc targets are primary, if possible
+ new map format

v 0.25.5 (05-10-02, 10:20am)
+ minor changes to the client & server for Helge
+ added Cord Awtry's mega-patch for quads, flipping arms, small bugfixes
+ fixed a few new clubbing bugs
+ added flags for equipment
+ fixed logic with needing a roll to stand up
+ 553907: BV of flamer is 6, not 9
+ 552182: switching back to primary target doesn't get secondary targetting mod
+ 552747: -2 target prone modifier added to physical attacks
+ 552747: can't club a prone target unless it is one level higher

v 0.25.4 (05-03-02, 8:20pm)
+ use ammo and build heat for automatic misses, none for impossible shots
+ 549900: mechs make shutdown rolls even if pilot is KO
+ 550229: attack tooltip to-hit now takes torso twisting into account
+ automatic misses now show reason (though it's always "out of range")
+ 546527: can't fire from depth 1 water while prone
+ added ant build.xml
+ megamek now prominently displays version number
+ mechs can flee during movement, provided certain conditions are met

v 0.25.3 (04-28-02, 5pm)
+ added Dima Nemchenko's patch for confirm dialogs on physical attacks
+ added Cord Awtry's patch for a next target button
+ weapons with no ammo left can't fire
+ added some new fields for use in 3050+ weapons
+ 543593: intiative rewritten to fix lockups
+ added Cord Awtry's patch for status bars on mechs
+ added game options dialog in lobby and a few options to change
+ changed next target button to use Entity.isEnemyOf
+ fixed descriptions for base physical attack to-hit
+ fixed a bug that would stop wakeup rolls under certain circumstances
+ added a picture for quads (not used yet)
+ fixed an error that occured when a mech had no operational weapons
+ hexes are now hexagonal in LOS calcs (thx Derek Evans)
+ 550576: config file read in dedicated server mode too

v 0.25.2
+ 543237: heat modifier to fire now applies at the correct levels
+ 543735: hip actuator hit halves movement, now rounded up
+ 543735: hip actuator hit piloting modifier now ignores other actuator hits
+ 543391: dead equipment is dead!  this includes jump jets!  arrgh!
+ 543737: more info shown when equipment is critically hit
+ 543645: weapons shows shots in ton and total shots left in firing display
+ 543589: shots from destroyed or already-fired weapons prevented
+ 543239: firing not prevented when out of range or to-hit 13+
+ 544122: no pushing after firing weapons from either arm
+ 543456: modal dialogs now not resizable
+ mech images are automatically rotated
+ custom mech images can be specified in data/mex/mechset.txt
+ 544496: dfa & charging to-hit uses piloting skill differential (not gunnery)
+ 545118: tree clubs work again
+ 543593: lock ups after heat phase possibly caught, not particularly fixed
+ using sun collections Random instead of equivalent custom class
+ added /roll command
+ a mech falling while between hexes now ends up in the _lower_ hex
+ fixed concurrent modification exception in board drawing routines
+ 544493: pilot can save to avoid damage in many auto-fall situations

v 0.25.1 (04-12-02, 3:30pm)
+ weapon critical hits should actually disable the weapon
+ mech display window resizable 
+ now using contents of Sun's Collections.jar
+ changed .blk loading files to be compatible with Java 1.1

v 0.25.0 (04-11-02, 10:45am)
+ moved extra weapon fire checking around in the code
+ all mech display panels now working properly in weapons phase
+ added pop-up prompt to read the documentation when using the bot
+ mech tooltip now shows movement and pilot skills
+ using latest mech pack from shrike@dropshipcommand.com

v 0.24.8 (04-10-02, 8pm)
+ fixed a bug where the server thought everybody was on the same team
+ .mtf reader now handles removed arm actuators properly
+ .mtf reader now reads MG ammo properly
+ added .blk reader from Nathan Rowden <njrkrynn@attbi.com>
  see his editor at http://mekmaker.darktech.org/
+ fixed a BV issue with half tons of MG ammo
+ mechs should no longer be able to punch from arms that have fired weapons
+ prone mechs should not be able to take one step forward
+ heat sink and jump jet criticals display properly
+ .mtf reader reads AC/2s properly
+ weapons on sections that are destroyed are again counted as destroyed
+ unified equiment (weapons/ammo/misc) in the code more
+ changed a few functions dealing with equipment/criticals
+ code now has more checks to prevent double weapons fire
+ ammo explosion damage applied to only the internals of a mech (lethal!)
+ packets are GZIPped before sending.  any faster?  slower?

v 0.25.7 (04-08-02, 9pm)
+ hitting esc or next unit after a torso twist now cancels the torso twist
+ 537226: intact mechs with dead pilots are now removed from the map
+ locations can't be destroyed twice (preventing falls from destroyed leg hits)
+ skip button works in firing phase
+ 538581: charge/dfa on a destroyed target no longer locks game
+ 536097: mechs need both arms in order to fire while prone.  (dumb rule)
+ numbers for starting position replaced by compass diresctions
+ teams selection added
+ mech loading code handles .mtf files from "hmpread" now
+ some changes to the mech display panels
+ -testdice command line option prints RNG test info
+ -dedicated command line option starts dedicated server using last settings
+ removed dedicated server button, in favor of the command line option

v 0.24.6 (04-07-02, 1:18pm)
+ refined command interface.  type "/help" for a list.
+ removed unused terrain types
+ players can reconnect to a game that they've left
+ changed how weapons, equipment and ammo are stored on a mech
+ moved jump jets & heat sinks into "equipment" from "systems"
+ hatchets load properly
+ hatchet attacks work
+ window close buttons close dialogs
+ changed button layout (again)... let's get the new buttons working!
+ inserted Derek Evans's fix for LOS floating-point precision errors
+ turn & torso twist buttons working
+ picking up tree clubs possible
+ /kick command added
+ server name changed to server password; used for /reset, /kick
+ server only sends entity add/delete packets in lounge, not entire list

v 0.24.5 (03-30-02, 3pm)
+ "esc" clears fire even when focus is not on the map
+ 536097: prone mechs are at the terrain elevation for LOS, not 1 higher
+ hex graphics brighter, flatter, renamed; added reddish sinkhole hexes
+ some changes & fixes to maps
+ 536104: attacker being prone now cancels charge instead of auto-misses
+ fixed a bug where a mech would fail to get up but move anyhow
+ fixed a bug where a leg destroyed critical would not cause a mech to fall
+ added MegaMek.cfg option to set map text color
+ map selector now handles custom boards
+ experimental ai client from Michael Hanson
+ some commands for the server (documentation to come)
+ basic server log to serverlog.txt (windows users, open with wordpad)

v 0.24.4 (03-27-02, 10:20pm)
+ 534490: hitting back up should not clear movement if you are not jumping
+ fixed some display glitches with movement paths
+ torso twisting doesn't rotate leg firing arcs (thx Niels Naumann)
+ leg weapons are blocked by terrain that gives attacker partial cover
+ fixed another bug with transfer damage
+ players can join the game at any time, to watch
+ 534820: mechs with 0 MP don't get the minimum 1 step movement rule applied
+ board editor working with new boardview
+ pilot skills displayed in lobby instead of just "(custom)"
+ map selection

v 0.24.3 (03-24-02, 9:30pm) 
+ 532083: transfer damage no longer counts double towards damage this phase
+ prone mechs can make facing changes at the normal cost
+ 531143: prone mechs can't make torso twists
+ impossible shots now show reason instead of 2147483647
+ 532908: fire button no longer enabled when it shouldn't be, AFAIK
+ 532066: limb destruction should not prevent physical attacks in the same phase
+ 532073: criticals should no longer transfer incorrectly
+ pilot damage resulting from falling during fire phase resolved immediately
+ connection class seperated from server class
+ connections send packets on a seperate thread

v 0.24.2 (03-20-02, 10pm)
+ .mep files load weapons with no space between "(R)" and the weapon name now
+ 532302: DFA causing target to be displaced from wrong coordinates
+ new distance formula by John Uckele (buggy?)
+ 532077: mechs making DFA no longer make landing PSRs during movement (thx bdee)
+ 532079: secondary target modifiers applied
+ 531688: now can't fire weapons from both arms while prone
- significantly changed how rear locations and weapons work:
+ weapons can now be rear-mounted anywhere legal (head, legs)
+ 532068: rear limb hits now transfer to rear torso locations (thx bdee)
+ 531825: initiative now sorts ties correctly

v 0.24.1 (03-17-02, 11pm)
+ changed RNG routine to avoid very unlikely chance of rounding errors (:-P)
+ fixed bug causing pilot consciousness checks to never be made
+ mechwarrior name/skill customization
+ mechwarrior gunnery/piloting skill factored into BV
+ factored piloting skill differential into charging/dfa to-hit
+ fixed a bug causing weapons fire tooltips not to display sometimes
+ even more mechs! (thanks Shrike@dropshipcommand.com again)

v 0.24.0 (03-18-02, 12:30pm)
+ mechs making a dfa attack can't be physically attacked
+ prone mechs automatically miss charging and DFA attacks
+ falling damage for mechs doing DFA is saved until they miss the DFA
+ invalid domino effect prevented
+ mechs making DFA attacks don't get the benefit of terrain modifiers
+ fixed bug with making too many consciousness rolls
+ mechs with 1 MP are allowed to get up
+ mechs with at least 1 MP can take 1 step forward, regardless of terrain cost
+ more notification about criticals due to "2" hit location
+ added a bunch more mechs (thx Jeff Biron)

v 0.23.6 (03-17-02, 8:15pm)
+ center on unit works in new display
+ new display works when screen is bigger than board
+ highlight border appears under mech instead of on top (subtle)
+ initiative ties rolled off (up to 5 times--sort of a hack)
+ edges cleared in new display
+ charging attacker takes damage on normal front table
+ death from above implemented
+ movement path display redone to reduce memory thrashing
+ some error boxes for errors reading mepfiles
+ pilot consciousness checks made before piloting skill rolls

v 0.23.5 (03-14-02, 6pm)
+ charge flag reset properly
+ crash bug fixed in getMissedChargeDisplacement
+ can't charge charging mechs anymore
+ charge error messages a little better, maybe
+ "2" on rear table now results in CTR (critical) hit, not CT (thx bob dee)
+ falling in water is only half damage
+ tooltips work better
+ successful charge always results in PSR for attacker and target
+ pilot roll to avoid damage is +1/level fallen, not just always +1

v 0.23.4 (03-14-02, 12pm)
+ charging
+ mechs can't fire in depth 2+ water
+ each starting position can handle many more mechs now
+ some client-side changes to try to prevent duplicate "readies"
+ rear side torso damage transfers to rear center torso (thx dave fanjoy)
+ rear armor destroyed when section destroyed (thx dave fanjoy again)
+ internal structure displays as "N/A" on rear locations
+ base punch damage rounded up, not down (thx Robert J Chverchko)

v 0.23.3 (03-12-02, 1:30am)
+ slightly better dialogs
+ now counting upper leg crits for piloting roll purposes (thx jerrymeander)
+ now applying immobile modifier to unconcious pilots (jerrymeander again)
+ fixed a keyboard problem on the Mac (thx Michael Flynn)
+ keyboard scrolling in new board display

v 0.23.2 (03-06-02, 10pm)
+ fast-drawin' cursors
+ image filters for tint, transparency (slower?)
+ movement now showing on new board
+ new scrolling cache system
++ buggy LOS back to normal levels of buggyness
+ player name in title bar
+ tooltips for entities include armor & internals
+ tooltips for attacks show weapons used
+ section destruction more noticible
+ both arms needed for pushing
+ to-hit rolls lower than 0 handled
++ fixed a bug where an entity facing north & falling forwards caused a crash

v 0.23.1 (03-04-02, 4:48pm)
+ new board display stuff
+ tooltips on board, mechs, attacks

v 0.23.0 (03-02-02, 6:30pm)
+ falling does damage again (oops)
+ changed torso twisting a little
+ initiative working again
+ changed the way players and entities are stored in the game
+ player changes (such as starting position) properly update again
+ "immobile" centered on mech icon, when displayed
+ falling accounts for elevation
+ falling while moving handled more correctly
+ new intervening formula from (http://www-cs-students.stanford.edu/~amitp/gameprog.html)
+ pushing & resulting effects implemented
+ you may choose to display either BV or tonnage in the lounge
+ invalid filenames in the mech loading routine handled

v 0.22.3 (02-21-02, 12pm)
+ connections handled differently on the server
+ units moving backwards can't change elevation levels
+ players that disconnect with active entities become "ghosts"
+ mechs now only punch with available arms instead of always both
+ players disconnecting in the lounge get all their entities removed
+ client now pops up a dialog and quits upon disconnection

v 0.22.2 (02-18-02, 11:30pm)
+ targets prone in depth 1 water can't be hit
+ sensors critical hit means a +2 to weapons fire, not +1 (oops)
+ can't shoot arm-mounted weapons while prone and opposite arm destroyed
+ critical hits more noticable in report
+ in lounge, changing starting pos no longer resets BV
+ cleaned up some equals methods
+ refactored stuff dealing with piloting skill rolls
+ mepfiles: lower arm & hand actuators properly removed (victor loads now)
+ underwater heat sinks work twice as much
- extra heat capacity due to underwater heat sinks doesn't show up on display
+ shut down mechs gain no extra heat from engine criticals
+ fixed a bug which caused critical hits to self-heal sometimes
+ all critical hits in destroyed location are considered hit
+ mechwarrior effects from broken life support
+ criticals transfer from empty locations
+ running or jumping with damaged gyro or certain actuators now needs a roll

v 0.22.1 (02-17-02, 9pm)
+ an automatic fall no longer results in the pilot automatically avoiding damage
+ most common stacking violations prevented
+ rough terrain doesn't actually need a piloting roll (oops)
+ engines & gyros taking more than one hit in the same turn are properly destroyed
+ mep files parse heat sinks & jump jets properly
+ changed a few function names dealing with critical slots
+ now displays "immobile" for shut down or pilot unconcious
+ will now skip the movement phase if nobody can act
+ destroyed jump jets reduce jump movement
+ destroyed heat sinks reduce capacity
+ heat capacity shown on mech display
+ hitting "get up" then "move" works now
+ empty weapons try to reload "on the fly"

v 0.22.0 (02-16-02, 7pm)
+ torso twisting now turns in the correct direction
+ any button except button1 does not select hexes (so you can scroll)
- movement arrows dissappear when scrolled off the screen
+ turn order recalculated every phase for eligible entities
+ now, once again, factors in target movement (oops)
+ physical attacks skipped for entities that can't use them
- units should actually count in the action queue, but be skipped on their turns
+ internal setting "friendly fire" off if more than one player in the game

v 0.21.5 (02-16-02, 12pm)
+ weapons stored differently; may reduce network traffic
+ report at end of movement/firing if necessary

v 0.21.4 (02-13-02, 4pm)
+ kicks do normal kick damage now
+ engine hit heat added in a way that you can see
+ fixed a torso twisting bug introduced in the last version
+ no running backwards
+ some movement requires a piloting skill roll
+ display differences for movement needing a piloting skill roll
+ jump jets don't work in water
- all jump jets don't work, not just the ones underwater (ugh)
+ getting up revised, but you still can't get up except as your first move
+ many of the standard piloting skill rolls during movement now
+ turning is free after getting up
+ can't jump over too-high terrain (poor urbanmechs)
+ missing actuators figure into punches and kicks
+ BoardView crashes with null entities possibly fixed

v 0.21.3 (02-12-02, 6:22pm)
+ can't fire at underwater units
+ punching & kicking account for prone/elevation changes
+ status bar during physical attacks says "physical attacks" now
+ can't do physical attacks while prone
+ fixed text bug in targetting modifiers
+ walking/jumping back to normal levels of brokenness
+ moving somewhat re-done internally
- backup/getup not working
- server may allow certain types of illegal movement (stacking)

v 0.21.2 (02-11-02, 3pm)
+ punching supported
+ just about everything that has to do with hitting re-written or modified
+ button placement changes in the gui
+ kicking supported
- regression: getting up, jumping, backwards movement is broken

v 0.21.1 (02-07-02, 11:43am)
+ pilots can wake up from unconciousness
+ starting position selection (on any 8 primary/secondary compass directions)

v 0.21.0 (01-27-02, 10:30pm)
+ fixed movement heat costs
+ ammo exploding doesn't empty the bin until the end of the turn
+ mepfiles: 1/2 ton MG ammo parsed
+ mepfiles: flamers (damage only) added
+ mepfiles: rear facing weapons parsed
+ rear facing weapons working (torsos only)
+ initiative phase just displays the report, which has initiative info now
+ dead entities aren't sent out every phase (just kept on server)
+ game rounds counted & displayed at the top of the report

v 0.20.5 (01-27-02, 12pm)
+ fixed a bug where mechs destroyed did't stay dead (yikes!)
+ fixed a bug causing turns to go to players without active mechs
+ fixed a bug causing shutdown mechs not to be displayed
+ changed how crew conditions are handled internally
+ leg destruction now results in a piloting skill check
+ server now uses game player data instead of its own
+ player objects are now aware of their own id
+ changed how client handles connects/disconnects
+ changed how server handles players internally
+ entities are now aware of their id numbers and act accordingly
+ changed how selected weapons & pending fire are handled internally
++ AAARGH!! fixed another bug with torso twisting, hopefully the last
+ mech display kept by client

v 0.20.4 (01-26-02, 6:30pm)
+ fixed a bug with keyboard listeners lingering

v 0.20.3 (01-26-02, 6pm)
+ torso twisting hopefully fixed
+ different random number routine accessed

v 0.20.2 (01-26-02, 11:30am)
+ changed how certain mech status conditions (destroyed, prone) were
  handled internally
+ testing release to track down why torso twists sometimes fail

v 0.20.1 (01-25-02, 1pm)
+ added some more maps, mechs

v 0.20.0 (01-23-02, 10:40pm)
+ fixed a bug in the new network code (thread synchronization issues)
+ added interface for modifying board layout parameters
+ added "delete mech button"
+ if mechs or board layout changes in the lounge, all players are unreadied
+ you can no longer start the game without a mech
+ calculating battle value
+ fixed a .mep parsing bug with armor
+ display total BV for player during startup
+ auto-center on active mech working again
+ color selection working again
+ fixed a bug in initiative where only one player had to click "ready"

v 0.19.3 (01-21-02, 9:30pm)
+ re-did network communication to use java object serialization exclusively
+ mapsheet combiner working
+ new map format!  tile based
+ editor works with new map format
- saving doesn't really work with new map format yet

v 0.19.2 (01-16-02, 9:30am)
+ seperated code into packages: server, client & common
+ all data in data folder
+ removed several unused data from board file (reducing size by about 1/4)
+ seperation of board, game and client.  only one attricious hack needed, too!
+ at some point, jumping got broken.  fixed it.

v 0.19.1 (01-12-02, 11pm)
+ chat area now doesn't go to the top every phase change (yay!)
+ fixed a bug that was giving 10 extra heatsinks to loaded mechs
+ fixed a number format bug in mech loading: stalker loads now
+ code: renamed "Game" to "Client" and "GameServer" to "Server"

v 0.19.0 (01-12-02, 9:30pm)
+ remade initiative and lounge screens
+ lounge screen now allows loading of mechs
+ all 3025 weapons & ammo except flamers
+ mechs deploy around a point instead of at fixed points
+ code: "location" (and associated) in Entity replaced with "position"
+ editor: making a new map resets save name
+ editor: default board size is now 16x17
+ more maps & tiles added

v 0.18.0 (01-09-02, 2am)
+ weapon attacks held client-side and sent in a bunch
+ torso twisting
+ ammo tracking
+ ammo auto-reloads if more is availiable
+ fixed number of leg critical slots (now 6)
+ ammo explosions from critical hits and heat

v 0.17.0 (12-01-01, 1:49am)
+ some settings saved (yay!)
+ walking backwards

v 0.16.7 (10-20-01, 1pm)
+ falling
+ falling from actuator hits
+ falling from 20+ damage
+ pilot damage due to falling
+ piloting skill rolls

v 0.16.1
+ mechs have pilots now, and the pilots can take damage
+ fixed a bug not allowing you to jump over enemy mechs

v 0.16.0 (09-06-01, 1pm)
+ fixed board edges in new graphics engine
+ editor enabled
+ added jumping support
+ test scenario: spider vs. urbanmech

v 0.15.5 (08-20-01, 8:22pm)
++ new graphics engine (sorry, it's slower) should allow almost unlimited board size
+ criticals on rear torso locations now resolve properly against the main torso
+ added the rest of the missile hit tables in (oops!)

v 0.15.4 (08-19-01, 9:39pm)
+ fixed an infinite damage loop bug
+ firing lines clear properly
+ added more effects of system criticals
+ limb blown off criticals work
+ fixed a bug with partial cover not being assigned
+ reworked the damage loop so that hit locations 2 should actually critical
+ people with no mechs don't have to click okay


v 0.15.3 (08-19-01, 1:46am)
+ fixed a bug with player color selection

v 0.15.2 (08-19-01, 1:11am)
+ image tint cache
+ lines to show fire
+ critical hits to weapons & systems (no system effects)
+ changes to damage readout

v 0.15.1 (08-17-01, 12:40am)
+ removed the stalker from the default mechs
+ new rangefinder formula ( http://www.rossmack.com/ab/RPG/traveller/AstroHexDistance.asp )

v 0.15.0 (08-16-01, 11pm)
+ logic to stop people from selecting the same color
+ 4 different starting positions on the default board
+ clears target when using "next unit" button
+ centers current unit in map view area
+ missile damage displays as "missile" on the weapon list
+ arms destroyed when torso is destroyed
+ fixed some errors in keyboard handling
+++ partial intervening terrain & LOS added (splines handled badly)
+ dead mechs should be dissapearing better
+ should be no empty line at the bottom of chat text
+ ready/moved/shutdown mechs display slightly differently
+ mech display is movable window
+ fixed movement data font changing
+ deselect hex at end of turn
+ attacker terrain
+ defender terrain

v 0.14.2 (08-09-01) 6:49pm
+ partially fixed initiative
+ next mech button
+ medium mech graphics added
+ colors changed to pastelly stuff

v 0.14.1
+ fixed a range finding bug
+ overhead pictures of mechs, tinted to the player color

v 0.14 (8-08-01)
+ disable weapons in destroyed sections
+ some stacking violations prevented
+ fixed bug with rear torso internal structure
+ destroyed mechs don't show up on the map any more

v 0.13.3 (8-07-01, 12:25am)
+ don't target destroyed mechs
+ don't resolve fire against destroyed mechs
+ target immobile modifierx

v 0.13.2 (8-06-01, 3:30pm)
+ bug fixed with missile damage display
+ added target arcs
+ better turn status messages
+ heat buildup should not resolve until the end of the turn
+ heat shutdown & startup effects
+ rotate w/o moving (shift click in movement)


v 0.13.1 (8-06-01, 1:00am)
+ added weapon arcs
+ added missiles and missile damage resolution

v 0.13 (8-04-01, 4:14pm)
+ fixed initiative bug with uneven sides
+ added heat

v 0.12.1 (8-01-01, 12:50am)
+ can't fire at invalid target/out of range

v 0.12 (7-31-01)
+ damage
+ hit location tables
+ end of turn report

v 0.11 (7-24-01)
+ more firing
+ some cursor stuff

v 0.10 (7-08-01)
+ firing phase

v 0.09 (2-20-01, 10:31pm)
+ initiative phase
+ more movement overhauls

v 0.081 (2-13-01, 5:10pm)
+ lazy ground pathfinder
  - bug: allows running into water
  - generally unintelligent path choices
+ displays movement on map
+ server forbids moving too far

v 0.080
+ redraws the sides when the screen area is larger than the board
+ preliminary display of mechs on the map
+ preliminary mech movement

v 0.076 (02-09-01, 12:02am)
+ preliminary game phase progression

v 0.075
+ buffered map reading.  now about twice as fast!
+ fixed: sometimes not all the tile pictures will load when 
you load a map, or they'll load halfway.
+ fixed: when you change the elevation in the editor, the 
little picture in the corner doesn't change
+ testing fog in the editor: press "f" to toggle

v 0.073 (02-06-01, 10:50pm)
+ player list in chat
+ player ready button in chat

v 0.071
+ resized the tiles to 84 * 72 pixels
+ redrew the "boring" tileset to match

v 0.07
+ main menu!
+ added some multiplayer host/connection support

Version 0.063
+ fixed: in the editor, clicking on a new tile while holding 
CTRL won't paint that tile, but releasing and then tapping CTRL
will.
+ fixed a bug in showing elevation changes while editing boards
+ CTRL is now the paintbrush and ALT is the eyedropper in the 
editor
+ internal difference between dragging and selecting a hex.

Version 0.062 (02-05-01, 3:40pm)
+ tiles have borders to represent elevation changes

Version 0.061 (02-05-01, 3:40pm)
+ fixed a small bug loading terrain tiles with underscores

version 0.06
+ saving and loading of maps
+ slightly more intuitive new map starting

versions before 0.06 
+ i dunno


